Package: waveslim
Version: 1.8.5
Date: 2024-06-02
Title: Basic Wavelet Routines for One-, Two-, and Three-Dimensional
        Signal Processing
Author: Brandon Whitcher
Maintainer: Brandon Whitcher <bwhitcher@gmail.com>
Depends: R (>= 2.11.0), graphics, grDevices, stats, utils, multitaper
Suggests: fftw, covr
Description: Basic wavelet routines for time series (1D), image (2D) and array 
  (3D) analysis.  The code provided here is based on wavelet methodology 
  developed in Percival and Walden (2000); Gencay, Selcuk and Whitcher (2001); 
  the dual-tree complex wavelet transform (DTCWT) from Kingsbury (1999, 2001) as
  implemented by Selesnick; and Hilbert wavelet pairs (Selesnick 2001, 2002).  
  All figures in chapters 4-7 of GSW (2001) are reproducible using this package 
  and R code available at the book website(s) below.
License: BSD_3_clause + file LICENSE
URL: https://waveslim.blogspot.com
RoxygenNote: 7.3.1
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2024-06-03 18:31:59 UTC; brandon
Repository: CRAN
Date/Publication: 2024-06-04 13:20:03 UTC

# waveslim

![Travis-CI Build Status](https://travis-ci.org/bjw34032/waveslim.svg?branch=master)
![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/waveslim)
![CRAN Downloads Badge](http://cranlogs.r-pkg.org/badges/grand-total/waveslim)
![CRAN Downloads Badge](http://cranlogs.r-pkg.org/badges/waveslim)

The R packages **waveslim** contains basic wavelet routines for time series (1D), image (2D) and array (3D) analysis. The code provided is based on wavelet methodology developed in 

* Percival and Walden (2000)
* Gencay, Selcuk and Whitcher (2001)
* the dual-tree complex wavelet transform (CWT) from Kingsbury (1999, 2001) as implemented by Selesnick, and 
* Hilbert wavelet pairs (Selesnick 2001, 2002)

# waveslim

The R packages **waveslim** contains basic wavelet routines for time series (1D), image (2D) and array (3D) analysis. The code provided here is based on wavelet methodology developed in Percival and Walden (2000); Gencay, Selcuk and Whitcher (2001); the dual-tree complex wavelet transform (CWT) from Kingsbury (1999, 2001) as implemented by Selesnick; and Hilbert wavelet pairs (Selesnick 2001, 2002).

Travis-CI build for bjw34032/waveslim

[![Travis-CI Build Status](https://travis-ci.org/bjw34032/waveslim.svg?branch=master)](https://travis-ci.org/bjw34032/waveslim)

[![CRAN_Status_Badge](http://www.r-pkg.org/badges/version/waveslim/)](https://CRAN.R-project.org/package=waveslim)
[![](http://cranlogs.r-pkg.org/badges/grand-total/waveslim)](https://CRAN.R-project.org/package=waveslim)

#' Generate Stationary Gaussian Process Using Hosking's Method
#' 
#' Uses exact time-domain method from Hosking (1984) to generate a simulated
#' time series from a specified autocovariance sequence.
#' 
#' 
#' @param n Length of series.
#' @param acvs Autocovariance sequence of series with which to generate, must
#' be of length at least \code{n}.
#' @return Length \code{n} time series from true autocovariance sequence
#' \code{acvs}.
#' @author B. Whitcher
#' @references Hosking, J. R. M. (1984) Modeling persistence in hydrological
#' time series using fractional differencing, \emph{Water Resources Research},
#' \bold{20}, No. 12, 1898-1908.
#' 
#' Percival, D. B. (1992) Simulating Gaussian random processes with specified
#' spectra, \emph{Computing Science and Statistics}, \bold{22}, 534-538.
#' @keywords ts
#' @examples
#' 
#' dB <- function(x) 10 * log10(x)
#' per <- function (z) {
#'   n <- length(z)
#'   (Mod(fft(z))^2/(2 * pi * n))[1:(n%/%2 + 1)]
#' }
#' spp.sdf <- function(freq, delta, omega)
#'   abs(2 * (cos(2*pi*freq) - cos(2*pi*omega)))^(-2*delta)
#' data(acvs.andel8)
#' n <- 1024
#' \dontrun{
#' z <- hosking.sim(n, acvs.andel8[,2])
#' per.z <- 2 * pi * per(z)
#' par(mfrow=c(2,1), las=1)
#' plot.ts(z, ylab="", main="Realization of a Seasonal Long-Memory Process")
#' plot(0:(n/2)/n, dB(per.z), type="l", xlab="Frequency", ylab="dB",
#'      main="Periodogram")
#' lines(0:(n/2)/n, dB(spp.sdf(0:(n/2)/n, .4, 1/12)), col=2)
#' }
#' 
#' @export hosking.sim
hosking.sim <- function(n, acvs) {
  .C(C_hosking, tseries=rnorm(n), as.integer(n), as.double(acvs[1:n]))$tseries
}

#' Wavelet Shrinkage via Thresholding
#' 
#' Perform wavelet shrinkage using data-analytic, hybrid SURE, manual, SURE, or
#' universal thresholding.
#' 
#' An extensive amount of literature has been written on wavelet shrinkage.
#' The functions here represent the most basic approaches to the problem of
#' nonparametric function estimation.  See the references for further
#' information.
#' 
#' @usage da.thresh(wc, alpha = .05, max.level = 4, verbose = FALSE, return.thresh = FALSE)
#' @usage hybrid.thresh(wc, max.level = 4, verbose = FALSE, seed = 0)
#' @usage manual.thresh(wc, max.level = 4, value, hard = TRUE)
#' @usage sure.thresh(wc, max.level = 4, hard = TRUE)
#' @usage universal.thresh(wc, max.level = 4, hard = TRUE)
#' @usage universal.thresh.modwt(wc, max.level = 4, hard = TRUE)
#' @aliases Thresholding da.thresh hybrid.thresh manual.thresh sure.thresh
#' universal.thresh universal.thresh.modwt bishrink soft
#' @param wc wavelet coefficients
#' @param alpha level of the hypothesis tests
#' @param max.level maximum level of coefficients to be affected by threshold
#' @param verbose if \code{verbose=TRUE} then information is printed to the
#' screen
#' @param value threshold value (only utilized in \code{manual.thresh})
#' @param hard Boolean value, if \code{hard=F} then soft thresholding is used
#' @param seed sets random seed (only utilized in \code{hybrid.thresh})
#' @param return.thresh if \code{return.thresh=TRUE} then the vector of
#' threshold values is returned, otherwise the surviving wavelet coefficients
#' are returned
#' @return The default output is a list structure, the same length as was
#' input, containing only those wavelet coefficients surviving the threshold.
#' @author B. Whitcher (some code taken from R. Todd Ogden)
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Ogden, R. T. (1996) \emph{Essential Wavelets for Statistical Applications
#' and Data Analysis}, Birkhauser.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' 
#' Vidakovic, B. (1999) \emph{Statistical Modeling by Wavelets}, John Wiley and
#' Sons.
#' @keywords ts
manual.thresh <- function(wc, max.level=4, value, hard=TRUE)
{
  wc.fine <- wc[["d1"]]
  factor <- median(abs(wc.fine)) / .6745

  wc.shrink <- wc

  if(hard) {
    # Hard thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * value
      wc.shrink[[i]] <- wci * (abs(wci) > unithresh)
    }
  }
  else {
    # Soft thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * value
      wc.shrink[[i]] <- sign(wci) * (abs(wci) - unithresh) * 
        (abs(wci) > unithresh)
    }
  }
  wc.shrink
}

universal.thresh <- function(wc, max.level=4, hard=TRUE)
{
  n <- length(idwt(wc))

  wc.fine <- wc[["d1"]]
  factor <- median(abs(wc.fine)) / .6745

  wc.shrink <- wc

  if(hard) {
    # Hard thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * sqrt(2 * log(n))
      wc.shrink[[i]] <- wci * (abs(wci) > unithresh)
    }
  }
  else {
    # Soft thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * sqrt(2 * log(n))
      wc.shrink[[i]] <- sign(wci) * (abs(wci) - unithresh) *
        (abs(wci) > unithresh)
    }
  }
  wc.shrink
}

universal.thresh.modwt <- function(wc, max.level=4, hard=TRUE)
{
  n <- length(wc[[1]])
  wc.fine <- wc[["d1"]]
  factor <- sqrt(2) * median(abs(wc.fine)) / .6745
  wc.shrink <- wc
  j <- 1
  if(hard) {
    ## Hard thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * sqrt(2 * log(n)) / 2^(j/2)
      wc.shrink[[i]] <- wci * (abs(wci) > unithresh)
      j <- j+1
    }
  }
  else {
    ## Soft thresholding
    for(i in names(wc)[1:max.level]) {
      wci <- wc[[i]]
      unithresh <- factor * sqrt(2 * log(n)) / 2^(j/2)
      wc.shrink[[i]] <- sign(wci) * (abs(wci) - unithresh) *
        (abs(wci) > unithresh)
      j <- j+1
    }
  }
  wc.shrink
}

sure.thresh <- function(wc, max.level=4, hard=TRUE)
{
  wc.shrink <- wc

  sure <- function(t, x) {
    ax <- sort(abs(x))    
    num <- match(FALSE, ax <= t, nomatch = length(ax) + 1) - 1
    length(ax) - 2 * num + sum(pmin(ax, t)^2)
  }

  for(i in names(wc)[1:max.level]) {
    wci <- wc[[i]]
    ni <- length(wci)
    factor <- median(abs(wci)) / .6745
    xi <- wci / factor
    sxi <- sort(abs(xi))^2
    s <- cumsum(sxi) + ((ni - 1):0) * sxi
    risk <- (ni - (2 * (1:ni)) + s) / ni
    surethresh <- sqrt(sxi[order(risk)[1]])
    if(hard) {
      ## Hard thresholding
      wc.shrink[[i]] <- wci * (abs(xi) > surethresh)
    }
    else {
      ## Soft thresholding
      wc.shrink[[i]] <- sign(wci) * (abs(wci) - factor*surethresh) *
        (abs(xi) > surethresh)
    }
  }
  return(wc.shrink)
}

hybrid.thresh <- function(wc, max.level = 4, verbose = FALSE, seed = 0)
{
  shrinkit <- function(coeffs, thresh)
    sign(coeffs) * pmax(abs(coeffs) - thresh, 0)

  sure <- function(t, x) {
    ax <- sort(abs(x))    
    num <- match(FALSE, ax <= t, nomatch = length(ax) + 1) - 1
    length(ax) - 2 * num + sum(pmin(ax, t)^2)
  }

  wc.shrink <- wc
  n <- length(unlist(wc))
  nlev <- log(n + 1, 2) - 1
  i <- 1
  iloc <- 1
  while(i <= max.level) {
    ## Extract current level coefficients from all wavelet coefficients
    raw <- wc[[names(wc)[i]]]
    d <- length(raw)
    ## Test:  if the variance is small enough, just use threshold sqrt(2logd)
    if((sum(raw^2) - d)/d <= sqrt(i^3/2^i)) {
      if(verbose)
        cat(paste("At level ", i, " the threshhold is sqrt(2log(d)): ", 
                  sqrt(2 * log(d)), "\n", sep = ""))
      wc.shrink[[names(wc)[i]]] <- shrinkit(wc[[names(wc)[i]]], sqrt(2*log(d)))
    }
      else {
        ## Generate random subset
        if(length(seed) != 1)
          .Random.seed <- seed
        Iset <- sort(sample(d, d/2))
        rawI <- raw[Iset] / (median(abs(raw[Iset])) / .6745)
        rawIp <- raw[ - Iset] / (median(abs(raw[ - Iset])) / .6745)
        ggI <- sort(abs(rawI))
        ggIp <- sort(abs(rawIp))        
        ## Calculate SURE for all possible thresholds
        surevecI <- sapply(c(ggI[ggI < sqrt(2 * log(d))], 0,
                             sqrt(2 * log(d))), sure, ggI)
        surevecIp <- sapply(c(ggIp[ggI < sqrt(2 * log(d))], 0, 
                              sqrt(2 * log(d))), sure, ggIp)    
        ## Threshold that minimizes risk
        llI <- length(surevecI)
        llIp <- length(surevecIp)       
        ## The minimum occurs either at sqrt(2logd), 
        if(min(surevecI) == surevecI[llI])
          threshI <- sqrt(2 * log(d))
        else if(min(surevecI) == surevecI[llI - 1])
          threshI <- 0
        else threshI <- ggI[match(min(surevecI), surevecI)]     
        ## or at 0, 
        if(min(surevecIp) == surevecIp[llIp])
          threshIp <- sqrt(2 * log(d))
        else if(min(surevecIp) == surevecI[llIp - 1])
          threshIp <- 0
        else
          threshIp <- ggIp[match(min(surevecIp), surevecIp)]
        ## or at 0, 
        if(verbose) {
          cat(paste("At level ", i, ", threshold1 is ", threshI, "\n",
                    sep = ""))
          cat(paste("At level ", i, ", threshold2 is ", threshIp,
                    "\n", sep = ""))
        }
        ## Perform shrinking
        newI <- shrinkit(rawI, threshIp)
        newIp <- shrinkit(rawIp, threshI)
        new <- rep(0, d)
        new[Iset] <- newI
        new[ - Iset] <- newIp
        wc.shrink[[names(wc)[i]]] <- new
      }
    ## Otherwise, go through all this stuff
    iloc <- iloc + 2^i
    i <- i + 1
  }
  wc.shrink
}

da.thresh <- function(wc, alpha=.05, max.level=4, verbose=FALSE,
                      return.thresh=FALSE) {
  onebyone2 <- function(dat, alpha) {
    kolsmi.chi2 <- function(dat) {
      n <- length(dat)
      return(max(abs(cumsum(dat)-(1:n)*sum(dat)/n))/sqrt(2*n))
    }
    crit <- c(seq(0.28,1.49,by=.01), seq(1.50,2.48,by=.02))
    alph <- c(.999999,.999996,.999991,.999979,.999954,.999909,.999829,
              .999697,.999489,.999174,.998715,.998071,.997192,.996028,
              .994524,.992623,.990270,.987410,.983995,.979978,.975318,
              .969983,.963945,.957186,.949694,.941466,.932503,.922817,
              .912423,.901344,.889605,.877240,.864282,.850771,.836775,
              .822247,.807323,.792013,.776363,.760418,.744220,.727811,
              .711235,.694529,.677735,.660887,.644019,.627167,.610360,
              .593628,.576998,.560495,.544143,.527959,.511970,.496192,
              .480634,.465318,.450256,.435454,.420930,.406684,.392730,
              .379072,.365714,.352662,.339918,.327484,.315364,.303556,
              .292060,.280874,.270000,.259434,.249174,.239220,.229566,
              .220206,.211140,.202364,.193872,.185658,.177718,.170050,
              .162644,.155498,.148606,.141962,.135558,.129388,.123452,
              .117742,.112250,.106970,.101896,.097028,.092352,.087868,
              .083568,.079444,.075495,.071712,.068092,.064630,.061318,
              .058152,.055128,.052244,.049488,.046858,.044350,.041960,
              .039682,.037514,.035448,.033484,.031618,.029842,.028154,
              .026552,.025030,.023588,.022218,.019690,.017422,.015390,
              .013574,.011952,.010508,.009223,.008083,.007072,.006177,
              .005388,.004691,.004078,.003540,.003068,.002654,.002293,
              .001977,.001703,.001464,.001256,.001076,.000921,.000787,
              .000671,.000572,.000484,.000412,.000350,.000295,.000250,
              .000210,.000178,.000148,.000126,.000104,.000088,.000074,
              .000060,.000051,.000042,.000035,.000030,.000024,.000020,
              .000016,.000013,.000011,.000009)
    if(alpha < min(alph) || alpha > max(alph))
      stop("alpha =",alpha,"is out of range")
    ind <- match(TRUE, alpha > alph)
    critval <- crit[ind-1]+(alph[ind-1]-alpha)*(crit[ind]-crit[ind-1]) / 
      (alph[ind-1]-alph[ind])
    i <- length(dat)
    cc <- kolsmi.chi2(dat)
    while(cc[length(cc)] > critval && i > 1) {
      i <- i-1
      cc <- c(cc,kolsmi.chi2(dat[sort(order(dat)[1:i])]))
    }
    return(cc)
  }
  getthrda2 <- function(dat, alpha) {
    a <- onebyone2(dat, alpha)
    if(length(a) == length(dat))
      if(1 - pchisq(min(dat),1) < alpha)
        ggg <- 0
      else
        ggg <- sqrt(min(dat))
    else
      ggg <- sqrt(max(dat[sort(order(dat)[1:(length(dat)-length(a)+1)])]))
    return(ggg)
  }
  shrinkit <- function(coeffs, thresh)
    sign(coeffs) * pmax(abs(coeffs) - thresh, 0)

  if(alpha <= .000009 || alpha >= .999999)
    stop("alpha out of range")
  ans <- wc
  n <- length(unlist(wc))
  nlev <- log(n+1, 2)-1
  i <- 1
  iloc <- 1
  while(i <= max.level) {
    gg <- wc[[names(wc)[i]]]
    thresh <- getthrda2(gg^2,alpha)
    if(verbose)
      cat(paste("At level ",i,", the threshold is ",thresh, "\n",sep=""))
    if(return.thresh)
      if(i == nlev)
        rt <- thresh
      else
        rt <- c(thresh, rt)
    else
      ans[[names(wc)[i]]] <- shrinkit(wc[[names(wc)[i]]], thresh)
    iloc <- iloc + 2^i
    i <- i+1
  }
  if(return.thresh)
    return(rt)
  else
    return(ans)
}

#' Two-Dimensional Discrete Wavelet Transform
#' 
#' Performs a separable two-dimensional discrete wavelet transform (DWT) on a
#' matrix of dyadic dimensions.
#' 
#' See references.
#' 
#' @usage dwt.2d(x, wf, J = 4, boundary = "periodic")
#' @usage idwt.2d(y)
#' @aliases dwt.2d idwt.2d
#' @param x input matrix (image)
#' @param wf name of the wavelet filter to use in the decomposition
#' @param J depth of the decomposition, must be a number less than or equal to
#' log(minM,N,2)
#' @param boundary only \code{"periodic"} is currently implemented
#' @param y an object of class \code{dwt.2d}
#' @return List structure containing the \eqn{3J+1} sub-matrices from the
#' decomposition.
#' @author B. Whitcher
#' @seealso \code{\link{modwt.2d}}.
#' @references Mallat, S. (1998) \emph{A Wavelet Tour of Signal Processing},
#' Academic Press.
#' 
#' Vetterli, M. and J. Kovacevic (1995) \emph{Wavelets and Subband Coding},
#' Prentice Hall.
#' @keywords ts
#' @examples
#' 
#' ## Xbox image
#' data(xbox)
#' xbox.dwt <- dwt.2d(xbox, "haar", 3)
#' par(mfrow=c(1,1), pty="s")
#' plot.dwt.2d(xbox.dwt)
#' par(mfrow=c(2,2), pty="s")
#' image(1:dim(xbox)[1], 1:dim(xbox)[2], xbox, xlab="", ylab="",
#'       main="Original Image")
#' image(1:dim(xbox)[1], 1:dim(xbox)[2], idwt.2d(xbox.dwt), xlab="", ylab="",
#'       main="Wavelet Reconstruction")
#' image(1:dim(xbox)[1], 1:dim(xbox)[2], xbox - idwt.2d(xbox.dwt),
#'       xlab="", ylab="", main="Difference")
#' 
#' ## Daubechies image
#' data(dau)
#' par(mfrow=c(1,1), pty="s")
#' image(dau, col=rainbow(128))
#' sum(dau^2)
#' dau.dwt <- dwt.2d(dau, "d4", 3)
#' plot.dwt.2d(dau.dwt)
#' sum(plot.dwt.2d(dau.dwt, plot=FALSE)^2)
#' 
#' @export dwt.2d
dwt.2d <- function(x, wf, J=4, boundary="periodic")
{
  m <- dim(x)[1]
  storage.mode(m) <- "integer"
  n <- dim(x)[2]
  storage.mode(n) <- "integer"

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  z <- matrix(0, m/2, n/2)
  storage.mode(z) <- "double"

  x.wt <- vector("list", 3*J+1)
  x.names <- NULL
  for(j in 1:J) {
    out <- .C(C_two_D_dwt, "Image"=as.double(x), "Rows"=m, "Cols"=n, 
                "filter.length"=L, "hpf"=h, "lpf"=g, "LL"=z, "LH"=z,
                "HL"=z, "HH"=z)[7:10]
    if(j < J) {
      index <- (3*j-2):(3*j)
      x.wt[index] <- out[-1]
      x.names <- c(x.names, sapply(names(out)[-1], paste, j, sep=""))
      x <- out[[1]]
      m <- dim(x)[1]
      storage.mode(m) <- "integer"
      n <- dim(x)[2]
      storage.mode(n) <- "integer"
      z <- matrix(0, m/2, n/2)
      storage.mode(z) <- "double"
    }
    else {
      index <- (3*j):(3*(j+1)) - 2
      x.wt[index] <- out[c(2:4,1)]
      x.names <- c(x.names, sapply(names(out)[c(2:4,1)], paste, j, sep=""))
    }
  }

  names(x.wt) <- x.names
  attr(x.wt, "J") <- J
  attr(x.wt, "wavelet") <- wf
  attr(x.wt, "boundary") <- boundary
  attr(x.wt, "class") <- "dwt.2d"
  x.wt
}

idwt.2d <- function(y)
{
  J <- attributes(y)$J

  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  LL <- paste("LL", J, sep="")
  y.in <- y[[LL]]

  for(j in J:1) {
    LH <- paste("LH", j, sep="")
    HL <- paste("HL", j, sep="")
    HH <- paste("HH", j, sep="")
    
    m <- dim(y.in)[1]
    storage.mode(m) <- "integer"
    n <- dim(y.in)[2]
    storage.mode(n) <- "integer"
    x <- matrix(0, 2*m, 2*n)
    storage.mode(x) <- "double"

    out <- .C(C_two_D_idwt, as.double(y.in), as.double(y[[LH]]),
              as.double(y[[HL]]), as.double(y[[HH]]), m, n, L, h, g,
              "Y"=x)
    y.in <- out$Y
  }
  zapsmall(y.in)
}



#' Two-Dimensional Maximal Overlap Discrete Wavelet Transform
#' 
#' Performs a separable two-dimensional maximal overlap discrete wavelet
#' transform (MODWT) on a matrix of arbitrary dimensions.
#' 
#' See references.
#' 
#' @usage modwt.2d(x, wf, J = 4, boundary = "periodic")
#' @usage imodwt.2d(y)
#' @aliases modwt.2d imodwt.2d
#' @param x input matrix
#' @param wf name of the wavelet filter to use in the decomposition
#' @param J depth of the decomposition
#' @param boundary only \code{"periodic"} is currently implemented
#' @param y an object of class \code{dwt.2d}
#' @return List structure containing the \eqn{3J+1} sub-matrices from the
#' decomposition.
#' @author B. Whitcher
#' @seealso \code{\link{dwt.2d}}, \code{\link{shift.2d}}.
#' @references Liang, J. and T. W. Parks (1994) A two-dimensional translation
#' invariant wavelet representation and its applications, \emph{Proceedings
#' ICIP-94}, Vol. 1, 66-70.
#' 
#' Liang, J. and T. W. Parks (1994) Image coding using translation invariant
#' wavelet transforms with symmetric extensions, \emph{IEEE Transactions on
#' Image Processing}, \bold{7}, No. 5, 762-769.
#' @keywords ts
#' @examples
#' 
#' ## Xbox image
#' data(xbox)
#' xbox.modwt <- modwt.2d(xbox, "haar", 2)
#' ## Level 1 decomposition
#' par(mfrow=c(2,2), pty="s")
#' image(xbox.modwt$LH1, col=rainbow(128), axes=FALSE, main="LH1")
#' image(xbox.modwt$HH1, col=rainbow(128), axes=FALSE, main="HH1")
#' frame()
#' image(xbox.modwt$HL1, col=rainbow(128), axes=FALSE, main="HL1")
#' ## Level 2 decomposition
#' par(mfrow=c(2,2), pty="s")
#' image(xbox.modwt$LH2, col=rainbow(128), axes=FALSE, main="LH2")
#' image(xbox.modwt$HH2, col=rainbow(128), axes=FALSE, main="HH2")
#' image(xbox.modwt$LL2, col=rainbow(128), axes=FALSE, main="LL2")
#' image(xbox.modwt$HL2, col=rainbow(128), axes=FALSE, main="HL2")
#' sum((xbox - imodwt.2d(xbox.modwt))^2)
#' 
#' data(dau)
#' par(mfrow=c(1,1), pty="s")
#' image(dau, col=rainbow(128), axes=FALSE, main="Ingrid Daubechies")
#' sum(dau^2)
#' dau.modwt <- modwt.2d(dau, "d4", 2)
#' ## Level 1 decomposition
#' par(mfrow=c(2,2), pty="s")
#' image(dau.modwt$LH1, col=rainbow(128), axes=FALSE, main="LH1")
#' image(dau.modwt$HH1, col=rainbow(128), axes=FALSE, main="HH1")
#' frame()
#' image(dau.modwt$HL1, col=rainbow(128), axes=FALSE, main="HL1")
#' ## Level 2 decomposition
#' par(mfrow=c(2,2), pty="s")
#' image(dau.modwt$LH2, col=rainbow(128), axes=FALSE, main="LH2")
#' image(dau.modwt$HH2, col=rainbow(128), axes=FALSE, main="HH2")
#' image(dau.modwt$LL2, col=rainbow(128), axes=FALSE, main="LL2")
#' image(dau.modwt$HL2, col=rainbow(128), axes=FALSE, main="HL2")
#' sum((dau - imodwt.2d(dau.modwt))^2)
#' 
#' @export modwt.2d
modwt.2d <- function(x, wf, J=4, boundary="periodic")
{
  m <- dim(x)[1]
  storage.mode(m) <- "integer"
  n <- dim(x)[2]
  storage.mode(n) <- "integer"

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf / sqrt(2)
  storage.mode(h) <- "double"
  g <- dict$lpf / sqrt(2)
  storage.mode(g) <- "double"

  z <- matrix(0, m, n)
  storage.mode(z) <- "double"

  x.wt <- vector("list", 3*J+1)
  x.names <- NULL
  for(j in 1:J) {
    out <- .C("two_D_modwt", "Image"=as.double(x), "Rows"=m, "Cols"=n,
              "Level"=j, "filter.length"=L, "hpf"=h, "lpf"=g, "LL"=z,
              "LH"=z, "HL"=z, "HH"=z, PACKAGE="waveslim")[8:11]
    if(j < J) {
      index <- (3*j-2):(3*j)
      x.wt[index] <- out[-1]
      x.names <- c(x.names, sapply(names(out)[-1], paste, j, sep=""))
      x <- out$LL
    }
    else {
      index <- (3*j):(3*(j+1)) - 2
      x.wt[index] <- out[c(2:4,1)]
      x.names <- c(x.names, sapply(names(out)[c(2:4,1)], paste, j, sep=""))
    }
  }

  names(x.wt) <- x.names
  attr(x.wt, "J") <- J
  attr(x.wt, "wavelet") <- wf
  attr(x.wt, "boundary") <- boundary
  x.wt
}


imodwt.2d <- function(y)
{
  J <- attributes(y)$J

  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf / sqrt(2)
  storage.mode(h) <- "double"
  g <- dict$lpf / sqrt(2)
  storage.mode(g) <- "double"

  LL <- paste("LL", J, sep="")
  y.in <- y[[LL]]

  for(j in J:1) {
    LH <- paste("LH", j, sep="")
    HL <- paste("HL", j, sep="")
    HH <- paste("HH", j, sep="")
    
    m <- dim(y.in)[1]
    storage.mode(m) <- "integer"
    n <- dim(y.in)[2]
    storage.mode(n) <- "integer"
    x <- matrix(0, m, n)
    storage.mode(x) <- "double"

    out <- .C(C_two_D_imodwt, as.double(y.in), as.double(y[[LH]]),
              as.double(y[[HL]]), as.double(y[[HH]]), m, n, j, L,
              h, g, "Y"=x)
    y.in <- out$Y
  }
  zapsmall(y.in)
}



#' Plot Two-dimensional Discrete Wavelet Transform
#' 
#' Organizes the wavelet coefficients from a 2D DWT into a single matrix and
#' plots it.  The coarser resolutions are nested within the lower-lefthand
#' corner of the image.
#' 
#' The wavelet coefficients from the DWT object (a list) are reorganized into a
#' single matrix of the same dimension as the original image and the result is
#' plotted.
#' 
#' @param x input matrix (image)
#' @param cex.axis \code{par} plotting parameter that controls the size of the
#' axis text
#' @param plot if \code{plot = FALSE} then the matrix of wavelet coefficients
#' is returned, the default is \code{plot = TRUE}
#' @param ... additional graphical parameters if necessary
#' @return Image plot.
#' @author B. Whitcher
#' @seealso \code{\link{dwt.2d}}.
#' @keywords ts
#' @export plot.dwt.2d
plot.dwt.2d <- function(x, cex.axis=1, plot=TRUE, ...)
{
  J <- attributes(x)$J
  X <- x[[paste("LL", J, sep="")]]
  for(j in J:1) {
    x.names <- sapply(c("LH","HL","HH"), paste, j, sep="")
    X <- rbind(cbind(X, x[[x.names[2]]]),
               cbind(x[[x.names[1]]], x[[x.names[3]]]))
  }
  M <- dim(X)[1]; N <- dim(X)[2]
  if(plot) {
    image(1:M, 1:N, X, col=rainbow(128), axes=FALSE, xlab="", ylab="", ...)
    x.label <- NULL
    lines(c(0,N,N,0,0) + 0.5, c(0,0,M,M,0) + 0.5)
    for(j in J:1) {
      lines(c(M/2^j,M/2^j) + 0.5, 2*c(0,N/2^j) + 0.5)
      lines(2*c(0,M/2^j) + 0.5, c(N/2^j,N/2^j) + 0.5)
    }
    at <- c((3*N+2)/2^(1:J+1),(N+2)/2^(J+1))
    labs <- c(paste("H",1:J,sep=""), paste("L",J,sep=""))
    axis(side=1, at=at, labels=labs, tick=FALSE, cex.axis=cex.axis)
    axis(side=2, at=at, labels=labs, tick=FALSE, cex.axis=cex.axis)
  }
  else
    return(X)
  invisible()
}



#' Denoise an Image via the 2D Discrete Wavelet Transform
#' 
#' Perform simple de-noising of an image using the two-dimensional discrete
#' wavelet transform.
#' 
#' See \code{\link{Thresholding}}.
#' 
#' @aliases denoise.dwt.2d denoise.modwt.2d
#' @param x input matrix (image)
#' @param wf name of the wavelet filter to use in the decomposition
#' @param J depth of the decomposition, must be a number less than or equal to
#' log(minM,N,2)
#' @param method character string describing the threshold applied, only
#' \code{"universal"} and \code{"long-memory"} are currently implemented
#' @param H self-similarity or Hurst parameter to indicate spectral scaling,
#' white noise is 0.5
#' @param noise.dir number of directions to estimate background noise standard
#' deviation, the default is 3 which produces a unique estimate of the
#' background noise for each spatial direction
#' @param rule either a \code{"hard"} or \code{"soft"} thresholding rule may be
#' used
#' @return Image of the same dimension as the original but with high-freqency
#' fluctuations removed.
#' @author B. Whitcher
#' @seealso \code{\link{Thresholding}}
#' @references See \code{\link{Thresholding}} for references concerning
#' de-noising in one dimension.
#' @keywords ts
#' @examples
#' 
#' ## Xbox image
#' data(xbox)
#' n <- nrow(xbox)
#' xbox.noise <- xbox + matrix(rnorm(n*n, sd=.15), n, n)
#' par(mfrow=c(2,2), cex=.8, pty="s")
#' image(xbox.noise, col=rainbow(128), main="Original Image")
#' image(denoise.dwt.2d(xbox.noise, wf="haar"), col=rainbow(128),
#'       zlim=range(xbox.noise), main="Denoised image")
#' image(xbox.noise - denoise.dwt.2d(xbox.noise, wf="haar"), col=rainbow(128),
#'       zlim=range(xbox.noise), main="Residual image")
#' 
#' ## Daubechies image
#' data(dau)
#' n <- nrow(dau)
#' dau.noise <- dau + matrix(rnorm(n*n, sd=10), n, n)
#' par(mfrow=c(2,2), cex=.8, pty="s")
#' image(dau.noise, col=rainbow(128), main="Original Image")
#' dau.denoise <- denoise.modwt.2d(dau.noise, wf="d4", rule="soft")
#' image(dau.denoise, col=rainbow(128), zlim=range(dau.noise),
#'       main="Denoised image")
#' image(dau.noise - dau.denoise, col=rainbow(128), main="Residual image")
#' 
denoise.dwt.2d <- function(x, wf = "la8", J = 4, method = "universal", 
                           H = 0.5, noise.dir = 3, rule = "hard")
{
  soft <- function(x, delta) sign(x) * pmax(abs(x) - delta, 0)
  hard <- function(x, delta) ifelse(abs(x) > delta, x, 0)

  n <- length(x)
  x.dwt <- dwt.2d(x, wf, J)
  if(noise.dir == 3)
    sigma.mad <- list(HH = mad(x.dwt$HH1), HL = mad(x.dwt$HL1), 
  		      LH = mad(x.dwt$LH1))
  else {
    noise <- x.dwt$jj
    sigma.mad <- list(HH = mad(noise), HL = mad(noise), LH = mad(noise))
  }
    thresh <- list(HH = rep(sqrt(2 * sigma.mad$HH^2 * log(n)), J), 
		   HL = rep(sqrt(2 * sigma.mad$HL^2 * log(n)), J),
		   LH = rep(sqrt(2 * sigma.mad$LH^2 * log(n)), J))

  if(method == "long-memory")
    thresh <- lapply(thresh, function(x,J,H) 2^(0:(J-1)*(H-1/2))*x, J=J, H=H)
  for(j in 1:J) {
    jj <- paste("HL", j, sep = "")
    if(rule == "hard")
      x.dwt[[jj]] <- hard(x.dwt[[jj]], thresh$HL[j])
    else 
      x.dwt[[jj]] <- soft(x.dwt[[jj]], thresh$HL[j])
    jj <- paste("LH", j, sep = "")
    if(rule == "hard")
      x.dwt[[jj]] <- hard(x.dwt[[jj]], thresh$LH[j])
    else 
      x.dwt[[jj]] <- soft(x.dwt[[jj]], thresh$LH[j])
    jj <- paste("HH", j, sep = "")
    if(rule == "hard")
      x.dwt[[jj]] <- hard(x.dwt[[jj]], thresh$HH[j])
    else 
      x.dwt[[jj]] <- soft(x.dwt[[jj]], thresh$HH[j])
  }
  idwt.2d(x.dwt)
}


denoise.modwt.2d <- function(x, wf = "la8", J = 4, method = "universal", 
  H = 0.5, rule = "hard")
{
  soft <- function(x, delta) sign(x) * pmax(abs(x) - delta, 0)
  hard <- function(x, delta) ifelse(abs(x) > delta, x, 0)
  n <- length(x)
  x.modwt <- modwt.2d(x, wf, J)
  sigma.mad <- list(HH = sqrt(2) * mad(x.modwt$HH1),
		    HL = sqrt(2) * mad(x.modwt$HL1),
		    LH = sqrt(2) * mad(x.modwt$LH1))
    thresh <- list(HH = rep(sqrt(2 * sigma.mad$HH^2 * log(n))/2^(1:J), J), 
		   HL = rep(sqrt(2 * sigma.mad$HL^2 * log(n))/2^(1:J), J), 
		   LH = rep(sqrt(2 * sigma.mad$LH^2 * log(n))/2^(1:J), J))
  if(method == "long-memory")
    thresh <- lapply(thresh, function(x,J,H) 2^(0:(J-1)*(H-1/2))*x, J=J, H=H)
  for(j in 1:J) {
    jj <- paste("HL", j, sep = "")
    if(rule == "hard")
      x.modwt[[jj]] <- hard(x.modwt[[jj]], thresh$HL[j])
    else 
      x.modwt[[jj]] <- soft(x.modwt[[jj]], thresh$HL[j])
    jj <- paste("LH", j, sep = "")
    if(rule == "hard")
      x.modwt[[jj]] <- hard(x.modwt[[jj]], thresh$LH[j])
    else 
      x.modwt[[jj]] <- soft(x.modwt[[jj]], thresh$LH[j])
    jj <- paste("HH", j, sep = "")
    if(rule == "hard")
      x.modwt[[jj]] <- hard(x.modwt[[jj]], thresh$HH[j])
    else 
     x.modwt[[jj]] <- soft(x.modwt[[jj]], thresh$HH[j])
  }
  imodwt.2d(x.modwt)
}



#' (Inverse) Discrete Wavelet Packet Transforms in Two Dimensions
#' 
#' All possible filtering combinations (low- and high-pass) are performed to
#' decompose a matrix or image.  The resulting coefficients are associated with
#' a quad-tree structure corresponding to a partitioning of the two-dimensional
#' frequency plane.
#' 
#' The code implements the two-dimensional DWPT using the pyramid algorithm of
#' Mallat (1989).
#' 
#' @usage dwpt.2d(x, wf = "la8", J = 4, boundary = "periodic")
#' @usage idwpt.2d(y, y.basis)
#' @aliases dwpt.2d idwpt.2d
#' @param x a matrix or image containing the data be to decomposed.  This
#' ojbect must be dyadic (power of 2) in length in each dimension.
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length \eqn{L=8} (Daubechies, 1992), least asymmetric
#' family.
#' @param J Specifies the depth of the decomposition.  This must be a number
#' less than or equal to \eqn{\log(\mbox{length}(x),2)}.
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the default, then the vector you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the vector beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @param y \code{dwpt.2d} object (list-based structure of matrices)
#' @param y.basis Boolean vector, the same length as \eqn{y}, where \code{TRUE}
#' means the basis tensor should be used in the reconstruction.
#' @return Basically, a list with the following components
#' \item{w?.?-w?.?}{Wavelet coefficient matrices (images).  The first index is
#' associated with the scale of the decomposition while the second is
#' associated with the frequency partition within that level.  The left and
#' right strings, separated by the dash `-', correspond to the first \eqn{(x)}
#' and second \eqn{(y)} dimensions.} \item{wavelet}{Name of the wavelet filter
#' used.} \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{dwt.2d}}, \code{\link{modwt.2d}},
#' \code{\link{wave.filter}}.
#' @references Mallat, S. G. (1989) A theory for multiresolution signal
#' decomposition: the wavelet representation, \emph{IEEE Transactions on
#' Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.
#' 
#' Wickerhauser, M. V. (1994) \emph{Adapted Wavelet Analysis from Theory to
#' Software}, A K Peters.
#' @keywords ts
#' @export dwpt.2d
dwpt.2d <- function(x, wf="la8", J=4, boundary="periodic")
{
  ## x <- xbox
  ## Define image dimensions (assign mode for C) and perform simple
  ## diagnostics.
  m <- dim(x)[1]
  storage.mode(m) <- "integer"
  n <- dim(x)[2]
  storage.mode(n) <- "integer"
  if(log(m, 2) != trunc(log(m, 2)) | log(n, 2) != trunc(log(n, 2)))
    stop("One dimension is not a power of 2")
  if(2^J > m | 2^J > n)
    stop("Wavelet transform exceeds sample size in one dimension of DWPT")

  ## Extract wavelet and scaling filter coefficients, along with filter
  ## length, from the filter name provided.
  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  ## Create names for wavelet packet nodes (quad-tree structure).
  N <- sum(4^(1:J))
  level <- rep(1:J, 4^(1:J))
  x.wpt <- vector("list", N)
  c1 <- rep(1:J, 2^(1:J))
  c2 <- unlist(apply(as.matrix(2^(1:J) - 1), 1, seq, from=0))
  cry <- paste("w", c1, ".", c2, sep="")
  x.wpt.names <- NULL
  for(j in 1:J) {
    xx <- matrix(cry[c1 == j], 2^j, 2^j)
    yy <- matrix(cry[c1 == j], 2^j, 2^j, byrow=TRUE)
    x.wpt.names <- c(x.wpt.names, as.matrix(paste(xx, "-", yy, sep="")))
  }
  names(x.wpt) <- x.wpt.names
  rm(j,xx,yy,c1,c2,cry)
  ## Define initial zero matrix to store wavelet sub-images.
  z <- matrix(0, m/2, n/2)
  storage.mode(z) <- "double"

  ## Implement the 2D DWPT in a nested loop structure.
  for(j in 1:J) {
    ## cat("j =", j, fill=TRUE)
    for(k in 0:(4^j/4-1)) {
      if(j > 1) {
        ## if j > 1, grab wavelet coefficient image and also its name.
        index <- min((1:N)[level == j-1]) + k
        parent <- x.wpt.names[index]
        ## cat("parent =", parent, fill=TRUE)
        x <- x.wpt[[parent]]
        tmp <- unlist(strsplit(parent, "\\-"))
      }
      else
        tmp <- c("w0.0", "w0.0")
      ## Deconstruct name into nodes for the x and y dimensions.
      node <- unlist(strsplit(tmp, "\\."))
      node <- as.integer(node[-c(1,3)])
      ## Preliminary assignments in order to keep wavelet coefficient
      ## sub-images in sequency order.
      if(node[1] %% 2 == 0) {
        Xlow <- paste("w", j, ".", 2 * node[1], sep="")
        Xhigh <- paste("w", j, ".", 2 * node[1] + 1, sep="")
      }
      else {
        Xlow <- paste("w", j, ".", 2 * node[1] + 1, sep="")
        Xhigh <- paste("w", j, ".", 2 * node[1], sep="")
      }
      if(node[2] %% 2 == 0) {
        Ylow <- paste("w", j, ".", 2 * node[2], sep="")
        Yhigh <- paste("w", j, ".", 2 * node[2] + 1, sep="")
      }
      else {
        Ylow <- paste("w", j, ".", 2 * node[2] + 1, sep="")
        Yhigh <- paste("w", j, ".", 2 * node[2], sep="")
      }
      ## Create names for the new wavelet coefficient images.
      LL <- paste(Xlow, "-", Ylow, sep="")
      LH <- paste(Xlow, "-", Yhigh, sep="")
      HL <- paste(Xhigh, "-", Ylow, sep="")
      HH <- paste(Xhigh, "-", Yhigh, sep="")
      ## cat(matrix(c(LH,LL,HH,HL), 2, 2), fill=TRUE)
      ## Perform the DWPT
      out <- .C(C_two_D_dwt, "Image"=as.double(x), "Rows"=m, "Cols"=n, 
                "filter.length"=L, "hpf"=h, "lpf"=g, "LL"=z, "LH"=z,
                "HL"=z, "HH"=z)[7:10]
      ## Pass wavelet coefficient images into the DWPT object.
      x.wpt[[LL]] <- out[["LL"]]
      x.wpt[[LH]] <- out[["LH"]]
      x.wpt[[HL]] <- out[["HL"]]
      x.wpt[[HH]] <- out[["HH"]]
    }
    ## Redefine zero matrix to its new (decimated) size.
    m <- dim(out[["LL"]])[1]
    storage.mode(m) <- "integer"
    n <- dim(out[["LL"]])[2]
    storage.mode(n) <- "integer"
    z <- matrix(0, m/2, n/2)
    storage.mode(z) <- "double"
  }
  attr(x.wpt, "J") <- J
  attr(x.wpt, "wavelet") <- wf
  attr(x.wpt, "boundary") <- boundary
  return(x.wpt)
}


idwpt.2d <- function(y, y.basis)
{
  ## Error checking
  if(length(y) != length(y.basis))
    stop("DWPT object and basis selection must be the same length")
  ## Number of wavelet scales
  J <- attributes(y)$J
  ## Define wavelet/scaling filter coefficients and length
  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"
  ## Nested for loops
  names(y.basis) <- names(y)
  for(j in J:1) {
    for(nx in seq(0, 2^j - 1, by = 2)) {
      for(ny in seq(0, 2^j - 1, by = 2)) {
        ## Name the four wavelet coefficients sub-images
        LL <- paste("w", j, ".", nx, "-", "w", j, ".", ny, sep="")
        LH <- paste("w", j, ".", nx, "-", "w", j, ".", ny+1, sep="")
        HL <- paste("w", j, ".", nx+1, "-", "w", j, ".", ny, sep="")
        HH <- paste("w", j, ".", nx+1, "-", "w", j, ".", ny+1, sep="")
        if(any(y.basis[LL], y.basis[LH], y.basis[HL], y.basis[HH])) {
          m <- nrow(y[[LL]])
          storage.mode(m) <- "integer"
          n <- ncol(y[[LL]])
          storage.mode(n) <- "integer"
          XX <- matrix(0, 2*m, 2*n)
          storage.mode(XX) <- "double"
          ## parent indices to construct string
          pnx <- floor(nx / 2)
          pny <- floor(ny / 2)
          if((pnx %% 2 != 0) & (pny %% 2 != 0))
            ## Upper right-hand corner
            out <- .C(C_two_D_idwt, as.double(y[[HH]]),
                      as.double(y[[HL]]), as.double(y[[LH]]),
                      as.double(y[[LL]]), m, n, L, h, g, "Y"=XX)$Y
          else {
            ## Upper left-hand corner
            if((pnx %% 2 == 0) & (pny %% 2 != 0))
              out <- .C(C_two_D_idwt, as.double(y[[LH]]),
                        as.double(y[[LL]]), as.double(y[[HH]]),
                        as.double(y[[HL]]), m, n, L, h, g, "Y"=XX)$Y
            else {
              ## Lower right-hand corner
              if((pnx %% 2 != 0) & (pny %% 2 == 0))
                out <- .C(C_two_D_idwt, as.double(y[[HL]]),
                          as.double(y[[HH]]), as.double(y[[LL]]),
                          as.double(y[[LH]]), m, n, L, h, g, "Y"=XX)$Y
              else {
                ## Lower left-hand corner
                if((pnx %% 2 == 0) & (pny %% 2 == 0))
                  out <- .C(C_two_D_idwt, as.double(y[[LL]]),
                            as.double(y[[LH]]), as.double(y[[HL]]),
                            as.double(y[[HH]]), m, n, L, h, g, "Y"=XX)$Y
                else
                  stop("Ouch!")
              }
            }
          }
          if(j > 1) {
            pname <- paste("w", j-1, ".", pnx, "-", "w", j-1, ".", pny, sep="")
            y[[pname]] <- out
            y.basis[pname] <- 1
          }
        }
      }
    }
  }
  return(out)
}

## .First.lib <- function(lib, pkg) library.dynam("waveslim", pkg, lib)

.onAttach <- function(lib, pkg) {
  txt <- paste(
    "\n",
    pkg,
    ": Wavelet Method for 1/2/3D Signals (version = ",
    utils::packageDescription(pkg, lib)[["Version"]],
    ")\n",
    sep = ""
  )
  packageStartupMessage(txt)
}

#' Autocovariance Functions via the Discrete Fourier Transform
#' 
#' Computes the autocovariance function (ACF) for a time series or the
#' cross-covariance function (CCF) between two time series.
#' 
#' The series is zero padded to twice its length before the discrete Fourier
#' transform is applied.  Only the values corresponding to nonnegative lags are
#' provided (for the ACF).
#' 
#' @usage my.acf(x)
#' @usage my.ccf(a, b)
#' @aliases my.acf my.ccf
#' @param x,a,b time series
#' @return The autocovariance function for all nonnegative lags or the
#' cross-covariance function for all lags.
#' @author B. Whitcher
#' @keywords ts
#' @examples
#' 
#' data(ibm)
#' ibm.returns <- diff(log(ibm))
#' plot(1:length(ibm.returns) - 1, my.acf(ibm.returns), type="h",
#'      xlab="lag", ylab="ACVS", main="Autocovariance Sequence for IBM Returns")
#' 
#' @export my.acf
my.acf <- function(x)
{
  n <- length(x)
  x <- c(x, rep(0, n))
  Re(fft(Mod(fft(x)) ^ 2, inverse = TRUE) / 2 / n ^ 2)[1:n]
}

my.ccf <- function(a, b) {
  n <- length(a)
  a <- c(a, rep(0, n))
  b <- c(b, rep(0, n))
  x <- Re(fft(fft(a) * Conj(fft(b)), inverse = TRUE)) / 2 / n ^ 2
  x[c((n + 2):(2 * n), 1:n)]
}

#' Higher-Order Wavelet Filters
#' 
#' Create a wavelet filter at arbitrary scale.
#' 
#' Uses \code{cascade} subroutine to compute higher-order wavelet coefficient
#' vector from a given filtering sequence.
#' 
#' @param wf.name Character string of wavelet filter.
#' @param filter.seq Character string of filter sequence.  \code{H} means
#' high-pass filtering and \code{L} means low-pass filtering.  Sequence is read
#' from right to left.
#' @param n Length of zero-padded filter.  Frequency resolution will be
#' \code{n}/2+1.
#' @return Vector of wavelet coefficients.
#' @author B. Whitcher
#' @seealso \code{\link{squared.gain}}, \code{\link{wave.filter}}.
#' @references Bruce, A. and H.-Y. Gao (1996).  \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' 
#' Doroslovacki, M. L. (1998) On the least asymmetric wavelets, \emph{IEEE
#' Transactions on Signal Processing}, \bold{46}, No. 4, 1125-1130.
#' 
#' Daubechies, I. (1992) \emph{Ten Lectures on Wavelets}, CBMS-NSF Regional
#' Conference Series in Applied Mathematics, SIAM: Philadelphia.
#' 
#' Morris and Peravali (1999) Minimum-bandwidth discrete-time wavelets,
#' \emph{Signal Processing}, \bold{76}, No. 2, 181-193.
#' 
#' Nielsen, M. (2001) On the Construction and Frequency Localization of Finite
#' Orthogonal Quadrature Filters, \emph{Journal of Approximation Theory},
#' \bold{108}, No. 1, 36-52.
#' @keywords ts
#' @examples
#' 
#' ## Figure 4.14 in Gencay, Selcuk and Whitcher (2001)
#' par(mfrow=c(3,1), mar=c(5-2,4,4-1,2))
#' f.seq <- "HLLLLL"
#' plot(c(rep(0,33), wavelet.filter("mb4", f.seq), rep(0,33)), type="l",
#'      xlab="", ylab="", main="D(4) in black, MB(4) in red")
#' lines(c(rep(0,33), wavelet.filter("d4", f.seq), rep(0,33)), col=2)
#' plot(c(rep(0,35), -wavelet.filter("mb8", f.seq), rep(0,35)), type="l",
#'      xlab="", ylab="", main="D(8) in black, -MB(8) in red")
#' lines(c(rep(0,35), wavelet.filter("d8", f.seq), rep(0,35)), col=2)
#' plot(c(rep(0,39), wavelet.filter("mb16", f.seq), rep(0,39)), type="l",
#'      xlab="", ylab="", main="D(16) in black, MB(16) in red")
#' lines(c(rep(0,39), wavelet.filter("d16", f.seq), rep(0,39)), col=2)
#' 
#' @export wavelet.filter
wavelet.filter <- function(wf.name, filter.seq = "L", n = 512)
{
  cascade <- function(f, x, j)
    {
      L <- length(f)
      N <- length(x)
      M <- (L - 1) * 2^j
      M1 <- M - L + 2
      M2 <- 2 * M - L + 2
      if(N > M1)
        stop("x is too long\n")
      else x <- c(x, rep(0, M1 - N))
      xj <- c(rep(0, M), x, rep(0, M))
      yj <- rep(0, M2)
      for(i in 1:L)
        yj <- yj + f[L - i + 1] * xj[1:M2 + (i - 1) * 2^j]
      yj
    }
  if(is.character(wf.name))
    wf <- wave.filter(wf.name)
  else
    wf <- wf.name
  J <- nchar(filter.seq)
  key <- rev(substring(filter.seq, 1:J, 1:J))
  f <- 1
  fl <- wf$lpf
  fh <- wf$hpf
  for(k in 1:J) {
    if(key[k] == "H")
      f <- cascade(fh, f, k - 1)
    else if(key[k] == "L")
      f <- cascade(fl, f, k - 1)
    else stop("Invalid filter.seq\n")
  }
  f
}



#' Squared Gain Function of a Filter
#' 
#' Produces the modulus squared of the Fourier transform for a given filtering
#' sequence.
#' 
#' Uses \code{cascade} subroutine to compute the squared gain function from a
#' given filtering sequence.
#' 
#' @param wf.name Character string of wavelet filter.
#' @param filter.seq Character string of filter sequence.  \code{H} means
#' high-pass filtering and \code{L} means low-pass filtering.  Sequence is read
#' from right to left.
#' @param n Length of zero-padded filter.  Frequency resolution will be
#' \code{n}/2+1.
#' @return Squared gain function.
#' @author B. Whitcher
#' @seealso \code{\link{wave.filter}}, \code{\link{wavelet.filter}}.
#' @keywords ts
#' @examples
#' 
#' par(mfrow=c(2,2))
#' f.seq <- "H"
#' plot(0:256/512, squared.gain("d4", f.seq), type="l", ylim=c(0,2),
#'      xlab="frequency", ylab="L = 4", main="Level 1")
#' lines(0:256/512, squared.gain("fk4", f.seq), col=2)
#' lines(0:256/512, squared.gain("mb4", f.seq), col=3)
#' abline(v=c(1,2)/4, lty=2)
#' legend(-.02, 2, c("Daubechies", "Fejer-Korovkin", "Minimum-Bandwidth"),
#'        lty=1, col=1:3, bty="n", cex=1)
#' f.seq <- "HL"
#' plot(0:256/512, squared.gain("d4", f.seq), type="l", ylim=c(0,4),
#'      xlab="frequency", ylab="", main="Level 2")
#' lines(0:256/512, squared.gain("fk4", f.seq), col=2)
#' lines(0:256/512, squared.gain("mb4", f.seq), col=3)
#' abline(v=c(1,2)/8, lty=2)
#' f.seq <- "H"
#' plot(0:256/512, squared.gain("d8", f.seq), type="l", ylim=c(0,2),
#'      xlab="frequency", ylab="L = 8", main="")
#' lines(0:256/512, squared.gain("fk8", f.seq), col=2)
#' lines(0:256/512, squared.gain("mb8", f.seq), col=3)
#' abline(v=c(1,2)/4, lty=2)
#' f.seq <- "HL"
#' plot(0:256/512, squared.gain("d8", f.seq), type="l", ylim=c(0,4),
#'      xlab="frequency", ylab="", main="")
#' lines(0:256/512, squared.gain("fk8", f.seq), col=2)
#' lines(0:256/512, squared.gain("mb8", f.seq), col=3)
#' abline(v=c(1,2)/8, lty=2)
#' 
#' @export squared.gain
squared.gain <- function(wf.name, filter.seq = "L", n = 512)
{
  cascade <- function(f, x, j)
    {
      L <- length(f)
      N <- length(x)
      M <- (L - 1) * 2^j
      M1 <- M - L + 2
      M2 <- 2 * M - L + 2
      if(N > M1)
        stop("x is too long\n")
      else x <- c(x, rep(0, M1 - N))
      xj <- c(rep(0, M), x, rep(0, M))
      yj <- rep(0, M2)
      for(i in 1:L)
        yj <- yj + f[L - i + 1] * xj[1:M2 + (i - 1) * 2^j]
      yj
    }
  if(is.character(wf.name))
    wf <- wave.filter(wf.name)
  else 
    wf <- wf.name
  J <- nchar(filter.seq)
  key <- rev(substring(filter.seq, 1:J, 1:J))
  f <- 1
  fl <- wf$lpf
  fh <- wf$hpf
  for(k in 1:J) {
    if(key[k] == "H")
      f <- cascade(fh, f, k - 1)
    else if(key[k] == "L")
      f <- cascade(fl, f, k - 1)
    else stop("Invalid filter.seq\n")
  }
  Mod(fft(c(f, rep(0, n - length(f))))[1:(n/2 + 1)])^2
}

bishrink <- function(y1, y2, T) {
  ## Bivariate Shrinkage Function
  ## Usage :
  ##      [w1] = bishrink(y1,y2,T)
  ## INPUT :
  ##      y1 - a noisy coefficient value
  ##      y2 - the corresponding parent value
  ##      T  - threshold value
  ## OUTPUT :
  ##      w1 - the denoised coefficient
  R <- sqrt(abs(y1)^2 + abs(y2)^2)
  R <- R - T
  R <- R * as.numeric(R > 0)
  return(y1 * R/(R+T))
}

#' Bootstrap Time Series Using the DWPT
#' 
#' An adaptive orthonormal basis is selected in order to perform the naive
#' bootstrap within nodes of the wavelet packet tree.  A bootstrap realization
#' of the time series is produce by applying the inverse DWPT.
#' 
#' A subroutines is used to select an adaptive orthonormal basis for the
#' piecewise-constant approximation to the underlying spectral density function
#' (SDF).  Once selected, sampling with replacement is performed within each
#' wavelet packet coefficient vector and the new collection of wavelet packet
#' coefficients are reconstructed into a bootstrap realization of the original
#' time series.
#' 
#' @param y Not necessarily dyadic length time series.
#' @param wf Name of the wavelet filter to use in the decomposition.  See
#' \code{\link{wave.filter}} for those wavelet filters available.
#' @param J Depth of the discrete wavelet packet transform.
#' @param p Level of significance for the white noise testing procedure.
#' @param frac Fraction of the time series that should be used in constructing
#' the likelihood function.
#' @return Time series of length $N$, where $N$ is the length of \code{y}.
#' @author B. Whitcher
#' @seealso \code{\link{dwpt.sim}}, \code{\link{spp.mle}}
#' @references Percival, D.B., S. Sardy, A. Davision (2000) Wavestrapping Time
#' Series: Adaptive Wavelet-Based Bootstrapping, in B.J. Fitzgerald, R.L.
#' Smith, A.T. Walden, P.C. Young (Eds.)  \emph{Nonlinear and Nonstationary
#' Signal Processing}, pp. 442-471.
#' 
#' Whitcher, B. (2001) Simulating Gaussian Stationary Time Series with
#' Unbounded Spectra, \emph{Journal of Computational and Graphical Statistics},
#' \bold{10}, No. 1, 112-134.
#' 
#' Whitcher, B. (2004) Wavelet-Based Estimation for Seasonal Long-Memory
#' Processes, \emph{Technometrics}, \bold{46}, No. 2, 225-238.
#' @keywords ts
#' @export dwpt.boot
dwpt.boot <- function(y, wf, J=log(length(y),2)-1, p=1e-04, frac=1) {

  N <- length(y)
  if(N/2^J != trunc(N/2^J)) 
    stop("Sample size is not divisible by 2^J")
  
  ## Perform discrete wavelet packet transform (DWPT) on Y
  y.dwpt <- dwpt(y, wf, n.levels=J)
  n <- length(y)
  if(frac < 1) {
    for(i in 1:length(y.dwpt)) {
      vec <- y.dwpt[[i]]
      ni <- length(vec)
      j <- rep(1:J, 2^(1:J))[i]
      vec[trunc(frac * n/2^j):ni] <- NA
      y.dwpt[[i]] <- vec
    }
  }
  y.basis <- as.logical(ortho.basis(portmanteau.test(y.dwpt, p, type="other")))

  ## Taken from my 2D bootstrapping methodology
  resample.dwpt <- y.dwpt
  for(i in 1:length(y.basis)) {
    m <- length(y.dwpt[[i]])
    if(y.basis[i])
      resample.dwpt[[i]] <- sample(y.dwpt[[i]], replace=TRUE)
    else
      resample.dwpt[[i]] <- rep(NA, m)
  }
  idwpt(resample.dwpt, y.basis)
}

dualtree2D <- function(x, J, Faf, af) {
  ## normalization
  x <- x/sqrt(2)
  w <- vector("list", J+1)
  ## Tree 1
  w[[1]] <- vector("list", 2)
  temp <- afb2D(x, Faf[[1]])              # stage 1
  x1 <- temp$lo
  w[[1]][[1]] <- temp$hi
  if (J > 1) {
    for (j in 2:J) {
      w[[j]] <- vector("list", 2)
      temp <- afb2D(x1, af[[1]])          # remaining stages
      x1 <- temp$lo
      w[[j]][[1]] <- temp$hi
    }
  }
  w[[J+1]] <- vector("list", 2)
  w[[J+1]][[1]] <- x1                     # lowpass subband
  ## Tree 2
  temp <- afb2D(x, Faf[[2]])              # stage 1
  x2 <- temp$lo
  w[[1]][[2]] <- temp$hi
  if (J > 1) {
    for (j in 2:J) {
      temp <- afb2D(x2, af[[2]])          # remaining stages
      x2 <- temp$lo
      w[[j]][[2]] <- temp$hi
    }
  }
  w[[J+1]][[2]] <- x2                     # lowpass subband
  ## sum and difference
  for (j in 1:J) {
    for (m in 1:3) {
      A <- w[[j]][[1]][[m]]
      B <- w[[j]][[2]][[m]]
      w[[j]][[1]][[m]] <- (A + B) / sqrt(2)
      w[[j]][[2]][[m]] <- (A - B) / sqrt(2)
    }
  }
  return(w)
}

afb2D <- function(x, af1, af2=NULL) {
  if (is.null(af2)) {
    af2 <- af1
  }
  ## filter along columns
  temp <- afb2D.A(x, af1, 1)
  L <- temp$lo
  H <- temp$hi
  ## filter along rows
  hi <- vector("list", 3)
  temp <- afb2D.A(L, af2, 2)
  lo <- temp$lo
  hi[[1]] <- temp$hi
  temp <- afb2D.A(H, af2, 2)
  hi[[2]] <- temp$lo
  hi[[3]] <- temp$hi
  list(lo = lo, hi = hi)
}

afb2D.A <- function(x, af, d) {
  lpf <- af[,1]     # lowpass filter
  hpf <- af[,2]     # highpass filter
  if (d == 2) {
    x <- t(x)
  }
  ## x <- matrix(1:32, 32, 64)
  N <- nrow(x)
  L <- nrow(af) / 2
  x <- cshift2D(x, -L)
  ## image(x, col=rainbow(16))

  ## lo <- upfirdn(x, lpf, 1, 2)
  lo <- convolve2D(x, lpf, conj=FALSE, type="open")
  lo <- cshift2D(lo, -(2 * L - 1))
  lo <- lo[seq(1, nrow(lo), by=2),]
  lo[1:L,] <- lo[1:L,] + lo[1:L + N/2,]
  lo <- lo[1:(N/2),]

  ## hi <- upfirdn(x, hpf, 1, 2)
  hi <- convolve2D(x, hpf, conj=FALSE, type="open")
  hi <- cshift2D(hi, -(2 * L - 1))
  hi <- hi[seq(1, nrow(hi), by=2),]
  hi[1:L,] <- hi[1:L,] + hi[1:L + N/2,]
  hi <- hi[1:(N/2),]

  if (d == 2) {
    lo <- t(lo)
    hi <- t(hi)
  }
  list(lo = lo, hi = hi)
}

cshift2D <- function(x, m) {
  N <- nrow(x)
  n <- 0:(N-1)
  n <- (n-m) %% N
  y <- x[n+1,]
  return(y)
}



#' Fast Column-wise Convolution of a Matrix
#' 
#' Use the Fast Fourier Transform to perform convolutions between a sequence
#' and each column of a matrix.
#' 
#' This is a corrupted version of \code{convolve} made by replacing \code{fft}
#' with \code{mvfft} in a few places.  It would be nice to submit this to the R
#' Developers for inclusion.
#' 
#' @param x MxN matrix.
#' @param y numeric sequence of length N.
#' @param conj logical; if \code{TRUE}, take the complex \emph{conjugate}
#' before back-transforming (default, and used for usual convolution).
#' @param type character; one of \code{circular}, \code{open} (beginning of
#' word is ok).  For \code{circular}, the two sequences are treated as
#' \emph{circular}, i.e., periodic.
#' 
#' For \code{open} and \code{filter}, the sequences are padded with zeros (from
#' left and right) first; \code{filter} returns the middle sub-vector of
#' \code{open}, namely, the result of running a weighted mean of \code{x} with
#' weights \code{y}.
#' @author B. Whitcher
#' @seealso \code{\link{convolve}}
#' @keywords ts
#' @export convolve2D
convolve2D <- function(x, y, conj=TRUE, type=c("circular", "open")) {
  ## Generalize convolve to handle vector arrays by calling mvfft()
  type <- match.arg(type)
  n <- nrow(x)
  ny <- length(y)
  Real <- is.numeric(x) && is.numeric(y)
  if (type == "circular") {
    if (ny != n) {
      stop("length mismatch in convolution")
    }
  } else {
    n1 <- ny - 1
    x <- rbind(matrix(0, n1, ncol(x)), x)
    n <- length(y <- c(y, rep.int(0, n - 1)))
  }
  x <- mvfft(mvfft(x) * (if (conj) Conj(fft(y)) else fft(y)), inverse=TRUE)
  (if (Real) Re(x) else x) / n
}

idualtree2D <- function(w, J, Fsf, sf) {
  ## sum and difference
  for (k in 1:J) {
    for (m in 1:3) {
      A <- w[[k]][[1]][[m]]
      B <- w[[k]][[2]][[m]]
      w[[k]][[1]][[m]] <- (A+B)/sqrt(2)
      w[[k]][[2]][[m]] <- (A-B)/sqrt(2)
    }
  }
  ## Tree 1
  y1 <- w[[J+1]][[1]]
  if (J > 1) {
    for (j in J:2) {
      y1 <- sfb2D(y1, w[[j]][[1]], sf[[1]])
    }
  }
  y1 <- sfb2D(y1, w[[1]][[1]], Fsf[[1]])
  ## Tree 2
  y2 <- w[[J+1]][[2]]
  if (J > 1) {
    for (j in J:2) {
      y2 <- sfb2D(y2, w[[j]][[2]], sf[[2]])
    }
    y2 <- sfb2D(y2, w[[1]][[2]], Fsf[[2]])
  }
  ## normalization
  y <- (y1 + y2)/sqrt(2)
  return(y)
}

sfb2D <- function(lo, hi, sf1, sf2=NULL) {
  if (is.null(sf2)) {
    sf2 <- sf1
  }
  ## filter along rows
  lo <- sfb2D.A(lo, hi[[1]], sf2, 2)
  hi <- sfb2D.A(hi[[2]], hi[[3]], sf2, 2)
  ## filter along columns
  y <- sfb2D.A(lo, hi, sf1, 1)
  return(y)
}

sfb2D.A <- function(lo, hi, sf, d) {
  lpf <- sf[,1]     # lowpass filter
  hpf <- sf[,2]     # highpass filter
  if (d == 2) {
    lo <- t(lo)
    hi <- t(hi)
  }
  N <- 2 * nrow(lo)
  M <- ncol(lo)
  L <- nrow(sf)
  ## y = upfirdn(lo, lpf, 2, 1) + upfirdn(hi, hpf, 2, 1);
  lo <- c(matrix(c(rep(0, length(lo)), c(lo)), nrow=2, byrow=TRUE))
  lo <- matrix(lo, N, M)
  lo <- convolve2D(lo, lpf, conj=FALSE, type="open")
  lo <- cshift2D(lo, -L)
  hi <- c(matrix(c(rep(0, length(hi)), c(hi)), nrow=2, byrow=TRUE))
  hi <- matrix(hi, N, M)
  hi <- convolve2D(hi, hpf, conj=FALSE, type="open")
  hi <- cshift2D(hi, -L)
  y <- lo + hi
  y[1:(L-2),] <- y[1:(L-2),] + y[N+1:(L-2),]
  y <- y[1:N,]
  y <- cshift2D(y, 1 - L/2)
  if (d == 2) {
    y <- t(y)
  }
  return(y)
}

pm <- function(a, b) {
  u <- (a + b) / sqrt(2)
  v <- (a - b) / sqrt(2)
  list(u=u, v=v)
}

#' Calculating Thomson's Spectral Multitapers by Inverse Iteration
#' 
#' This is now a wrapper to the function multitaper::dpss().
#' 
#' @param n length of data taper(s)
#' @param k number of data tapers; 1, 2, 3, ... (do not use 0!)
#' @param nw product of length and half-bandwidth parameter (w)
#' @return \item{v}{matrix of data tapers (cols = tapers)}
#' \item{eigen}{eigenvalue associated with each data taper, discarded} 
#' @author B. Whitcher
#' @seealso \code{\link{sine.taper}}.
#' @references Percival, D. B. and A. T. Walden (1993) \emph{Spectral Estimation for
#' Physical Applications: Multitaper and Conventional Univariate Techniques},
#' Cambridge University Press.
#' @keywords ts
#' @export dpss.taper
dpss.taper <- function(n, k, nw = 4) {
  out <- multitaper::dpss(n, k, nw)
  return(out$v)
}

#' Computing Sinusoidal Data Tapers
#' 
#' Computes sinusoidal data tapers directly from equations.
#' 
#' See reference.
#' 
#' @param n length of data taper(s)
#' @param k number of data tapers
#' @return A vector or matrix of data tapers (cols = tapers).
#' @author B. Whitcher
#' @references Riedel, K. S. and A. Sidorenko (1995) Minimum bias multiple
#' taper spectral estimation, \emph{IEEE Transactions on Signal Processing},
#' \bold{43}, 188-195.
#' @keywords ts
#' @export sine.taper
sine.taper <- function(n, k) {
  tapers <- NULL
  for(i in 1:k)
    tapers <- cbind(tapers, sqrt(2/(n+1)) * sin((pi*i*1:n)/(n+1)))
  return(tapers)
}

#' Wavelet Analysis of Univariate/Bivariate Time Series
#' 
#' Produces an estimate of the multiscale variance, covariance or correlation
#' along with approximate confidence intervals.
#' 
#' The time-independent wavelet variance is basically the average of the
#' squared wavelet coefficients across each scale.  As shown in Percival
#' (1995), the wavelet variance is a scale-by-scale decomposition of the
#' variance for a stationary process, and certain non-stationary processes.
#' 
#' @usage wave.variance(x, type = "eta3", p = 0.025)
#' @usage wave.covariance(x, y)
#' @usage wave.correlation(x, y, N, p = 0.975)
#' @aliases wave.variance wave.covariance wave.correlation
#' @param x first time series
#' @param y second time series
#' @param type character string describing confidence interval calculation;
#' valid methods are \code{gaussian}, \code{eta1}, \code{eta2}, \code{eta3},
#' \code{nongaussian}
#' @param p (one minus the) two-sided p-value for the confidence interval
#' @param N length of time series
#' @return Matrix with as many rows as levels in the wavelet transform object.
#' The first column provides the point estimate for the wavelet variance,
#' covariance, or correlation followed by the lower and upper bounds from the
#' confidence interval.
#' @author B. Whitcher
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Percival, D. B. (1995) \emph{Biometrika}, \bold{82}, No. 3, 619-631.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' 
#' Whitcher, B., P. Guttorp and D. B. Percival (2000) Wavelet Analysis of
#' Covariance with Application to Atmospheric Time Series, \emph{Journal of
#' Geophysical Research}, \bold{105}, No. D11, 14,941-14,962.
#' @keywords ts
#' @examples
#' 
#' ## Figure 7.3 from Gencay, Selcuk and Whitcher (2001)
#' data(ar1)
#' ar1.modwt <- modwt(ar1, "haar", 6)
#' ar1.modwt.bw <- brick.wall(ar1.modwt, "haar")
#' ar1.modwt.var2 <- wave.variance(ar1.modwt.bw, type="gaussian")
#' ar1.modwt.var <- wave.variance(ar1.modwt.bw, type="nongaussian")
#' par(mfrow=c(1,1), las=1, mar=c(5,4,4,2)+.1)
#' matplot(2^(0:5), ar1.modwt.var2[-7,], type="b", log="xy",
#'         xaxt="n", ylim=c(.025, 6), pch="*LU", lty=1, col=c(1,4,4),
#'         xlab="Wavelet Scale", ylab="")
#' matlines(2^(0:5), as.matrix(ar1.modwt.var)[-7,2:3], type="b",
#'          pch="LU", lty=1, col=3)
#' axis(side=1, at=2^(0:5))
#' legend(1, 6, c("Wavelet variance", "Gaussian CI", "Non-Gaussian CI"),
#'        lty=1, col=c(1,4,3), bty="n")
#' 
#' ## Figure 7.8 from Gencay, Selcuk and Whitcher (2001)
#' data(exchange)
#' returns <- diff(log(as.matrix(exchange)))
#' returns <- ts(returns, start=1970, freq=12)
#' wf <- "d4"
#' J <- 6
#' demusd.modwt <- modwt(returns[,"DEM.USD"], wf, J)
#' demusd.modwt.bw <- brick.wall(demusd.modwt, wf)
#' jpyusd.modwt <- modwt(returns[,"JPY.USD"], wf, J)
#' jpyusd.modwt.bw <- brick.wall(jpyusd.modwt, wf)
#' returns.modwt.cov <- wave.covariance(demusd.modwt.bw, jpyusd.modwt.bw)
#' par(mfrow=c(1,1), las=0, mar=c(5,4,4,2)+.1)
#' matplot(2^(0:(J-1)), returns.modwt.cov[-(J+1),], type="b", log="x",
#'         pch="*LU", xaxt="n", lty=1, col=c(1,4,4), xlab="Wavelet Scale", 
#'         ylab="Wavelet Covariance")
#' axis(side=1, at=2^(0:7))
#' abline(h=0)
#' 
#' returns.modwt.cor <- wave.correlation(demusd.modwt.bw, jpyusd.modwt.bw,
#'                                       N = dim(returns)[1])
#' par(mfrow=c(1,1), las=0, mar=c(5,4,4,2)+.1)
#' matplot(2^(0:(J-1)), returns.modwt.cor[-(J+1),], type="b", log="x",
#'         pch="*LU", xaxt="n", lty=1, col=c(1,4,4), xlab="Wavelet Scale", 
#'         ylab="Wavelet Correlation")
#' axis(side=1, at=2^(0:7))
#' abline(h=0)
#' 
#' @export wave.variance
wave.variance <- function(x, type = "eta3", p = 0.025) {
  ci.gaussian <- function(x, y, p) {
    find.first <- function(v) {
      na.length <- sum(is.na(v))
      v[na.length + 1]
    }
    x.acf <- lapply(x, FUN = my.acf)
    Aj <- unlist(lapply(x.acf, FUN = function(v) sum(v * v, na.rm = TRUE))) -
      unlist(lapply(x.acf, FUN = find.first))^2 / 2
    wv.var <- 2 * Aj / unlist(lapply(x, FUN = function(v) sum(!is.na(v))))
    return(data.frame(wavevar = y, lower = y - qnorm(1-p) * sqrt(wv.var),
                      upper = y + qnorm(1 - p) * sqrt(wv.var)))
  }
  
  ci.eta1 <- function(x, y, p) {
    ## x4 <- lapply(x, FUN = function(v) sum(v^4, na.rm = TRUE))
    ## eta1 <- x4.ss * unlist(lapply(x, FUN = function(v) sum(!is.na(v))))
    return(0)
  }
  
  ci.eta2 <- function(x, y, p) {
    return(0)
  }
  
  ci.eta3 <- function(x, y, p) {
    x.length <- unlist(lapply(x, FUN=function(v)sum(!is.na(v))))
    eta3 <- pmax(x.length / 2^(1:length(x)), 1)
    return(data.frame(wavevar = y, lower = eta3 * y / qchisq(1-p, eta3),
                      upper = eta3 * y / qchisq(p, eta3)))
  }

  ci.nongaussian <- function(x, y, p) {
    K <- 5
    J <- length(x)
    x.length <- unlist(lapply(x, FUN=function(v)sum(!is.na(v))))
    x.ss <- unlist(lapply(x, FUN=function(v)v[!is.na(v)]^2))
    mt.var <- numeric(J)
    for(j in 1:J) { 
      # Return the matrix of Slepian Sequences only (ignore the eigenvalues)
      x.dpss <- dpss(x.length[j], K, 4)$v
      V <- apply(x.dpss, 2, sum)
      J <- apply(x.dpss * x.ss[[j]], 2, sum)
      mt.var[j] <- sum((J - y[j] * V)^2) / K / x.length[j]
    }
    return(data.frame(wavevar = y, lower = y - qnorm(1-p) * sqrt(mt.var),
                      upper = y + qnorm(1-p) * sqrt(mt.var)))
  }

  x.ss <- unlist(lapply(x, FUN = function(v) sum(v*v, na.rm=TRUE)))
  x.length <- unlist(lapply(x, FUN = function(v) sum(!is.na(v))))
  y <- x.ss / x.length

  switch(type,
    gaussian = ci.gaussian(x, y, p),
    eta1 = ci.eta1(x, y, p),
    eta2 = ci.eta2(x, y, p),
    eta3 = ci.eta3(x, y, p),
    nongaussian = ci.nongaussian(x, y, p),
    stop("Invalid selection of \"type\" for the confidence interval"))
}

##plot.var <- function(x, y=NA, ylim=range(x, y, na.rm=TRUE))
##{
##  n <- dim(x)[1]
##  plot(2^(0:(n-1)), x[,1], axes=FALSE, type="n", log="xy", ylim=ylim)
##  axis(1, at=2^(0:(n-1)))
##  axis(2)
##  polyci(x[,1], x[,-1], -1)
##  if(any(!is.na(y))) { polyci(y[,1], y[,-1], 1, color=5) }
##  abline(h=0, lty=2)
##}

wave.covariance <- function(x, y) {
  my.acf.na <- function(v) {
    v <- v[!is.na(v)]
    my.acf(v)
  }
  my.ccf.na <- function(u, v) {
    u <- u[!is.na(u)]
    v <- v[!is.na(v)]
    n <- length(u)
    u <- c(u, rep(0, n))
    v <- c(v, rep(0, n))
    n <- length(u)
    x <- Re(fft(fft(u) * Conj(fft(v)), inverse=TRUE)) / 2 / n^2
    x[c((n %/% 2):n, 1:(n %/% 2 - 1))]
  }
  compute.sum.xy.ccvs <- function(x, y) {
    l <- length(x)
    xy <- numeric(l)
    for(i in 1:l)
      xy[i] <- sum(my.ccf.na(x[[i]], y[[i]])^2)
    xy
  }
  compute.xy.acvs <- function(x, y) {
    l <- length(x)
    xy <- vector("list", l)
    for(i in 1:l) {
      z <- x[[i]] * y[[i]]
      xy[[i]] <- c(rev(z), z[-1])
    }
    xy
  }
  per <- function (z) {
    n <- length(z)
    (Mod(fft(z))^2/n)[1:(n%/%2 + 1)]
  }
  per2 <- function(x, y) {
    n <- length(x)
    fft.x <- fft(x)
    fft.y <- fft(y)
    ((Conj(fft.x) * fft.y)/n)[1:(n %/% 2 + 1)]
  }
  
  l <- length(x)
  xy <- vector("list", l)
  for(i in 1:l)
    xy[[i]] <- as.vector(x[[i]] * y[[i]])
  z.ss <- unlist(lapply(xy, sum, na.rm=TRUE))
  x.na <- lapply(x, is.na)
  for(i in 1:l)
    x.na[[i]] <- !x.na[[i]]
  z.length <- unlist(lapply(x.na, sum))

  zz <- z.ss / z.length
  names(zz) <- names(x)

  x.acvs <- lapply(x, my.acf.na)
  y.acvs <- lapply(y, my.acf.na)
  sum.xy.acvs <- unlist(lapply(compute.xy.acvs(x.acvs, y.acvs), sum))
  sum.squared.xy.ccvs <- compute.sum.xy.ccvs(x, y)
  var.gamma <- (sum.xy.acvs + sum.squared.xy.ccvs) / 2 / z.length

  out <- data.frame(wavecov = zz, lower = zz - qnorm(.975) * sqrt(var.gamma),
                    upper = zz + qnorm(.975) * sqrt(var.gamma))
  return(as.matrix(out))
}

##polyci <- function(x, xci, sp, color=2)
##{
##  n <- length(x)
##  y <- 2^(0:(n-1)+sp*.05)
##  delta <- y - 2^(0:(n-1))
##  for(i in 1:n){
##     polygon(c(y[i] + .6*delta[i], y[i] + .6*delta[i], y[i] - .6*delta[i],
##        y[i] - .6*delta[i]), c(xci[i,], xci[i,2:1]), border=FALSE,
##        col=color, lty=1)
##  }
##  points(y, x, pch="-")
##}

##plot.cov <- function(x, ylim=range(x,0))
##{
##  n <- dim(x)[1]
##  plot(2^(0:(n-1)), x[,1], axes=FALSE, type="n", log="x", ylim=ylim)
##  axis(1, at=2^(0:(n-1)))
##  axis(2)
##  polyci(x[,1], x[,-1], 1)
##  abline(h=0, lty=2)
##}

wave.correlation <- function(x, y, N, p = .975) {
  sum.of.squares <- function(x) { sum(x^2, na.rm=TRUE) / sum(!is.na(x)) }
  sum.of.not.squares <- function(x) { sum(x, na.rm=TRUE) / sum(!is.na(x)) }

  l <- length(x)
  xy <- vector("list", l); xy.abs <- vector("list", l)
  for(i in 1:l) {
    xy[[i]] <- as.vector(x[[i]] * y[[i]])
    xy.abs[[i]] <- as.vector(abs(x[[i]] * y[[i]]))
  }
  xy.cov <- unlist(lapply(xy, sum.of.not.squares))
  
  x.var <- unlist(lapply(x, sum.of.squares))
  y.var <- unlist(lapply(y, sum.of.squares))
  
  xy.cor <- xy.cov / sqrt(x.var * y.var)
  n <- trunc(N/2^(1:l))
  out <- data.frame(wavecor=xy.cor,
                    lower=tanh(atanh(xy.cor)-qnorm(p)/sqrt(n-3)),
                    upper=tanh(atanh(xy.cor)+qnorm(p)/sqrt(n-3)))
  return(as.matrix(out))
}

##plot.cor <- function(x, ylim=c(-1,1), cex=NULL)
##{
##  n <- dim(x)[1]
##  plot(2^(0:(n-1)), x[,1], axes=FALSE, type="n", log="x", ylim=ylim, cex=cex)
##  axis(1, at=2^(0:(n-1)), cex=cex)
##  axis(2, cex=cex)
##  polyci(x[,1], x[,-1], 1)
##  abline(h=0, lty=2)
##}

#' Compute Wavelet Cross-Covariance Between Two Time Series
#' 
#' Computes wavelet cross-covariance or cross-correlation between two time
#' series.
#' 
#' See references.
#' 
#' @usage spin.covariance(x, y, lag.max = NA)
#' @usage spin.correlation(x, y, lag.max = NA)
#' @aliases spin.covariance spin.correlation
#' @param x first time series
#' @param y second time series, same length as \code{x}
#' @param lag.max maximum lag to compute cross-covariance (correlation)
#' @return List structure holding the wavelet cross-covariances (correlations)
#' according to scale.
#' @author B. Whitcher
#' @seealso \code{\link{wave.covariance}}, \code{\link{wave.correlation}}.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Whitcher, B., P. Guttorp and D. B. Percival (2000) Wavelet analysis of
#' covariance with application to atmospheric time series, \emph{Journal of
#' Geophysical Research}, \bold{105}, No. D11, 14,941-14,962.
#' @keywords ts
#' @examples
#' 
#' ## Figure 7.9 from Gencay, Selcuk and Whitcher (2001)
#' data(exchange)
#' returns <- diff(log(exchange))
#' returns <- ts(returns, start=1970, freq=12)
#' wf <- "d4"
#' demusd.modwt <- modwt(returns[,"DEM.USD"], wf, 8)
#' demusd.modwt.bw <- brick.wall(demusd.modwt, wf)
#' jpyusd.modwt <- modwt(returns[,"JPY.USD"], wf, 8)
#' jpyusd.modwt.bw <- brick.wall(jpyusd.modwt, wf)
#' n <- dim(returns)[1]
#' J <- 6
#' lmax <- 36
#' returns.cross.cor <- NULL
#' for(i in 1:J) {
#'   blah <- spin.correlation(demusd.modwt.bw[[i]], jpyusd.modwt.bw[[i]], lmax)
#'   returns.cross.cor <- cbind(returns.cross.cor, blah)
#' }
#' returns.cross.cor <- ts(as.matrix(returns.cross.cor), start=-36, freq=1)
#' dimnames(returns.cross.cor) <- list(NULL, paste("Level", 1:J))
#' lags <- length(-lmax:lmax)
#' lower.ci <- tanh(atanh(returns.cross.cor) - qnorm(0.975) /
#'                  sqrt(matrix(trunc(n/2^(1:J)), nrow=lags, ncol=J, byrow=TRUE)
#'                       - 3))
#' upper.ci <- tanh(atanh(returns.cross.cor) + qnorm(0.975) /
#'                  sqrt(matrix(trunc(n/2^(1:J)), nrow=lags, ncol=J, byrow=TRUE)
#'                       - 3))
#' par(mfrow=c(3,2), las=1, pty="m", mar=c(5,4,4,2)+.1)
#' for(i in J:1) {
#'   plot(returns.cross.cor[,i], ylim=c(-1,1), xaxt="n", xlab="Lag (months)",
#'        ylab="", main=dimnames(returns.cross.cor)[[2]][i])
#'   axis(side=1, at=seq(-36, 36, by=12))
#'   lines(lower.ci[,i], lty=1, col=2)
#'   lines(upper.ci[,i], lty=1, col=2)
#'   abline(h=0,v=0)
#' }
#' 
#' @export spin.covariance
spin.covariance <- function(x, y, lag.max = NA) {
  xx <- zz <- x[!is.na(x)]
  yy <- y[!is.na(y)]
  n.length <- length(xx)
  xx.length <- min(length(xx)-1, lag.max, na.rm=TRUE)

  lag1 <- numeric(xx.length + 1)
  lag2 <- numeric(xx.length + 1)
  for(i in 1:(xx.length+1)) {
      lag1[i] <- sum(xx * yy, na.rm=TRUE) / n.length
      lag2[i] <- sum(zz * yy, na.rm=TRUE) / n.length
      xx <- c(xx[2:n.length], NA)
      zz <- c(NA, zz[1:(n.length-1)])
    }
  c(rev(lag2[-1]), lag1)
}

spin.correlation <- function(x, y, lag.max = NA) {
  xx <- zz <- x[!is.na(x)]
  yy <- y[!is.na(y)]
  n.length <- length(xx)
  xx.length <- min(length(xx)-1, lag.max, na.rm=TRUE)
  xx.var <- mean(xx^2)
  yy.var <- mean(yy^2)

  lag1 <- numeric(xx.length + 1)
  lag2 <- numeric(xx.length + 1)
  for(i in 1:(xx.length+1)) {
      lag1[i] <- sum(xx * yy, na.rm=TRUE) / sqrt(xx.var * yy.var) / n.length
      lag2[i] <- sum(zz * yy, na.rm=TRUE) / sqrt(xx.var * yy.var) / n.length
      xx <- c(xx[2:n.length], NA)
      zz <- c(NA, zz[1:(n.length-1)])
    }
  c(rev(lag2[-1]), lag1)
}

##edof <- function(x) {
##  x <- x[!is.na(x)]
##  n <- length(x)
##  x.acf <- my.acf(x)
##  n * x.acf[1]^2 /
##    sum((1 - abs(seq(-n+1,n-1))/n) * c(rev(x.acf[-1]), x.acf)^2)
##}

brick.wall.2d <- function (x, method = "modwt") {
  wf <- attributes(x)$wavelet
  m <- wave.filter(wf)$length
  for (i in names(x)) {
    j <- as.numeric(substr(i, 3, 3))
    if (method == "dwt") {
      n <- ceiling((m - 2) * (1 - 1/2^j))
    } else {
      n <- (2^j - 1) * (m - 1)
    }
    n <- min(n, nrow(x[[i]]))
    x[[i]][1:n, ] <- NA
    x[[i]][, 1:n] <- NA
  }
  
  return(x)
}

#' Wavelet Analysis of Images
#' 
#' Produces an estimate of the multiscale variance with approximate 
#' confidence intervals using the 2D MODWT.
#' 
#' The wavelet variance is basically the average of the squared wavelet 
#' coefficients across each scale and direction of an image. As shown 
#' in Mondal and Percival (2012), the wavelet variance is a 
#' scale-by-scale decomposition of the variance for a stationary spatial
#' process, and certain non-stationary spatial processes.
#' 
#' @param x image
#' @param p (one minus the) two-sided p-value for the confidence interval
#' @return Data frame with 3J+1 rows.
#' @author B. Whitcher
#' @references Mondal, D. and D. B. Percival (2012). Wavelet variance 
#' analysis for random fields on a regular lattice. \emph{IEEE 
#' Transactions on Image Processing} \bold{21}, 537–549.
#'
wave.variance.2d <- function(x, p = 0.025) {
  
  # The unbiased estimator ignores those coefficients affected by the boundary
  x_bw <- brick.wall.2d(x)
  x_ss <- unlist(lapply(x_bw, FUN = function(v) sum(v * v, na.rm = TRUE)))
  x_length <- unlist(lapply(x_bw, FUN = function(v) sum(! is.na(v))))
  wave_var <- x_ss / x_length
  
  edof <- rep(NA, length(x))
  names(edof) <- names(x)
  wf_length <- wave.filter(attributes(x)$wavelet)$length
  # from Section 3.3 Confidence intervals in Geilhufe et al. (2013)
  for (i in names(x)) {
    j <- as.integer(substr(i, 3, 3))
    Lj <- (2^j - 1) * (wf_length - 1) + 1
    Nj <- nrow(x[[i]]) - Lj + 1
    Mj <- ncol(x[[i]]) - Lj + 1
    pad_with_zeros <- matrix(0, nrow = 2^(trunc(log2(Nj)) + 2), ncol = 2^(trunc(log2(Mj)) + 2))
    pad_with_zeros[1:Nj, 1:Mj] <- x[[i]][Lj:nrow(x[[i]]), Lj:ncol(x[[i]])]
    sW <- fft(fft(pad_with_zeros) * Conj(fft(pad_with_zeros)), inverse = TRUE) / prod(dim(pad_with_zeros)) / Nj / Mj
    sigma_W <- sum(sW^2)
    if (Nj * Mj > 128) {
      edof[i] <- 2 * Nj * Mj * wave_var[i]^2 / Re(sigma_W)
    } else {
      edof[i] <- max((Nj * Mj) / (2^j * 2^j), 1)
    }
  }
  
  data.frame(
    value = wave_var,
    level = as.integer(substr(names(x), 3, 3)),
    direction = factor(
      toupper(substr(names(x), 1, 2)),
      levels = c("LH", "HL", "HH", "LL"),
      labels = c("Horizontal", "Vertical", "Diagonal", "Approximation")
    ),
    ci_lower = unlist(edof) * wave_var / qchisq(1 - p, unlist(edof)),
    ci_upper = unlist(edof) * wave_var / qchisq(p, unlist(edof))
  )
}

#' Multiresolution Analysis of an Image
#' 
#' This function performs a level \eqn{J} additive decomposition of the input
#' matrix or image using the pyramid algorithm (Mallat 1989).
#' 
#' This code implements a two-dimensional multiresolution analysis by
#' performing the one-dimensional pyramid algorithm (Mallat 1989) on the rows
#' and columns of the input matrix.  Either the DWT or MODWT may be used to
#' compute the multiresolution analysis, which is an additive decomposition of
#' the original matrix (image).
#' 
#' @param x A matrix or image containing the data be to decomposed.  This must
#' be have dyadic length in both dimensions (but not necessarily the same) for
#' \code{method="dwt"}.
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length L=8 least asymmetric family.
#' @param J Specifies the depth of the decomposition.  This must be a number
#' less than or equal to log(length(x),2).
#' @param method Either \code{"dwt"} or \code{"modwt"}.
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the default, then the matrix you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the matrix beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @return Basically, a list with the following components \item{LH?}{Wavelet
#' detail image in the horizontal direction.} \item{HL?}{Wavelet detail image
#' in the vertical direction.} \item{HH?}{Wavelet detail image in the diagonal
#' direction.} \item{LLJ}{Wavelet smooth image at the coarsest resolution.}
#' \item{J}{Depth of the wavelet transform.} \item{wavelet}{Name of the wavelet
#' filter used.} \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{dwt.2d}}, \code{\link{modwt.2d}}
#' @references Mallat, S. G. (1989) A theory for multiresolution signal
#' decomposition: the wavelet representation, \emph{IEEE Transactions on
#' Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.
#' 
#' Mallat, S. G. (1998) \emph{A Wavelet Tour of Signal Processing}, Academic
#' Press.
#' @keywords ts
#' @examples
#' 
#' ## Easy check to see if it works...
#' ## --------------------------------
#' 
#' x <- matrix(rnorm(32*32), 32, 32)
#' # MODWT
#' x.mra <- mra.2d(x, method="modwt")
#' x.mra.sum <- x.mra[[1]]
#' for(j in 2:length(x.mra))
#'   x.mra.sum <- x.mra.sum + x.mra[[j]]
#' sum((x - x.mra.sum)^2)
#' 
#' # DWT
#' x.mra <- mra.2d(x, method="dwt")
#' x.mra.sum <- x.mra[[1]]
#' for(j in 2:length(x.mra))
#'   x.mra.sum <- x.mra.sum + x.mra[[j]]
#' sum((x - x.mra.sum)^2)
#' 
#' @export mra.2d
mra.2d <-
  function(x, wf="la8", J=4, method="modwt", boundary="periodic")
{
  m <- dim(x)[1]
  n <- dim(x)[2]

  switch(boundary,
    "periodic" = invisible(),
    stop("Invalid boundary rule in mra"))

  if(method == "modwt") {
    x.wt <- modwt.2d(x, wf, J, "periodic")
  } else {
    x.wt <- dwt.2d(x, wf, J, "periodic")
  }
  
  x.mra <- vector("list", 3*J+1)

  ## Smooth
  zero <- vector("list", 3*J+1)
  names(zero) <-
    c(matrix(rbind(paste("LH", 1:J, sep=""), paste("HL", 1:J, sep=""),
                   paste("HH", 1:J, sep="")), nrow=1), paste("LL", J, sep=""))
  attr(zero, "J") <- J
  attr(zero, "wavelet") <- wf
  attr(zero, "boundary") <- boundary
  zero[[3*J+1]] <- x.wt[[3*J+1]]
  if(method == "modwt") {
    for(k in 1:(3*J))
      zero[[k]] <- matrix(0, m, n)
    x.mra[[3*J+1]] <- imodwt.2d(zero)
  } else {
    for(k in 1:J)
      zero[[3*(k-1)+1]] <- zero[[3*(k-1)+2]] <- zero[[3*k]] <-
        matrix(0, m/2^k, n/2^k)
    x.mra[[3*J+1]] <- idwt.2d(zero)
  }

## Details
  for(j in (3*J):1) {
    Jj <- ceiling(j/3)
    zero <- vector("list", 3*Jj+1)
    names(zero) <-
      c(matrix(rbind(paste("LH", 1:Jj, sep=""), paste("HL", 1:Jj, sep=""),
                     paste("HH", 1:Jj, sep="")), nrow=1),
        paste("LL", Jj, sep=""))
    attr(zero, "J") <- Jj
    attr(zero, "wavelet") <- wf
    attr(zero, "boundary") <- boundary
    zero[[j]] <- x.wt[[j]]
    if(method == "modwt") {
      for(k in names(zero)[-charmatch(names(zero)[j], names(zero))])
        zero[[k]] <- matrix(0, m, n)
      x.mra[[j]] <- imodwt.2d(zero)
    } else {
      for(k in 1:Jj)
        zero[[3*(k-1)+1]] <- zero[[3*(k-1)+2]] <- zero[[3*k]] <-
          matrix(0, m/2^k, n/2^k)
      zero[[3*Jj+1]] <- matrix(0, m/2^Jj, n/2^Jj)
      zero[[j]] <- x.wt[[j]]
      x.mra[[j]] <- idwt.2d(zero)
    }
  }

  names(x.mra) <-
    c(matrix(rbind(paste("LH", 1:J, sep=""), paste("HL", 1:J, sep=""),
                   paste("HH", 1:J, sep="")), nrow=1), paste("LL", Jj, sep=""))
   return(x.mra)
}

#' Kingsbury's Q-filters for the Dual-Tree Complex DWT
#' 
#' Kingsbury's Q-filters for the dual-tree complex DWT.
#' 
#' These cofficients are rounded to 8 decimal places.
#' 
#' @aliases dualfilt1 AntonB
#' @return \item{af}{List (i=1,2) - analysis filters for tree i} \item{sf}{List
#' (i=1,2) - synthesis filters for tree i} Note: \code{af[[2]]} is the reverse
#' of \code{af[[1]]}.
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @seealso \code{\link{dualtree}}
#' @references Kingsbury, N.G. (2000).  A dual-tree complex wavelet transform
#' with improved orthogonality and symmetry properties, \emph{Proceedings of
#' the IEEE Int. Conf. on Image Proc.} (ICIP).
#' @keywords ts
#' @export dualfilt1
dualfilt1 <- function() {

  af1 <- c(0.03516384000000, 0,
           0, 0,
           -0.08832942000000, -0.11430184000000,
           0.23389032000000, 0,
           0.76027237000000, 0.58751830000000,
           0.58751830000000, -0.76027237000000,
           0, 0.23389032000000,
           -0.11430184000000, 0.08832942000000,
           0, 0,
           0, -0.03516384000000)
  af1 <- matrix(af1, ncol=2, byrow=TRUE)
  af2 <- c(0, -0.03516384000000,
           0, 0,
           -0.11430184000000, 0.08832942000000,
           0, 0.23389032000000,
           0.58751830000000, -0.76027237000000,
           0.76027237000000, 0.58751830000000,
           0.23389032000000, 0,
           -0.08832942000000, -0.11430184000000,
           0, 0,
           0.03516384000000, 0)
  af2 <- matrix(af2, ncol=2, byrow=TRUE)
  sf1 <- af1[nrow(af1):1, ]
  sf2 <- af2[nrow(af2):1, ]
  list(af = list(af1, af2), sf = list(sf1, sf2))
}



#' Farras nearly symmetric filters
#' 
#' Farras nearly symmetric filters for orthogonal 2-channel perfect
#' reconstruction filter bank and Farras filters organized for the dual-tree
#' complex DWT.
#' 
#' 
#' @aliases farras FSfarras
#' @return \item{af}{List (i=1,2) - analysis filters for tree i} \item{sf}{List
#' (i=1,2) - synthesis filters for tree i}
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @seealso \code{\link{afb}}, \code{\link{dualtree}}, \code{\link{dualfilt1}}.
#' @references A. F. Abdelnour and I. W. Selesnick. \dQuote{Nearly symmetric
#' orthogonal wavelet bases}, Proc. IEEE Int. Conf. Acoust., Speech, Signal
#' Processing (ICASSP), May 2001.
#' @keywords ts
FSfarras <- function() {

  af1 <- c(0, 0,
           -0.08838834764832,  -0.01122679215254,
           0.08838834764832,   0.01122679215254,
           0.69587998903400,   0.08838834764832,
           0.69587998903400,   0.08838834764832,
           0.08838834764832,  -0.69587998903400,
           -0.08838834764832,   0.69587998903400,
           0.01122679215254,  -0.08838834764832,
           0.01122679215254,  -0.08838834764832,
           0, 0)
  af1 <- matrix(af1, ncol=2, byrow=TRUE)
  sf1 <- af1[nrow(af1):1, ]
  af2 <- c(0.01122679215254, 0,
           0.01122679215254, 0,
           -0.08838834764832, -0.08838834764832,
           0.08838834764832, -0.08838834764832,
           0.69587998903400, 0.69587998903400,
           0.69587998903400, -0.69587998903400,
           0.08838834764832, 0.08838834764832,
           -0.08838834764832, 0.08838834764832,
           0, 0.01122679215254,
           0, -0.01122679215254)
  af2 <- matrix(af2, ncol=2, byrow=TRUE)
  sf2 <- af2[nrow(af2):1, ]
  list(af = list(af1, af2), sf = list(sf1, sf2))
}

farras <- function() {

  af <- c(0, -0.01122679215254, 0, 0.01122679215254,
          -0.08838834764832, 0.08838834764832,
          0.08838834764832, 0.08838834764832,
          0.69587998903400, -0.69587998903400,
          0.69587998903400, 0.69587998903400,
          0.08838834764832, -0.08838834764832,
          -0.08838834764832, -0.08838834764832,
          0.01122679215254, 0, 0.01122679215254, 0)
  af <- matrix(af, nrow=10, byrow=TRUE)
  sf <- af[nrow(af):1, ]
  list(af = af, sf = sf)
}



#' Miscellaneous Functions for Dual-Tree Wavelet Software
#' 
#' Miscellaneous functions for dual-tree wavelet software.
#' 
#' 
#' @usage cshift(x, m)
#' @usage cshift2D(x, m)
#' @usage pm(a, b)
#' @aliases cshift cshift2D pm
#' @param x N-point vector
#' @param m amount of shift
#' @param a,b input parameters
#' @return \item{y}{vector \code{x} will be shifed by \code{m} samples to the
#' left or matrix \code{x} will be shifed by \code{m} samples down.}
#' \item{u}{(a + b) / sqrt(2)} \item{v}{(a - b) / sqrt(2)}
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @keywords ts
cshift <- function(x, m) {

  N <- length(x)
  n <- 0:(N-1)
  n <- (n-m) %% N
  y <- x[n+1]
  y
}



#' Filter Banks for Dual-Tree Wavelet Transforms
#' 
#' Analysis and synthesis filter banks used in dual-tree wavelet algorithms.
#' 
#' The functions \code{afb2D.A} and \code{sfb2D.A} implement the convolutions,
#' either for analysis or synthesis, in one dimension only.  Thus, they are the
#' workhorses of \code{afb2D} and \code{sfb2D}.  The output for the analysis
#' filter bank along one dimension (\code{afb2D.A}) is a list with two elements
#' \describe{ \item{lo}{low-pass subband} \item{hi}{high-pass subband} } where
#' the dimension of analysis will be half its original length.  The output for
#' the synthesis filter bank along one dimension (\code{sfb2D.A}) will be the
#' output array, where the dimension of synthesis will be twice its original
#' length.
#' 
#' @usage afb(x, af)
#' @usage afb2D(x, af1, af2 = NULL)
#' @usage afb2D.A(x, af, d)
#' @usage sfb(lo, hi, sf)
#' @usage sfb2D(lo, hi, sf1, sf2 = NULL)
#' @usage sfb2D.A(lo, hi, sf, d)
#' @aliases afb afb2D afb2D.A sfb sfb2D sfb2D.A
#' @param x vector or matrix of observations
#' @param af analysis filters.  First element of the list is the low-pass
#' filter, second element is the high-pass filter.
#' @param af1,af2 analysis filters for the first and second dimension of a 2D
#' array.
#' @param sf synthesis filters.  First element of the list is the low-pass
#' filter, second element is the high-pass filter.
#' @param sf1,sf2 synthesis filters for the first and second dimension of a 2D
#' array.
#' @param d dimension of filtering (d = 1 or 2)
#' @param lo low-frequecy coefficients
#' @param hi high-frequency coefficients
#' @return In one dimension the output for the analysis filter bank
#' (\code{afb}) is a list with two elements \item{lo}{Low frequecy output}
#' \item{hi}{High frequency output} and the output for the synthesis filter
#' bank (\code{sfb}) is the output signal.
#' 
#' In two dimensions the output for the analysis filter bank (\code{afb2D}) is
#' a list with four elements \item{lo}{low-pass subband} \item{hi[[1]]}{'lohi'
#' subband} \item{hi[[2]]}{'hilo' subband} \item{hi[[3]]}{'hihi' subband} and
#' the output for the synthesis filter bank (\code{sfb2D}) is the output array.
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @keywords ts
#' @examples
#' 
#' ## EXAMPLE: afb, sfb
#' af = farras()$af
#' sf = farras()$sf
#' x = rnorm(64)
#' x.afb = afb(x, af)
#' lo = x.afb$lo
#' hi = x.afb$hi
#' y = sfb(lo, hi, sf)
#' err = x - y
#' max(abs(err))
#' 
#' ## EXAMPLE: afb2D, sfb2D
#' x = matrix(rnorm(32*64), 32, 64)
#' af = farras()$af
#' sf = farras()$sf
#' x.afb2D = afb2D(x, af, af)
#' lo = x.afb2D$lo
#' hi = x.afb2D$hi
#' y = sfb2D(lo, hi, sf, sf)
#' err = x - y
#' max(abs(err))
#' 
#' ## Example: afb2D.A, sfb2D.A
#' x = matrix(rnorm(32*64), 32, 64)
#' af = farras()$af
#' sf = farras()$sf
#' x.afb2D.A = afb2D.A(x, af, 1)
#' lo = x.afb2D.A$lo
#' hi = x.afb2D.A$hi
#' y = sfb2D.A(lo, hi, sf, 1)
#' err = x - y
#' max(abs(err))
afb <- function(x, af) {

  N <- length(x)
  L <- nrow(af)/2
  x <- cshift(x,-L)
  
  ## lowpass filter
  lo <- convolve(x, af[,1], conj=FALSE, type="open")
  lo <- cshift(lo,-(2*L-1))
  lo <- lo[seq(1, length(lo), by=2)]
  lo[1:L] <- lo[N/2+(1:L)] + lo[1:L]
  lo <- lo[1:(N/2)]
  
  ## highpass filter
  hi <- convolve(x, af[,2], conj=FALSE, type="open")
  hi <- cshift(hi,-(2*L-1))
  hi <- hi[seq(1, length(hi), by=2)]
  hi[1:L] <- hi[N/2+(1:L)] + hi[1:L]
  hi <- hi[1:(N/2)]

  list(lo = lo, hi = hi)
}



#' Dual-tree Complex Discrete Wavelet Transform
#' 
#' One- and two-dimensional dual-tree complex discrete wavelet transforms
#' developed by Kingsbury and Selesnick \emph{et al.}
#' 
#' In one dimension \eqn{N} is divisible by \eqn{2^J} and
#' \eqn{N\ge2^{J-1}\cdot\mbox{length}(\mbox{\code{af}})}.
#' 
#' In two dimensions, these two conditions must hold for both \eqn{M} and
#' \eqn{N}.
#' 
#' @usage dualtree(x, J, Faf, af)
#' @usage idualtree(w, J, Fsf, sf)
#' @usage dualtree2D(x, J, Faf, af)
#' @usage idualtree2D(w, J, Fsf, sf)
#' @aliases dualtree idualtree dualtree2D idualtree2D
#' @param x N-point vector or MxN matrix.
#' @param w DWT coefficients.
#' @param J number of stages.
#' @param Faf analysis filters for the first stage.
#' @param af analysis filters for the remaining stages.
#' @param Fsf synthesis filters for the last stage.
#' @param sf synthesis filters for the preceeding stages.
#' @return For the analysis of \code{x}, the output is \item{w}{DWT
#' coefficients.  Each wavelet scale is a list containing the real and
#' imaginary parts.  The final scale (J+1) contains the low-pass filter
#' coefficients.} For the synthesis of \code{w}, the output is \item{y}{output
#' signal}
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @seealso \code{\link{FSfarras}}, \code{\link{farras}},
#' \code{\link{convolve}}, \code{\link{cshift}}, \code{\link{afb}},
#' \code{\link{sfb}}.
#' @keywords ts
#' @examples
#' 
#' ## EXAMPLE: dualtree
#' x = rnorm(512)
#' J = 4
#' Faf = FSfarras()$af
#' Fsf = FSfarras()$sf
#' af = dualfilt1()$af
#' sf = dualfilt1()$sf
#' w = dualtree(x, J, Faf, af)
#' y = idualtree(w, J, Fsf, sf)
#' err = x - y
#' max(abs(err))
#' 
#' ## Example: dualtree2D
#' x = matrix(rnorm(64*64), 64, 64)
#' J = 3
#' Faf = FSfarras()$af
#' Fsf = FSfarras()$sf
#' af = dualfilt1()$af
#' sf = dualfilt1()$sf
#' w = dualtree2D(x, J, Faf, af)
#' y = idualtree2D(w, J, Fsf, sf)
#' err = x - y
#' max(abs(err))
#' 
#' ## Display 2D wavelets of dualtree2D.m
#' 
#' J <- 4
#' L <- 3 * 2^(J+1)
#' N <- L / 2^J
#' Faf <- FSfarras()$af
#' Fsf <- FSfarras()$sf
#' af <- dualfilt1()$af
#' sf <- dualfilt1()$sf
#' x <- matrix(0, 2*L, 3*L)
#' w <- dualtree2D(x, J, Faf, af)
#' w[[J]][[1]][[1]][N/2, N/2+0*N] <- 1
#' w[[J]][[1]][[2]][N/2, N/2+1*N] <- 1
#' w[[J]][[1]][[3]][N/2, N/2+2*N] <- 1
#' w[[J]][[2]][[1]][N/2+N, N/2+0*N] <- 1
#' w[[J]][[2]][[2]][N/2+N, N/2+1*N] <- 1
#' w[[J]][[2]][[3]][N/2+N, N/2+2*N] <- 1
#' y <- idualtree2D(w, J, Fsf, sf)
#' image(t(y), col=grey(0:64/64), axes=FALSE)
#' 
dualtree <- function(x, J, Faf, af) {

  ## normalization
  x <- x/sqrt(2)
  w <- vector("list", J+1)

  ## Tree 1
  w[[1]] <- vector("list", 2)
  temp <- afb(x, Faf[[1]])
  x1 <- temp$lo
  w[[1]][[1]] <- temp$hi
  if(J > 1) {
    for(j in 2:J) {
      w[[j]] <- vector("list", 2)
      temp <- afb(x1, af[[1]])
      x1 <- temp$lo
      w[[j]][[1]] <- temp$hi
    }
  }
  w[[J+1]] <- vector("list", 2)
  w[[J+1]][[1]] <- x1

  ## Tree 2
  temp <- afb(x, Faf[[2]])
  x2 <- temp$lo
  w[[1]][[2]] <- temp$hi
  if(J > 1) {
    for(j in 2:J) {
      temp <- afb(x2, af[[2]])
      x2 <- temp$lo
      w[[j]][[2]] <- temp$hi
    }
  }
  w[[J+1]][[2]] <- x2
  w
}

sfb <- function(lo, hi, sf) {

  N <- 2*length(lo)
  L <- nrow(sf)
  ## lo <- upfirdn(lo, sf[,1], 2, 1)
  lo <- c(matrix(c(rep(0, N/2), lo), nrow=2, byrow=TRUE))
  lo <- convolve(lo, sf[,1], conj=FALSE, type="open")
  lo <- cshift(lo, -L)
  ## hi <- upfirdn(hi, sf[,2], 2, 1)
  hi <- c(matrix(c(rep(0, N/2), hi), nrow=2, byrow=TRUE))
  hi <- convolve(hi, sf[,2], conj=FALSE, type="open")
  hi <- cshift(hi, -L)
  
  y <- lo + hi
  y[1:(L-2)] <- y[1:(L-2)] + y[N+1:(L-2)]
  y <- y[1:N]
  ## y = cshift(y, 1-L/2);
  y <- cshift(y, 1-L/2)
  y
}

idualtree <- function(w, J, Fsf, sf) {

  ## Tree 1
  y1 <- w[[J+1]][[1]]
  if(J > 1) {
    for(j in J:2) {
      y1 <- sfb(y1, w[[j]][[1]], sf[[1]])
    }
  }
  y1 <- sfb(y1, w[[1]][[1]], Fsf[[1]])
  
  ## Tree 2
  y2 <- w[[J+1]][[2]]
  if(J > 1) {
    for(j in J:2) {
      y2 <- sfb(y2, w[[j]][[2]], sf[[2]])
    }
  }
  y2 <- sfb(y2, w[[1]][[2]], Fsf[[2]])

  ## normalization
  y <- (y1 + y2)/sqrt(2)
  y
}

#' Discrete Wavelet Transform (DWT)
#' 
#' This function performs a level \eqn{J} decomposition of the input vector or
#' time series using the pyramid algorithm (Mallat 1989).
#' 
#' The code implements the one-dimensional DWT using the pyramid algorithm
#' (Mallat, 1989).  The actual transform is performed in C using pseudocode
#' from Percival and Walden (2001).  That means convolutions, not inner
#' products, are used to apply the wavelet filters.
#' 
#' For a non-dyadic length vector or time series, \code{dwt.nondyadic} pads
#' with zeros, performs the orthonormal DWT on this dyadic length series and
#' then truncates the wavelet coefficient vectors appropriately.
#' 
#' @usage dwt(x, wf = "la8", n.levels = 4, boundary = "periodic")
#' @usage dwt.nondyadic(x)
#' @usage idwt(y)
#' @aliases dwt dwt.nondyadic idwt
#' @param x a vector or time series containing the data be to decomposed.  This
#' must be a dyadic length vector (power of 2).
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.
#' @param n.levels Specifies the depth of the decomposition.  This must be a
#' number less than or equal to log(length(x),2).
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the default, then the vector you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the vector beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @param y An object of S3 class \code{dwt}.
#' @return Basically, a list with the following components 
#' \item{d?}{Wavelet coefficient vectors.} 
#' \item{s?}{Scaling coefficient vector.}
#' \item{wavelet}{Name of the wavelet filter used.} 
#' \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{modwt}}, \code{\link{mra}}.
#' @references Daubechies, I. (1992) \emph{Ten Lectures on Wavelets}, CBMS-NSF
#' Regional Conference Series in Applied Mathematics, SIAM: Philadelphia.
#' 
#' Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An Introduction to
#' Wavelets and Other Filtering Methods in Finance and Economics}, Academic
#' Press.
#' 
#' Mallat, S. G. (1989) A theory for multiresolution signal decomposition: the
#' wavelet representation, \emph{IEEE Transactions on Pattern Analysis and
#' Machine Intelligence}, \bold{11}(7), 674--693.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' ## Figures 4.17 and 4.18 in Gencay, Selcuk and Whitcher (2001).
#' data(ibm)     
#' ibm.returns <- diff(log(ibm))
#' ## Haar
#' ibmr.haar <- dwt(ibm.returns, "haar")
#' names(ibmr.haar) <- c("w1", "w2", "w3", "w4", "v4")
#' ## plot partial Haar DWT for IBM data
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.returns, axes=FALSE, ylab="", main="(a)")
#' for(i in 1:4)
#'   plot.ts(up.sample(ibmr.haar[[i]], 2^i), type="h", axes=FALSE,
#'           ylab=names(ibmr.haar)[i])
#' plot.ts(up.sample(ibmr.haar$v4, 2^4), type="h", axes=FALSE,
#'         ylab=names(ibmr.haar)[5])
#' axis(side=1, at=seq(0,368,by=23), 
#'      labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' ## LA(8)
#' ibmr.la8 <- dwt(ibm.returns, "la8")
#' names(ibmr.la8) <- c("w1", "w2", "w3", "w4", "v4")
#' ## must shift LA(8) coefficients
#' ibmr.la8$w1 <- c(ibmr.la8$w1[-c(1:2)], ibmr.la8$w1[1:2])
#' ibmr.la8$w2 <- c(ibmr.la8$w2[-c(1:2)], ibmr.la8$w2[1:2])
#' for(i in names(ibmr.la8)[3:4])
#'   ibmr.la8[[i]] <- c(ibmr.la8[[i]][-c(1:3)], ibmr.la8[[i]][1:3])
#' ibmr.la8$v4 <- c(ibmr.la8$v4[-c(1:2)], ibmr.la8$v4[1:2])
#' ## plot partial LA(8) DWT for IBM data
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.returns, axes=FALSE, ylab="", main="(b)")
#' for(i in 1:4)
#'   plot.ts(up.sample(ibmr.la8[[i]], 2^i), type="h", axes=FALSE,
#'           ylab=names(ibmr.la8)[i])
#' plot.ts(up.sample(ibmr.la8$v4, 2^4), type="h", axes=FALSE,
#'         ylab=names(ibmr.la8)[5])
#' axis(side=1, at=seq(0,368,by=23), 
#'   labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' 
#' @export dwt
dwt <- function(x, wf="la8", n.levels=4, boundary="periodic")
{
  switch(boundary,
    "reflection" =  x <- c(x, rev(x)),
    "periodic" = invisible(),
    stop("Invalid boundary rule in dwt"))
  N <- length(x)
  J <- n.levels
  if(N/2^J != trunc(N/2^J))
    stop("Sample size is not divisible by 2^J")
  if(2^J > N)
    stop("wavelet transform exceeds sample size in dwt")

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  y <- vector("list", J+1)
  names(y) <- c(paste("d", 1:J, sep=""), paste("s", J, sep=""))
  for(j in 1:J) {
    W <- V <- numeric(N/2^j)
    out <- .C(C_dwt, as.double(x), as.integer(N/2^(j-1)), L, h, g, 
              W=as.double(W), V=as.double(V))[6:7]
    y[[j]] <- out$W
    x <- out$V
  }
  y[[J+1]] <- x
  class(y) <- "dwt"
  attr(y, "wavelet") <- wf
  attr(y, "boundary") <- boundary
  return(y)
}

dwt.nondyadic <- function(x)
{
  M <- length(x)
  N <- 2^(ceiling(log(M, 2)))
  xx <- c(x, rep(0, N - M))
  y <- dwt(xx)
  
  J <- length(y) - 1
  for(j in 1:J)
    y[[j]] <- y[[j]][1:trunc(M/2^j)]
  return(y)
}

idwt <- function(y)
{
  ctmp <- class(y)
  if(is.null(ctmp) || all(ctmp != "dwt"))
    stop("argument `y' is not of class \"dwt\"")

  J <- length(y) - 1

  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  jj <- paste("s", J, sep="")
  X <- y[[jj]]
  for(j in J:1) {
    jj <- paste("d", j, sep="")
    N <- length(X)
    XX <- numeric(2 * length(y[[jj]]))
    X <- .C(C_idwt, as.double(y[[jj]]), as.double(X), as.integer(N), L, 
            h, g, out=as.double(XX))$out
  }
  if(attr(y, "boundary") == "reflection") return(X[1:N])
  else return(X)
}



#' (Inverse) Maximal Overlap Discrete Wavelet Transform
#' 
#' This function performs a level \eqn{J} decomposition of the input vector
#' using the non-decimated discrete wavelet transform. The inverse transform
#' performs the reconstruction of a vector or time series from its maximal
#' overlap discrete wavelet transform.
#' 
#' The code implements the one-dimensional non-decimated DWT using the pyramid
#' algorithm.  The actual transform is performed in C using pseudocode from
#' Percival and Walden (2001).  That means convolutions, not inner products,
#' are used to apply the wavelet filters.
#' 
#' The MODWT goes by several names in the statistical and engineering
#' literature, such as, the ``stationary DWT'', ``translation-invariant DWT'',
#' and ``time-invariant DWT''.
#' 
#' The inverse MODWT implements the one-dimensional inverse transform using the
#' pyramid algorithm (Mallat, 1989).
#' 
#' @usage modwt(x, wf = "la8", n.levels = 4, boundary = "periodic")
#' @usage imodwt(y)
#' @aliases modwt imodwt
#' @param x a vector or time series containing the data be to decomposed.
#' There is \bold{no} restriction on its length.
#' @param y Object of class \code{"modwt"}.
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.
#' @param n.levels Specifies the depth of the decomposition.  This must be a
#' number less than or equal to log(length(x),2).
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the defaulTRUE, then the vector you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the vector beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @param y an object of class \code{"modwt"}
#' @return Basically, a list with the following components 
#' \item{d?}{Wavelet coefficient vectors.} 
#' \item{s?}{Scaling coefficient vector.} 
#' \item{wavelet}{Name of the wavelet filter used.}
#' \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{dwt}}, \code{\link{idwt}}, \code{\link{mra}}.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Percival, D. B. and P. Guttorp (1994) Long-memory processes, the Allan
#' variance and wavelets, In \emph{Wavelets and Geophysics}, pages 325-344,
#' Academic Press.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' ## Figure 4.23 in Gencay, Selcuk and Whitcher (2001)
#' data(ibm)     
#' ibm.returns <- diff(log(ibm))
#' # Haar
#' ibmr.haar <- modwt(ibm.returns, "haar")
#' names(ibmr.haar) <- c("w1", "w2", "w3", "w4", "v4")
#' # LA(8)
#' ibmr.la8 <- modwt(ibm.returns, "la8")
#' names(ibmr.la8) <- c("w1", "w2", "w3", "w4", "v4")
#' # shift the MODWT vectors
#' ibmr.la8 <- phase.shift(ibmr.la8, "la8")
#' ## plot partial MODWT for IBM data
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.returns, axes=FALSE, ylab="", main="(a)")
#' for(i in 1:5)
#'   plot.ts(ibmr.haar[[i]], axes=FALSE, ylab=names(ibmr.haar)[i])
#' axis(side=1, at=seq(0,368,by=23), 
#'   labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.returns, axes=FALSE, ylab="", main="(b)")
#' for(i in 1:5)
#'   plot.ts(ibmr.la8[[i]], axes=FALSE, ylab=names(ibmr.la8)[i])
#' axis(side=1, at=seq(0,368,by=23), 
#'   labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' 
#' @export modwt
modwt <- function(x, wf="la8", n.levels=4, boundary="periodic")
{
  switch(boundary,
    "reflection" =  x <- c(x, rev(x)),
    "periodic" = invisible(),
    stop("Invalid boundary rule in modwt"))
  N <- length(x)
  storage.mode(N) <- "integer"
  J <- n.levels
  if(2^J > N)
    stop("wavelet transform exceeds sample size in modwt")

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  ht <- dict$hpf / sqrt(2)
  storage.mode(ht) <- "double"
  gt <- dict$lpf / sqrt(2)
  storage.mode(gt) <- "double"

  y <- vector("list", J+1)
  names(y) <- c(paste("d", 1:J, sep=""), paste("s", J, sep=""))
  W <- V <- numeric(N)
  storage.mode(W) <- "double"
  storage.mode(V) <- "double"
  
  for(j in 1:J) {
    out <- .C(C_modwt, as.double(x), N, as.integer(j), L, ht, gt, 
              W=W, V=V)[7:8]
    y[[j]] <- out$W
    x <- out$V
  }
  y[[J+1]] <- x
  class(y) <- "modwt"
  attr(y, "wavelet") <- wf
  attr(y, "boundary") <- boundary
  return(y)
}

imodwt <- function(y)
{
  ctmp <- class(y)
  if(is.null(ctmp) || all(ctmp != "modwt"))
    stop("argument `y' is not of class \"modwt\"")

  J <- length(y) - 1

  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  ht <- dict$hpf / sqrt(2)
  storage.mode(ht) <- "double"
  gt <- dict$lpf / sqrt(2)
  storage.mode(gt) <- "double"

  jj <- paste("s", J, sep="")
  X <- y[[jj]]
  N <- length(X)
  storage.mode(N) <- "integer"
  XX <- numeric(N)
  storage.mode(XX) <- "double"
  for(j in J:1) {
    jj <- paste("d", j, sep="")
    X <- .C(C_imodwt, as.double(y[[jj]]), as.double(X), N, as.integer(j), 
            L, ht, gt, out=XX)$out
  }
  if(attr(y, "boundary") == "reflection") return(X[1:(N/2)])
  else return(X)
}



#' Replace Boundary Wavelet Coefficients with Missing Values
#' 
#' Sets the first \eqn{n} wavelet coefficients to \code{NA}.
#' 
#' The fact that observed time series are finite causes boundary issues.  One
#' way to get around this is to simply remove any wavelet coefficient computed
#' involving the boundary.  This is done here by replacing boundary wavelet
#' coefficients with \code{NA}.
#' 
#' @usage brick.wall(x, wf, method = "modwt")
#' @usage dwpt.brick.wall(x, wf, n.levels, method = "modwpt")
#' @usage brick.wall.2d(x, method = "modwt")
#' @aliases brick.wall dwpt.brick.wall brick.wall.2d
#' @param x DWT/MODWT/DWPT/MODWPT object
#' @param wf Character string; name of wavelet filter
#' @param n.levels Specifies the depth of the decomposition. This must be a
#' number less than or equal to log(length(x),2).
#' @param method Either \code{\link{dwt}} or \code{\link{modwt}} for
#' \code{brick.wall}, or either \code{\link{dwpt}} or \code{\link{modwpt}} for
#' \code{dwpt.brick.wall}
#' @return Same object as \code{x} only with some missing values.
#' @author B. Whitcher
#' @references Lindsay, R. W., D. B. Percival and D. A. Rothrock (1996). The
#' discrete wavelet transform and the scale anlaysis of the surface properties
#' of sea ice, \emph{IEEE Transactions on Geoscience and Remote Sensing},
#' \bold{34}, No. 3, 771-787.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @export brick.wall
brick.wall <- function(x, wf, method = "modwt")
{
  m <- wave.filter(wf)$length
  for (j in 1:(length(x) - 1)) {
    if (method == "dwt") {
      n <- ceiling((m - 2) * (1 - 1 / 2 ^ j))
    } else {
      n <- (2^j - 1) * (m - 1)
    }
    n <- min(n, length(x[[j]]))
    x[[j]][1:n] <- NA
  }
  x[[j + 1]][1:n] <- NA
  return(x)
}



#' Phase Shift Wavelet Coefficients
#' 
#' Wavelet coefficients are circularly shifted by the amount of phase shift
#' induced by the wavelet transform.
#' 
#' The center-of-energy argument of Hess-Nielsen and Wickerhauser (1996) is
#' used to provide a flexible way to circularly shift wavelet coefficients
#' regardless of the wavelet filter used.  The results are not identical to
#' those used by Percival and Walden (2000), but are more flexible.
#' 
#' \code{phase.shift.packet} is not yet implemented fully.
#' 
#' @usage phase.shift(z, wf, inv = FALSE)
#' @usage phase.shift.packet(z, wf, inv = FALSE)
#' @aliases phase.shift phase.shift.packet
#' @param z DWT object
#' @param wf character string; wavelet filter used in DWT
#' @param inv Boolean variable; if \code{inv=TRUE} then the inverse phase shift
#' is applied
#' @return DWT (DWPT) object with coefficients circularly shifted.
#' @author B. Whitcher
#' @references Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
#' time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
#' 523-540.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @export phase.shift
phase.shift <- function(z, wf, inv = FALSE)
{
  coe <- function(g)
    sum(0:(length(g)-1) * g^2) / sum(g^2)

  J <- length(z) - 1
  g <- wave.filter(wf)$lpf
  h <- wave.filter(wf)$hpf

  if(!inv) {
    for(j in 1:J) {
      ph <- round(2^(j-1) * (coe(g) + coe(h)) - coe(g), 0)
      Nj <- length(z[[j]])
      z[[j]] <- c(z[[j]][(ph + 1):Nj], z[[j]][1:ph])
    }
    ph <- round((2^J-1) * coe(g), 0)
    J <- J + 1
    z[[J]] <- c(z[[J]][(ph + 1):Nj], z[[J]][1:ph])
  } else {
    for(j in 1:J) {
      ph <- round(2^(j-1) * (coe(g) + coe(h)) - coe(g), 0)
      Nj <- length(z[[j]])
      z[[j]] <- c(z[[j]][(Nj - ph + 1):Nj], z[[j]][1:(Nj - ph)])
    }
    ph <- round((2^J-1) * coe(g), 0)
    J <- J + 1
    z[[J]] <- c(z[[J]][(Nj - ph + 1):Nj], z[[J]][1:(Nj - ph)])
  }
  return(z)
}



#' Multiresolution Analysis of Time Series
#' 
#' This function performs a level \eqn{J} additive decomposition of the input
#' vector or time series using the pyramid algorithm (Mallat 1989).
#' 
#' This code implements a one-dimensional multiresolution analysis introduced
#' by Mallat (1989).  Either the DWT or MODWT may be used to compute the
#' multiresolution analysis, which is an additive decomposition of the original
#' time series.
#' 
#' @param x A vector or time series containing the data be to decomposed.  This
#' must be a dyadic length vector (power of 2) for \code{method="dwt"}.
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length L=8 least asymmetric family.
#' @param J Specifies the depth of the decomposition.  This must be a number
#' less than or equal to log(length(x), 2).
#' @param method Either \code{"dwt"} or \code{"modwt"}.
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the default, then the vector you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the vector beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @return Basically, a list with the following components \item{D?}{Wavelet
#' detail vectors.} \item{S?}{Wavelet smooth vector.} \item{wavelet}{Name of
#' the wavelet filter used.} \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{dwt}}, \code{\link{modwt}}.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Mallat, S. G. (1989) A theory for multiresolution signal decomposition: the
#' wavelet representation, \emph{IEEE Transactions on Pattern Analysis and
#' Machine Intelligence}, \bold{11}, No. 7, 674-693.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' ## Easy check to see if it works...
#' x <- rnorm(32)
#' x.mra <- mra(x)
#' sum(x - apply(matrix(unlist(x.mra), nrow=32), 1, sum))^2
#' 
#' ## Figure 4.19 in Gencay, Selcuk and Whitcher (2001)
#' data(ibm)     
#' ibm.returns <- diff(log(ibm))
#' ibm.volatility <- abs(ibm.returns)
#' ## Haar
#' ibmv.haar <- mra(ibm.volatility, "haar", 4, "dwt")
#' names(ibmv.haar) <- c("d1", "d2", "d3", "d4", "s4")
#' ## LA(8)
#' ibmv.la8 <- mra(ibm.volatility, "la8", 4, "dwt")
#' names(ibmv.la8) <- c("d1", "d2", "d3", "d4", "s4")
#' ## plot multiresolution analysis of IBM data
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.volatility, axes=FALSE, ylab="", main="(a)")
#' for(i in 1:5)
#'   plot.ts(ibmv.haar[[i]], axes=FALSE, ylab=names(ibmv.haar)[i])
#' axis(side=1, at=seq(0,368,by=23), 
#'   labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
#' plot.ts(ibm.volatility, axes=FALSE, ylab="", main="(b)")
#' for(i in 1:5)
#'   plot.ts(ibmv.la8[[i]], axes=FALSE, ylab=names(ibmv.la8)[i])
#' axis(side=1, at=seq(0,368,by=23), 
#'   labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
#' 
#' @export mra
mra <- function(x, wf = "la8", J = 4, method = "modwt", boundary = "periodic")
{
  switch(boundary,
         "reflection" =  x <- c(x, rev(x)),
         "periodic" = invisible(),
         stop("Invalid boundary rule in mra"))
  n <- length(x)
  
  if(method == "modwt")
    x.wt <- modwt(x, wf, J, "periodic")
  else
    x.wt <- dwt(x, wf, J, "periodic")
  x.mra <- vector("list", J+1)
  
  ## Smooth
  zero <- vector("list", J+1)
  names(zero) <- c(paste("d", 1:J, sep = ""), paste("s", J, sep = ""))
  class(zero) <- method
  attr(zero, "wavelet") <- wf
  attr(zero, "boundary") <- boundary
  zero[[J+1]] <- x.wt[[J+1]]
  if(method == "modwt") {
    for(k in 1:J)
      zero[[k]] <- numeric(n)
    x.mra[[J+1]] <- imodwt(zero)
  } else {
    for(k in 1:J)
      zero[[k]] <- numeric(n/2^k)
    x.mra[[J+1]] <- idwt(zero)
  }

  ## Details
  for(j in J:1) {
    zero <- vector("list", j+1)
    names(zero) <- c(paste("d", 1:j, sep = ""), paste("s", j, sep = ""))
    class(zero) <- method
    attr(zero, "wavelet") <- wf
    attr(zero, "boundary") <- boundary
    zero[[j]] <- x.wt[[j]]
    if(method == "modwt") {
      if(j != 1) {
        for(k in c(j+1,(j-1):1))
          zero[[k]] <- numeric(n)
      } else {
        zero[[j+1]] <- numeric(n)
      }
      x.mra[[j]] <- imodwt(zero)
    } else {
      zero[[j+1]] <- numeric(n/2^j)
      if(j != 1) {
        for(k in (j-1):1)
          zero[[k]] <- numeric(n/2^k)
      }
      x.mra[[j]] <- idwt(zero)
    }
  }

  names(x.mra) <- c(paste("D", 1:J, sep = ""), paste("S", J, sep = ""))
  if(boundary == "reflection") { 
    for(j in (J+1):1)
      x.mra[[j]] <- x.mra[[j]][1:(n/2)]
    return(x.mra)
  } else {
    return(x.mra)
  }
}

#' Simulate Seasonal Persistent Processes Using the DWPT
#' 
#' A seasonal persistent process may be characterized by a spectral density
#' function with an asymptote occuring at a particular frequency in
#' \eqn{[0,\frac{1}{2})}{[0,1/2)}.  It's time domain representation was first
#' noted in passing by Hosking (1981).  Although an exact time-domain approach
#' to simulation is possible, this function utilizes the discrete wavelet
#' packet transform (DWPT).
#' 
#' Two subroutines are used, the first selects an adaptive orthonormal basis
#' for the true spectral density function (SDF) while the second computes the
#' bandpass variances associated with the chosen orthonormal basis and SDF.
#' Finally, when \eqn{M>N}{\code{M} > \code{N}} a uniform random variable is
#' generated in order to select a random piece of the simulated time series.
#' For more details see Whitcher (2001).
#' 
#' @param N Length of time series to be generated.
#' @param wf Character string for the wavelet filter.
#' @param delta Long-memory parameter for the seasonal persistent process.
#' @param fG Gegenbauer frequency.
#' @param M Actual length of simulated time series.
#' @param adaptive Logical; if \code{TRUE} the orthonormal basis used in the
#' DWPT is adapted to the ideal spectrum, otherwise the orthonormal basis is
#' performed to a maximum depth.
#' @param epsilon Threshold for adaptive basis selection.
#' @return Time series of length \code{N}.
#' @author B. Whitcher
#' @seealso \code{\link{hosking.sim}} for an exact time-domain method and
#' \code{\link{wave.filter}} for a list of available wavelet filters.
#' @references Hosking, J. R. M. (1981) Fractional Differencing,
#' \emph{Biometrika}, \bold{68}, No. 1, 165-176.
#' 
#' Whitcher, B. (2001) Simulating Gaussian Stationary Time Series with
#' Unbounded Spectra, \emph{Journal of Computational and Graphical Statistics},
#' \bold{10}, No. 1, 112-134.
#' @keywords ts
#' @examples
#' 
#' ## Generate monthly time series with annual oscillation
#' ## library(ts) is required in order to access acf()
#' x <- dwpt.sim(256, "mb16", .4, 1/12, M=4, epsilon=.001)
#' par(mfrow=c(2,1))
#' plot(x, type="l", xlab="Time")
#' acf(x, lag.max=128, ylim=c(-.6,1))
#' data(acvs.andel8)
#' lines(acvs.andel8$lag[1:128], acvs.andel8$acf[1:128], col=2)
#' 
#' @export dwpt.sim
dwpt.sim <- function(N, wf, delta, fG, M=2, adaptive=TRUE, epsilon=0.05) {
  M <- M*N
  J <- log(M, 2)
  jn <- rep(1:J, 2^(1:J))
  jl <- length(jn)

  if( adaptive ) {
    Basis <- find.adaptive.basis(wf, J, fG, epsilon) 
  } else {
    Basis <- numeric(jl)
    a <- min((1:jl)[jn == J])
    b <- max((1:jl)[jn == J])
    Basis[a:b] <- 1
  }

  Index <- (1:jl)[as.logical(Basis)]
  Length <- 2^jn

  variance <- bandpass.var.spp(delta, fG, J, Basis, Length)
  z <- vector("list", jl)
  class(z) <- "dwpt"
  attr(z, "wavelet") <- wf

  for(i in Index)
    z[[i]] <- rnorm(M/Length[i], sd=sqrt(Length[i]*variance[i]))

  x <- idwpt(z, Basis)
  xi <- trunc(runif(1, 1, M-N))
  return(x[xi:(xi+N-1)])
}



#' Determine an Orthonormal Basis for the Discrete Wavelet Packet Transform
#' 
#' Subroutine for use in simulating seasonal persistent processes using the
#' discrete wavelet packet transform.
#' 
#' The squared gain functions for a Daubechies (extremal phase or least
#' asymmetric) wavelet family are used in a filter cascade to compute the value
#' of the squared gain function for the wavelet packet filter at the
#' Gengenbauer frequency.  This is done for all nodes of the wavelet packet
#' table.
#' 
#' The idea behind this subroutine is to approximate the relationship between
#' the discrete wavelet transform and long-memory processes, where the squared
#' gain function is zero at frequency zero for all levels of the DWT.
#' 
#' @param wf Character string; name of the wavelet filter.
#' @param J Depth of the discrete wavelet packet transform.
#' @param fG Gegenbauer frequency.
#' @param eps Threshold for the squared gain function.
#' @return Boolean vector describing the orthonormal basis for the DWPT.
#' @author B. Whitcher
#' @seealso Used in \code{\link{dwpt.sim}}.
#' @keywords ts
#' @export find.adaptive.basis
find.adaptive.basis <- function(wf, J, fG, eps) {
  H <- function(f, L) {
    H <- 0
    for(l in 0:(L/2-1))
      H <- H + choose(L/2+l-1,l) * cos(pi*f)^(2*l)
    H <- 2 * sin(pi*f)^L * H
    return(H)
  }

  G <- function(f, L) {
    G <- 0
    for(l in 0:(L/2-1))
      G <- G + choose(L/2+l-1,l) * sin(pi*f)^(2*l)
    G <- 2 * cos(pi*f)^L * G
    return(G)
  }
  
  L <- wave.filter(wf)$length
  jn <- rep(1:J, 2^(1:J))
  jl <- length(jn)
  U <- numeric(jl)
  U[1] <- G(fG, L)
  U[2] <- H(fG, L)
  for(j in 2:J) {
    jj <- min((1:jl)[jn == j])
    jp <- (1:jl)[jn == j-1]
    for(n in 0:(2^j/2-1)) {
      if (n%%2 == 0) {
        U[jj + 2 * n + 1] <- U[jp[n+1]] * H(2^(j-1)*fG, L)
        U[jj + 2 * n] <- U[jp[n+1]] * G(2^(j-1)*fG, L)
      } else {
        U[jj + 2 * n] <- U[jp[n+1]] * H(2^(j-1)*fG, L)
        U[jj + 2 * n + 1] <- U[jp[n+1]] * G(2^(j-1)*fG, L)
      }
    }
  }
  return(ortho.basis(U < eps))
}

#' Bandpass Variance for Long-Memory Processes
#' 
#' Computes the band-pass variance for fractional difference (FD) or seasonal
#' persistent (SP) processes using numeric integration of their spectral
#' density function.
#' 
#' See references.
#' 
#' @usage bandpass.fdp(a, b, d)
#' @usage bandpass.spp(a, b, d, fG)
#' @usage bandpass.spp2(a, b, d1, f1, d2, f2)
#' @usage bandpass.var.spp(delta, fG, J, Basis, Length)
#' @aliases bandpass.fdp bandpass.spp bandpass.spp2 bandpass.var.spp
#' @param a Left-hand boundary for the definite integral.
#' @param b Right-hand boundary for the definite integral.
#' @param d,delta,d1,d2 Fractional difference parameter.
#' @param fG,f1,f2 Gegenbauer frequency.
#' @param J Depth of the wavelet transform.
#' @param Basis Logical vector representing the adaptive basis.
#' @param Length Number of elements in Basis.
#' @return Band-pass variance for the FD or SP process between \eqn{a} and
#' \eqn{b}.
#' @author B. Whitcher
#' @references McCoy, E. J., and A. T. Walden (1996) Wavelet analysis and
#' synthesis of stationary long-memory processes, \emph{Journal for
#' Computational and Graphical Statistics}, \bold{5}, No. 1, 26-56.
#' 
#' Whitcher, B. (2001) Simulating Gaussian stationary processes with unbounded
#' spectra, \emph{Journal for Computational and Graphical Statistics},
#' \bold{10}, No. 1, 112-134.
#' @keywords ts
bandpass.var.spp <- function(delta, fG, J, Basis, Length) {
  a <- unlist(sapply(2^(1:J)-1, seq, from=0, by=1)) / (2*Length)
  b <- unlist(sapply(2^(1:J), seq, from=1, by=1)) / (2*Length)
  bp.var <- rep(0, length(Basis))
  for(jn in (1:length(Basis))[as.logical(Basis)]) {
    if(fG < a[jn] | fG > b[jn])
      bp.var[jn] <- 2*integrate(spp.sdf, a[jn], b[jn], d=delta, fG=fG)$value
    else {
      result1 <- 2*integrate(spp.sdf, a[jn], fG, d=delta, fG=fG)$value
      result2 <- 2*integrate(spp.sdf, fG, b[jn], d=delta, fG=fG)$value
      bp.var[jn] <- result1 + result2
    }
  }
  return(bp.var)
}

#' Wavelet-based Maximum Likelihood Estimation for a Fractional Difference
#' Process
#' 
#' Parameter estimation for a fractional difference (long-memory, self-similar)
#' process is performed via maximum likelihood on the wavelet coefficients.
#' 
#' The variance-covariance matrix of the original time series is approximated
#' by its wavelet-based equivalent.  A Whittle-type likelihood is then
#' constructed where the sums of squared wavelet coefficients are compared to
#' bandpass filtered version of the true spectrum.  Minimization occurs only
#' for the fractional difference parameter \eqn{d}, while variance is estimated
#' afterwards.
#' 
#' @param y Dyadic length time series.
#' @param wf Name of the wavelet filter to use in the decomposition.  See
#' \code{\link{wave.filter}} for those wavelet filters available.
#' @param J Depth of the discrete wavelet transform.
#' @return List containing the maximum likelihood estimates (MLEs) of \eqn{d}
#' and \eqn{\sigma^2}, along with the value of the likelihood for those
#' estimates.
#' @author B. Whitcher
#' @references M. J. Jensen (2000) An alternative maximum likelihood estimator
#' of long-memory processes using compactly supported wavelets, \emph{Journal
#' of Economic Dynamics and Control}, \bold{24}, No. 3, 361-387.
#' 
#' McCoy, E. J., and A. T. Walden (1996) Wavelet analysis and synthesis of
#' stationary long-memory processes, \emph{Journal for Computational and
#' Graphical Statistics}, \bold{5}, No. 1, 26-56.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' ## Figure 5.5 in Gencay, Selcuk and Whitcher (2001)
#' fdp.sdf <- function(freq, d, sigma2=1)
#'   sigma2 / ((2*sin(pi * freq))^2)^d
#' dB <- function(x) 10 * log10(x)
#' per <- function(z) {
#'   n <- length(z)
#'   (Mod(fft(z))**2/(2*pi*n))[1:(n %/% 2 + 1)]
#' }
#' data(ibm)     
#' ibm.returns <- diff(log(ibm))
#' ibm.volatility <- abs(ibm.returns)
#' ibm.vol.mle <- fdp.mle(ibm.volatility, "d4", 4)
#' freq <- 0:184/368
#' ibm.vol.per <- 2 * pi * per(ibm.volatility)
#' ibm.vol.resid <- ibm.vol.per/ fdp.sdf(freq, ibm.vol.mle$parameters[1])
#' par(mfrow=c(1,1), las=0, pty="m")
#' plot(freq, dB(ibm.vol.per), type="l", xlab="Frequency", ylab="Spectrum")
#' lines(freq, dB(fdp.sdf(freq, ibm.vol.mle$parameters[1],
#'                        ibm.vol.mle$parameters[2]/2)), col=2)
#' 
#' @export fdp.mle
fdp.mle <- function(y, wf, J=log(length(y),2))
{
  fdpML <- function(d, y) {
    
    y.dwt <- y[[1]]
    n <- y[[2]]
    J <- y[[3]]

    ## Establish the limits of integration for the band-pass variances
    a <- c(1/2^c(1:J+1), 0)
    b <- 1/2^c(0:J+1)

    ## Define some useful parameters for computing the likelihood
    length.j <- n / c(2^(1:J), 2^J)
    scale.j <- c(2^(1:J+1), 2^(J+1))

    ## Initialize various parameters for computing the approximate ML
    bp.var <- numeric(J+1)

    ## Compute the band-pass variances according to d
    omega.diag <- NULL
    for(j in 1:(J+1)) {
      bp.var[j] <- integrate(fdp.sdf, a[j], b[j], d=d)$value
      omega.diag <- c(omega.diag, scale.j[j] * rep(bp.var[j], length.j[j]))
    }
    
    ## Compute approximate maximum likelihood 
    n * log(sum(y.dwt^2 / omega.diag) / n) +
      sum(length.j * log(scale.j * bp.var)) 
  }

  n <- length(y)
  y.dwt <- as.vector(unlist(dwt(y, wf, n.levels=J)))

  ## Compute MLE of d (limited to stationary region)
  result <- optimize(fdpML, interval=c(-0.5,0.5), maximum=FALSE,
                     y=list(y.dwt, n, J))

  ## Compute MLE of sigma_epsilon^2
  a <- c(1/2^c(1:J+1), 0)
  b <- 1/2^c(0:J+1)
  length.j <- n / c(2^(1:J), 2^J)
  scale.j <- c(2^(1:J+1), 2^(J+1))
  bp.var <- numeric(J+1)
  omega.diag <- NULL
  for(j in 1:(J+1)) {
    bp.var[j] <- integrate(fdp.sdf, a[j], b[j], d=result$minimum)$value
    omega.diag <- c(omega.diag, scale.j[j] * rep(bp.var[j], length.j[j]))
  }
  sigma2 <- sum(y.dwt^2 / omega.diag) / n

  list(parameters=c(result$minimum, sigma2), objective=result$objective)
}

#' (Inverse) Discrete Wavelet Packet Transforms
#' 
#' All possible filtering combinations (low- and high-pass) are performed to
#' decompose a vector or time series.  The resulting coefficients are
#' associated with a binary tree structure corresponding to a partitioning of
#' the frequency axis.
#' 
#' The code implements the one-dimensional DWPT using the pyramid algorithm
#' (Mallat, 1989).
#' 
#' @usage dwpt(x, wf = "la8", n.levels = 4, boundary = "periodic")
#' @usage idwpt(y, y.basis)
#' @aliases dwpt idwpt modwpt
#' @param x a vector or time series containing the data be to decomposed. This
#' must be a dyadic length vector (power of 2).
#' @param wf Name of the wavelet filter to use in the decomposition. By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.
#' @param n.levels Specifies the depth of the decomposition.This must be a
#' number less than or equal to
#' \eqn{\log(\mbox{length}(x),2)}{log2[length(x)]}.
#' @param boundary Character string specifying the boundary condition. If
#' \code{boundary=="periodic"} the default, then the vector you decompose is
#' assumed to be periodic on its defined interval,\cr if
#' \code{boundary=="reflection"}, the vector beyond its boundaries is assumed
#' to be a symmetric reflection of itself.
#' @param y Object of S3 class \code{dwpt}.
#' @param y.basis Vector of character strings that describe leaves on the DWPT 
#' basis tree.
#' @return Basically, a list with the following components 
#' \item{w?.?}{Wavelet coefficient vectors.  The first index is associated with 
#' the scale of the decomposition while the second is associated with the 
#' frequency partition within that level.} 
#' \item{wavelet}{Name of the wavelet filter used.}
#' \item{boundary}{How the boundaries were handled.}
#' @author B. Whitcher
#' @seealso \code{\link{dwt}}, \code{\link{modwpt}}, \code{\link{wave.filter}}.
#' @references Mallat, S. G. (1989) A theory for multiresolution signal
#' decomposition: the wavelet representation, \emph{IEEE Transactions on
#' Pattern Analysis and Machine Intelligence}, \bold{11}(7), 674--693.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' 
#' Wickerhauser, M. V. (1994) \emph{Adapted Wavelet Analysis from Theory to
#' Software}, A K Peters.
#' @keywords ts
#' @examples
#' 
#' data(mexm)
#' J <- 4
#' mexm.mra <- mra(log(mexm), "mb8", J, "modwt", "reflection")
#' mexm.nomean <- ts(
#'   apply(matrix(unlist(mexm.mra), ncol=J+1, byrow=FALSE)[,-(J+1)], 1, sum), 
#'   start=1957, freq=12)
#' mexm.dwpt <- dwpt(mexm.nomean[-c(1:4)], "mb8", 7, "reflection")
#' 
#' @export dwpt
dwpt <- function(x, wf="la8", n.levels=4, boundary="periodic") {
  N <- length(x)
  J <- n.levels
  if(N/2^J != trunc(N/2^J))
    stop("Sample size is not a power of 2")
  if(2^J > N)
    stop("wavelet transform exceeds sample size in dwt")

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  y <- vector("list", sum(2^(1:J)))
  crystals1 <- rep(1:J, 2^(1:J))
  crystals2 <- unlist(apply(as.matrix(2^(1:J) - 1), 1, seq, from=0))
  names(y) <- paste("w", crystals1, ".", crystals2, sep="")

  for(j in 1:J) {
    jj <- min((1:length(crystals1))[crystals1 == j])
    for(n in 0:(2^j/2-1)) {
      if(j > 1)
        x <- y[[(1:length(crystals1))[crystals1 == j-1][n+1]]]
      W <- V <- numeric(N/2^j)
      if(n %% 2 == 0) {
        z <- .C(C_dwt, as.double(x), as.integer(N/2^(j-1)), L, h, g, 
	  W=as.double(W), V=as.double(V))
        y[[jj + 2*n + 1]] <- z$W
        y[[jj + 2*n]] <- z$V
      }
      else {
        z <- .C(C_dwt, as.double(x), as.integer(N/2^(j-1)), L, h, g,
                W=as.double(W), V=as.double(V))
        y[[jj + 2*n]] <- z$W
        y[[jj + 2*n + 1 ]] <- z$V
      }
    }
  }
  attr(y, "wavelet") <- wf
  return(y)
}

idwpt <- function(y, y.basis)
{
  J <- trunc(log(length(y), 2))

  dict <- wave.filter(attributes(y)$wavelet)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  for(j in J:1) {
    a <- min((1:length(rep(1:J, 2^(1:J))))[rep(1:J, 2^(1:J)) == j])
    b <- max((1:length(rep(1:J, 2^(1:J))))[rep(1:J, 2^(1:J)) == j])
    n <- a
    while(n <= b) {
      if(y.basis[n]) {
        m <- length(y[[n]])
        XX <- numeric(2 * m)
        if(floor((n-a)/2) %% 2 == 0)
          X <- .C(C_idwt, as.double(y[[n+1]]), as.double(y[[n]]),
                  as.integer(m), L, h, g, out=as.double(XX))$out
        else
          X <- .C(C_idwt, as.double(y[[n]]), as.double(y[[n+1]]), 
                  as.integer(m), L, h, g, out=as.double(XX))$out
        if(j != 1) {
          y[[a-(b-a+1)/2 + (n-a)/2]] <- X
          y.basis[[a-(b-a+1)/2 + (n-a)/2]] <- 1
        }
        n <- n + 2
      }
      else { n <- n + 1 }
    }
  }
  return(X)
}

##plot.dwpt <- function(x, n.levels, pgrid=TRUE)
##{
##  J <- n.levels
##  scales <- rep(1:J, 2^(1:J))
##  y <- matrix(NA, 2*length(x[[1]]), J)
##  for(j in 1:J) {
##    a <- min((1:length(scales))[scales == j])
##    b <- max((1:length(scales))[scales == j])
##    y[, j] <- unlist(x[a:b])
##    x.length <- length(y[, j])
##  }
##  plot(ts(y), ylim=c(-.45,.45))
##  if(pgrid) {
##    lines(x.length * c(0,1), c(0,0), lty=2)
##    for(j in 1:J) {
##      lines(x.length * c(0,1), c(-j,-j), lty=2)
##      for(n in 0:2^j) lines(x.length * c(n/2^j, n/2^j), c(-j,-(j-1)), lty=2)
##    }
##  }
##  title(ylab="Level")
##}



#' Produce Boolean Vector from Wavelet Basis Names
#' 
#' Produce a vector of zeros and ones from a vector of basis names.
#' 
#' None.
#' 
#' @param x Output from the discrete wavelet package transfrom (DWPT).
#' @param basis.names Vector of character strings that describe leaves on the
#' DWPT basis tree.  See the examples below for appropriate syntax.
#' @return Vector of zeros and ones.
#' @seealso \code{\link{dwpt}}.
#' @keywords ts
#' @examples
#' 
#' data(acvs.andel8)
#' \dontrun{
#' x <- hosking.sim(1024, acvs.andel8[,2])
#' x.dwpt <- dwpt(x, "la8", 7)
#' ## Select orthonormal basis from wavelet packet tree
#' x.basis <- basis(x.dwpt, c("w1.1","w2.1","w3.0","w4.3","w5.4","w6.10",
#'                            "w7.22","w7.23"))
#' for(i in 1:length(x.dwpt))
#'   x.dwpt[[i]] <- x.basis[i] * x.dwpt[[i]]
#' ## Resonstruct original series using selected orthonormal basis
#' y <- idwpt(x.dwpt, x.basis)
#' par(mfrow=c(2,1), mar=c(5-1,4,4-1,2))
#' plot.ts(x, xlab="", ylab="", main="Original Series")
#' plot.ts(y, xlab="", ylab="", main="Reconstructed Series")
#' }
#' 
#' @export basis
basis <- function(x, basis.names)
{
  m <- length(x)
  n <- length(basis.names)
  y <- numeric(m)
  for(i in 1:n) { y <- y + as.integer(names(x) == basis.names[i]) }
  return(y)
}



#' Derive Orthonormal Basis from Wavelet Packet Tree
#' 
#' An orthonormal basis for the discrete wavelet transform may be characterized
#' via a disjoint partitioning of the frequency axis that covers
#' \eqn{[0,\frac{1}{2})}{[0,1/2)}.  This subroutine produces an orthonormal
#' basis from a full wavelet packet tree.
#' 
#' A wavelet packet tree is a binary tree of Boolean variables.  Parent nodes
#' are removed if any of their children exist.
#' 
#' @param xtree is a vector whose entries are associated with a wavelet packet
#' tree.
#' @return Boolean vector describing the orthonormal basis for the DWPT.
#' @author B. Whitcher
#' @keywords ts
#' @examples
#' 
#' data(japan)
#' J <- 4
#' wf <- "mb8"
#' japan.mra <- mra(log(japan), wf, J, boundary="reflection")
#' japan.nomean <-
#'   ts(apply(matrix(unlist(japan.mra[-(J+1)]), ncol=J, byrow=FALSE), 1, sum),
#'      start=1955, freq=4)
#' japan.nomean2 <- ts(japan.nomean[42:169], start=1965.25, freq=4)
#' plot(japan.nomean2, type="l")
#' japan.dwpt <- dwpt(japan.nomean2, wf, 6)
#' japan.basis <-
#'   ortho.basis(portmanteau.test(japan.dwpt, p=0.01, type="other"))
#' # Not implemented yet
#' # par(mfrow=c(1,1))
#' # plot.basis(japan.basis)
#' 
#' @export ortho.basis
ortho.basis <- function(xtree) {
  J <- trunc(log(length(xtree), 2))
  X <- vector("list", J)
  X[[1]] <- xtree[rep(1:J, 2^(1:J)) == 1]
  for(i in 2:J) {
    for(j in i:J) {
      if(i == 2) X[[j]] <- xtree[rep(1:J, 2^(1:J)) == j]
        X[[j]] <- X[[j]] + 2 * c(apply(matrix(xtree[rep(1:J, 2^(1:J)) == i-1]),
                                       1, rep, 2^(j-i+1)))
    }
  }
  X[[J]][X[[J]] == 0] <- 1
  ifelse(unlist(X) == 1, 1, 0)
}

##plot.basis <- function(xtree)
##{
##  J <- trunc(log(length(xtree), base=2))
##  j <- rep(1:J, 2^(1:J))
##  n <- unlist(apply(matrix(2^(1:J)-1), 1, seq, from=0))
##  basis <- ifelse(xtree, paste("w", j, ".", n, sep=""), NA)
##  pgrid.plot(basis[basis != "NA"])
##  invisible()
##}

phase.shift.packet <- function(z, wf, inv=FALSE)
{
  ## Center of energy
  coe <- function(g)
    sum(0:(length(g)-1) * g^2) / sum(g^2)

  J <- length(z) - 1
  g <- wave.filter(wf)$lpf
  h <- wave.filter(wf)$hpf

  if(!inv) {
    for(j in 1:J) {
      ph <- round(2^(j-1) * (coe(g) + coe(h)) - coe(g), 0)
      Nj <- length(z[[j]])
      z[[j]] <- c(z[[j]][(ph+1):Nj], z[[j]][1:ph])
    }
    ph <- round((2^J-1) * coe(g), 0)
    J <- J + 1
    z[[J]] <- c(z[[J]][(ph+1):Nj], z[[J]][1:ph])
  } else {
    for(j in 1:J) {
      ph <- round(2^(j-1) * (coe(g) + coe(h)) - coe(g), 0)
      Nj <- length(z[[j]])
      z[[j]] <- c(z[[j]][(Nj-ph+1):Nj], z[[j]][1:(Nj-ph)])
    }
    ph <- round((2^J-1) * coe(g), 0)
    J <- J + 1
    z[[J]] <- c(z[[j]][(Nj-ph+1):Nj], z[[j]][1:(Nj-ph)])
  }
  return(z)
}

modwpt <- function(x, wf="la8", n.levels=4, boundary="periodic")
{
  N <- length(x); storage.mode(N) <- "integer"
  J <- n.levels
  if(2^J > N) stop("wavelet transform exceeds sample size in modwt")

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  ht <- dict$hpf/sqrt(2)
  storage.mode(ht) <- "double"
  gt <- dict$lpf/sqrt(2)
  storage.mode(gt) <- "double"

  y <- vector("list", sum(2^(1:J)))
  yn <- length(y)
  crystals1 <- rep(1:J, 2^(1:J))
  crystals2 <- unlist(apply(as.matrix(2^(1:J) - 1), 1, seq, from=0))
  names(y) <- paste("w", crystals1, ".", crystals2, sep="")

  W <- V <- numeric(N)
  storage.mode(W) <- storage.mode(V) <- "double"
  for(j in 1:J) {
    index <- 0
    jj <- min((1:yn)[crystals1 == j])
    for(n in 0:(2^j / 2 - 1)) {
      index <- index + 1
      if(j > 1)
        x <- y[[(1:yn)[crystals1 == j-1][index]]]
      if(n %% 2 == 0) {
        z <- .C(C_modwt, as.double(x), N, as.integer(j), L, ht, gt, 
                W = W, V = V)[7:8]
        y[[jj + 2*n + 1]] <- z$W
        y[[jj + 2*n]] <- z$V
      }
      else {
        z <- .C(C_modwt, as.double(x), N, as.integer(j), L, ht, gt, 
                W = W, V = V)[7:8]
        y[[jj + 2*n]] <- z$W
        y[[jj + 2*n + 1 ]] <- z$V
      }
    }
  }
  attr(y, "wavelet") <- wf
  return(y)
}

dwpt.brick.wall <- function(x, wf, n.levels, method="modwpt")
{
  N <- length(x[[1]])
  m <- wave.filter(wf)$length
  J <- n.levels
  crystals1 <- rep(1:J, 2^(1:J))
  crystals2 <- unlist(apply(as.matrix(2^(1:J) - 1), 1, seq, from=0))

  if(method=="dwpt") {
    ## for DWPT
    for(j in 1:J) {
      jj <- min((1:length(crystals1))[crystals1 == j])
      L <- switch(j,
                  (m-2)/2,
                  ((m-2)/2 + floor(m/4)),
                  ((m-2)/2 + floor((m/2 + floor(m/4))/2)))
      if(is.null(L)) L <- (m-2)
      for(n in 0:(2^j-1))
        x[[jj+n]][1:L] <- NA
    }
  }
  else {
    ## for MODWPT
    for(j in 1:J) {
      jj <- min((1:length(crystals1))[crystals1 == j])
      L <- min((2^j - 1) * (m - 1), N)
      for(n in 0:(2^j-1))
        x[[jj+n]][1:L] <- NA
    }
  }
  return(x)
}



#' Testing the Wavelet Packet Tree for White Noise
#' 
#' A wavelet packet tree, from the discrete wavelet packet transform (DWPT), is
#' tested node-by-node for white noise.  This is the first step in selecting an
#' orthonormal basis for the DWPT.
#' 
#' Top-down recursive testing of the wavelet packet tree is
#' 
#' @usage cpgram.test(y, p = 0.05, taper = 0.1)
#' @usage css.test(y)
#' @usage entropy.test(y)
#' @usage portmanteau.test(y, p = 0.05, type = "Box-Pierce")
#' @aliases cpgram.test css.test entropy.test portmanteau.test
#' @param y wavelet packet tree (from the DWPT)
#' @param p significance level
#' @param taper weight of cosine bell taper (\code{cpgram.test} only)
#' @param type \code{"Box-Pierce"} and \code{other} recognized
#' (\code{portmanteau.test} only)
#' @return Boolean vector of the same length as the number of nodes in the
#' wavelet packet tree.
#' @author B. Whitcher
#' @seealso \code{\link{ortho.basis}}.
#' @references Brockwell and Davis (1991) \emph{Time Series: Theory and
#' Methods}, (2nd. edition), Springer-Verlag.
#' 
#' Brown, Durbin and Evans (1975) Techniques for testing the constancy of
#' regression relationships over time, \emph{Journal of the Royal Statistical
#' Society B}, \bold{37}, 149-163.
#' 
#' Percival, D. B., and A. T. Walden (1993) \emph{Spectral Analysis for
#' Physical Applications: Multitaper and Conventional Univariate Techniques},
#' Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' data(mexm)
#' J <- 6
#' wf <- "la8"
#' mexm.dwpt <- dwpt(mexm[-c(1:4)], wf, J)
#' ## Not implemented yet
#' ## plot.dwpt(x.dwpt, J)
#' mexm.dwpt.bw <- dwpt.brick.wall(mexm.dwpt, wf, 6, method="dwpt")
#' mexm.tree <- ortho.basis(portmanteau.test(mexm.dwpt.bw, p=0.025))
#' ## Not implemented yet
#' ## plot.basis(mexm.tree)
#'
css.test <- function(y) 
{
  K <- length(y)
  test <- numeric(K)

  for(k in 1:K) {
    x <- y[[k]]
    x <- x[!is.na(x)]
    n <- length(x)
    plus <- 1:n/(n - 1) - cumsum(x^2)/sum(x^2)
    minus <- cumsum(x^2)/sum(x^2) - 0:(n - 1)/(n - 1)
    D <- max(abs(plus), abs(minus))
    if(D < 1.224/(sqrt(n) + 0.12 + 0.11/sqrt(n))) test[k] <- 1
  }
  return(test)
}

entropy.test <- function(y)
{
  K <- length(y)
  test <- numeric(K)

  for(k in 1:K) {
    x <- y[[k]]
    test[k] <- sum(x^2 * log(x^2), na.rm=TRUE)
  }
  return(test)
}

cpgram.test <- function(y, p=0.05, taper=0.1)
{
  K <- length(y)
  test <- numeric(K)
  
  for(k in 1:K) {
    x <- y[[k]]
    x <- x[!is.na(x)]
    x <- spec.taper(scale(x, center=TRUE, scale=FALSE), p=taper)
    y <- Mod(fft(x))^2/length(x)
    y[1] <- 0
    n <- length(x)
    x <- (0:(n/2))/n
    if(length(x) %% 2 == 0) {
      n <- length(x) - 1
      y <- y[1:n]
      x <- x[1:n]
    }
    else y <- y[1:length(x)]
    mp <- length(x) - 1
    if(p == 0.05)
      crit <- 1.358/(sqrt(mp) + 0.12 + 0.11/sqrt(mp))
    else {
      if(p == 0.01) crit <- 1.628/(sqrt(mp) + 0.12 + 0.11/sqrt(mp))
      else stop("critical value is not known")
    }
    D <- abs(cumsum(y)/sum(y) -  0:mp/mp)
    if(max(D) < crit) test[k] <- 1
  }
  return(test)
}

portmanteau.test <- function(y, p = 0.05, type = "Box-Pierce")
{
  K <- length(y)
  test <- numeric(K)

  for(k in 1:K) {
  x <- y[[k]]
  x <- x[!is.na(x)]
  n <- length(x)
  h <- trunc(n/2)
  x.acf <- my.acf(x)[1:(h+1)]
  x.acf <- x.acf / x.acf[1];
  if(type == "Box-Pierce")
    test[k] <- ifelse(n * sum((x.acf[-1])^2) > qchisq(1-p, h), 0, 1)
  else 
    test[k] <- ifelse(n*(n+2) * sum((x.acf[-1])^2 / (n - h:1)) > 
                      qchisq(1-p, h), 0, 1)
  }
  return(test)
}

      SUBROUTINE DPSS(NMAX, KMAX, N, W, V, SIG, TOTIT, SINES, VOLD,   
     * U, SCR1, IFAULT)
C
C  CALCULATES DISCRETE PROLATE SPHEROIDAL SEQUENCES FOR USE AS DATA
C  TAPERS.
C
C  FORTRAN 77 
C
C  SUBMITTED BY BRAD BELL, DON PERCIVAL AND ANDREW WALDEN.
C  Comments/queries to
C  dbp@apl.washington.edu  OR  a.walden@ic.ac.uk
C
C  This software may be freely used for non-commercial purposes and can
C  be freely distributed.
C
C  Equation numbers and comments refer to the article:
C
C  Bell, B., Percival, D.B. and Walden, A.T. "Calculating Thomson's
C    Spectral Multitapers by Inverse Iteration", J. Comput. and Graph.
C    Stat., 1993.
C
C  Calls auxiliary routines SYTOEP and SPOL also given below.
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     NMAX    integer    input:  maximum possible length of taper
C
C     KMAX    integer    input:  dpss orders 0 to KMAX required
C
C     N       integer    input:  length of sequence to generate
C
C     W       real       input:  half-bandwidth, W < 1/2
C
C     V(NMAX, KMAX+1)       
C            real array output:  columns contain tapers
C
C     SIG(KMAX+1)
C            real array output:  eigenvalues are 1+SIG(j)
C
C     TOTIT   integer   output:  total number of iterations
C
C     SINES(0:N-1)
C            real array          work array
C
C     VOLD(N) real array         work array
C
C     U(N)    real array         work array
C
C     SCR1(N) real array         work array
C
C     IFAULT  integer   output:   0 indicates success
C                                 1 if W > 1/2
C                                 2 if N < 2
C                                 3 if NMAX < N; matrix too small
C                                 4 if KMAX < 0
C                                 5 failure in SYTOEP
C                                 6 > MAXIT its required for some order
C                                 (Output values are undefined for
C                                 IFAULT in the range 1 to 5.)
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      INTEGER J, K, K1, KMAX, M, N, TOTIT, ISIG, ILOW,
     *  IHIG, IT, MAXIT, IFAIL, IFAULT
      DOUBLE PRECISION V(NMAX,0:KMAX), SIG(0:KMAX), U(N),  
     * VOLD(N), SINES(0:N-1), SCR1(N), ZERO, ONE, TWO, FOUR, 
     * EPS, DELTA, PI, W, ROOTN, PROJ, SNORM, SSNORM, DIFF,
     * SUM, HALF, RONE 
      DATA ZERO, HALF, ONE,TWO,FOUR,EPS
     * /0.0D0, 0.5D0, 1.0D0,2.0D0,4.0D0,0.5D-6/
C
C  initialize max number of iterations flag
C
      IFAIL=0 
C
C check input parameters
C      
      IFAULT=1  
      IF(W .GT. HALF) RETURN
      IFAULT=2
      IF(N .LT. 2) RETURN
      IFAULT=3
      IF(NMAX .LT. N) RETURN
      IFAULT=4
      IF(KMAX .LT. 0 .OR. KMAX .GT. N-1) RETURN
C
C  set up SINES so that S in eqn. (1) is given by
C  S(n,m)=SINES(n-m) for n not equal to m. 
C
      PI=FOUR*ATAN(ONE)
      DO 5 M=1,N-1
        SINES(M)=SIN(TWO*PI*W*M)/(PI*M)
 5    CONTINUE
C
C  set total iteration counter and constant
C
      TOTIT=0
      ROOTN=SQRT(FLOAT(N))
      RONE=ONE/ROOTN
C
C  major loop over dpss orders 0 to KMAX
C
C  modify SINES(0) so that B_k in Section 2.2 is given by
C  B_k(n,m)=SINES(n-m)
C
      DO 200 K=0,KMAX
         IF(K .EQ. 0) THEN
              SINES(0)=TWO*W-ONE
         ELSE
              SINES(0)=TWO*W-(ONE+SIG(K-1))
         END IF
C
C  define suitable starting vector for inverse iteration;
C  see Section 2.2.
C
         ISIG=1
         K1=K+1
         DO 15 J=1, K1
                   ILOW=((J-1)*N/K1)+1
                   IHIG=(J*N/K1)
                   DO 20 JJ=ILOW,IHIG
                        U(JJ)=ISIG*RONE
 20                CONTINUE
                   ISIG=ISIG*(-1)
 15      CONTINUE
         IF(MOD(K,2).GT.0 .AND. MOD(N,2).GT.0) U((N/2)+1)=ZERO
C
C  maximum number of iterations
C
         MAXIT=(K+3)*ROOTN 
         IT=0
C
C  carry out inverse iteration
C
         DO 180 IT=1,MAXIT
C
C  copy U into old V; VOLD = previous iterate
C
         DO 50 J=1,N
 50        VOLD(J)=U(J)
C
C  solve symmetric Toeplitz matrix equation B_k*U=VOLD for U
C
         CALL SYTOEP(N, SINES, VOLD, U, SCR1, IFAIL)
C
C  check no problems 
C 
         IFAULT=5
         IF(IFAIL .NE. 0) RETURN
C
C  new vector must be orthogonal to previous eigenvectors
C
         IF(K .GT. 0) THEN
              DO 80 K1=0,K-1
C
C  projection of U onto V(*,K1):
C
              PROJ=ZERO
              DO 85 J=1,N
 85             PROJ=PROJ + U(J)*V(J,K1)
C
C subtract projection
C
                DO 90 J=1,N
 90               U(J)=U(J) - PROJ*V(J,K1)
C
 80           CONTINUE
         END IF
C
C  normalize
C
         SNORM=ZERO
         DO 100 J=1,N
100        SNORM=SNORM+U(J)*U(J)
         SSNORM=SQRT(SNORM)
         DO 105 J=1,N
105               U(J)=U(J)/SSNORM
C
C  check for convergence
C
         SUM=ZERO
         DIFF=ZERO
         DO 120 J=1,N
C         
C  first previous-current:
C
           DIFF=DIFF+(VOLD(J)-U(J))**2
C
C  next, previous+current
C            
 120     SUM=SUM+(VOLD(J)+U(J))**2
         DELTA=SQRT(MIN(DIFF,SUM))
         IF(DELTA .LE. EPS) GOTO 190
180      CONTINUE
C
C  if here, max number of iterations exceeded for this order dpss
C  
         IT=MAXIT
         IFAIL=1
190      CONTINUE
         TOTIT=TOTIT+IT
         IF(SUM .LT. DIFF) THEN
               IF(K .EQ. 0) THEN
                    SIG(0)= - ONE/SSNORM
               ELSE
                    SIG(K)=SIG(K-1) - ONE/SSNORM
               END IF
         ELSE
               IF(K .EQ. 0) THEN
                    SIG(0)= ONE/SSNORM
               ELSE
                    SIG(K)=SIG(K-1) + ONE/SSNORM
               END IF
         END IF
C
C  ensure tapers satisfy Slepian convention
C         
         CALL SPOL(N, U, K, IFAULT)
         DO 220 J=1,N
220        V(J,K)=U(J)
C
200   CONTINUE
C
C   if one order of dpss did not converge set IFAULT to 6
C
      IFAULT=0
      IF( IFAIL .EQ. 1) IFAULT=6 
      RETURN
      END


      SUBROUTINE SYTOEP(N, R, G, F, W, IFAULT)
C
C  FINDS FILTER CORRESPONDING TO A SYMMETRIC TOEPLITZ MATRIX
C  WITH FIRST ROW R(.) AND CROSSCORRELATION VECTOR G(.)
C
C  I.E., "R" F = G
C
C  To be used with DPSS and SPOL. See
C  Bell, B., Percival, D.B. and Walden, A.T. "Calculating Thomson's
C    Spectral Multitapers by Inverse Iteration", J. Comput. and Graph.
C    Stat., 1993.
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     N       integer    input:  dimension of Toeplitz matrix and
C                                 cross-correlation vector
C
C     R(N)    real       input:  autocovariances from lag 0 to N-1
C
C     G(N)    real       input:  cross-correlation vector
C
C     F(N)    real      output:  required filter
C
C     W(N)    real       input:  work array
C
C     IFAULT  integer   output:  0 indicates successful
C                                1 if N < 1
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   THIS PROGRAM IS A SUBSTANTIALLY CORRECTED AND MODIFIED VERSION OF 
C   "EUREKA" IN ROBINSON, E.A. (1967) MULTICHANNEL TIME SERIES ANALYSIS 
C   WITH DIGITAL COMPUTER PROGRAMS, HOLDEN-DAY.
C
C
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DOUBLE PRECISION R(0:N-1), G(N), F(N), W(N), V, D, Q,
     *  HOLD, ZERO, ONE
      DATA ZERO,ONE /0.0D0,1.0D0/
C
C  check for special "matrix" sizes
C
      IFAULT=1
      IF(N .LT. 1) RETURN
      V=R(0)
      F(1)=G(1)/V
      IFAULT=0
      IF(N .EQ. 1) RETURN
C
      D=R(1)
      W(1)=ONE
      Q=F(1)*R(1)
      DO 5 L=2,N
        W(L)=-D/V
        IF(L .GT. 2) THEN
             L1=(L-2)/2
             L2=L1+1
             IF(L .NE. 3) THEN
                  DO 10 J=2,L2
                  HOLD=W(J)
                  K=L-J+1
                  W(J)=W(J)+W(L)*W(K)
 10               W(K)=W(K)+W(L)*HOLD
             END IF
             IF((2*L1 .NE. L-2) .OR. L .EQ. 3) W(L2+1)=
     *       W(L2+1)+W(L)*W(L2+1)
        END IF
      V=V+W(L)*D
      F(L)=(G(L)-Q)/V
      L3=L-1
      DO 15 J=1,L3
           K=L-J+1
 15   F(J)=F(J)+F(L)*W(K)
      IF(L .EQ. N) RETURN
      D=ZERO
      Q=ZERO
      DO 5 I=1,L
          K=L-I+2
          D=D+W(I)*R(K-1)
  5   Q=Q+F(I)*R(K-1)
      RETURN
      END



      SUBROUTINE SPOL(N, V, K, IFAULT)
C
C  SCALES THE DISCRETE PROLATE SPHEROIDAL SEQUENCE AND SETS THE 
C  POLARITY TO AGREE WITH SLEPIAN'S CONVENTION.
C
C  To be used with DPSS and SYTOEP. See
C  Bell, B., Percival, D.B. and Walden, A.T. "Calculating Thomson's
C    Spectral Multitapers by Inverse Iteration", J. Comput. and Graph.
C    Stat., 1993. (Section 1.2.)
C
C  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C  N      Integer             input        length of dpss sequence
C
C  V      Real(N)             input        eigenvector (dpss) with unit energy
C                            output        unit energy dpss conforming to
C                                          Slepian's polarity convention
C
C  K      Integer             input        the order of the dpss 0=<K=<N-1
C
C  IFAULT Integer            output        0 indicates successful
C                                          1 indicates N < 1
C
C  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      INTEGER N, I, L, K, IFAULT
      DOUBLE PRECISION V(N), RN, STD, DSUM, DWSUM, ZERO, ONE, 
     * TWO, ZFLOAT
C
      DATA ZERO, ONE, TWO/0.0D0, 1.0D0, 2.0D0/
C
C
      IFAULT=1
      IF(N .LT. 1) RETURN
      IFAULT=0
      RN=DBLE(N)
      DSUM=ZERO
      DWSUM=ZERO
      DO 5 L=1,N
        DSUM=DSUM+V(L)
  5   DWSUM=DWSUM+V(L)*(RN-ONE-TWO*DBLE(L-1))
      IF(((MOD(K,2).EQ.0).AND.(DSUM.LT.ZERO)).OR.
     *     ((MOD(K,2).EQ.1).AND.(DWSUM.LT.ZERO))) THEN
      DO 10 L=1,N
 10          V(L)=-V(L)
      END IF
      RETURN
      END

#' Upsampling of a vector
#' 
#' Upsamples a given vector.
#' 
#' 
#' @param x vector of observations
#' @param f frequency of upsampling; e.g, 2, 4, etc.
#' @param y value to upsample with; e.g., NA, 0, etc.
#' @return A vector twice its length.
#' @author B. Whitcher
#' @references Any basic signal processing text.
#' @keywords ts
#' @export up.sample
up.sample <- function(x, f, y=NA) {
  n <- length(x)
  as.vector(rbind(x, matrix(rep(y, (f-1)*n), nrow=f-1)))
}

#' Wavelet-based Maximum Likelihood Estimation for Seasonal Persistent
#' Processes
#' 
#' Parameter estimation for a seasonal persistent (seasonal long-memory)
#' process is performed via maximum likelihood on the wavelet coefficients.
#' 
#' The variance-covariance matrix of the original time series is approximated
#' by its wavelet-based equivalent.  A Whittle-type likelihood is then
#' constructed where the sums of squared wavelet coefficients are compared to
#' bandpass filtered version of the true spectral density function.
#' Minimization occurs for the fractional difference parameter \eqn{d} and the
#' Gegenbauer frequency \eqn{f_G}, while the innovations variance is
#' subsequently estimated.
#' 
#' @usage spp.mle(y, wf, J = log(length(y), 2) - 1, p = 0.01, frac = 1)
#' @usage spp2.mle(y, wf, J = log(length(y), 2) - 1, p = 0.01, dyadic = TRUE, frac = 1)
#' @aliases spp.mle spp2.mle
#' @param y Not necessarily dyadic length time series.
#' @param wf Name of the wavelet filter to use in the decomposition.  See
#' \code{\link{wave.filter}} for those wavelet filters available.
#' @param J Depth of the discrete wavelet packet transform.
#' @param p Level of significance for the white noise testing procedure.
#' @param dyadic Logical parameter indicating whether or not the original time
#' series is dyadic in length.
#' @param frac Fraction of the time series that should be used in constructing
#' the likelihood function.
#' @return List containing the maximum likelihood estimates (MLEs) of
#' \eqn{\delta}, \eqn{f_G} and \eqn{\sigma^2}, along with the value of the
#' likelihood for those estimates.
#' @author B. Whitcher
#' @seealso \code{\link{fdp.mle}}
#' @references Whitcher, B. (2004) Wavelet-based estimation for seasonal
#' long-memory processes, \emph{Technometrics}, \bold{46}, No. 2, 225-238.
#' @keywords ts
#' @export spp.mle
spp.mle <- function(y, wf, J=log(length(y),2)-1, p=0.01, frac=1)
{
  sppLL <- function(x, y) {
    delta <- x[1]
    fG <- x[2]

    ## cat("Parameters are: d =", delta, ", and f =", fG, fill=TRUE)
    
    y.dwpt <- y[[1]]
    y.basis <- y[[2]]
    n <- y[[3]]
    J <- y[[4]]
    
    ## Establish the limits of integration for the band-pass variances
    a <- unlist(apply(matrix(2^(1:J)-1), 1, seq, from=0, by=1)) / 
      2^(rep(1:J, 2^(1:J))) / 2
    b <- unlist(apply(matrix(2^(1:J)), 1, seq, from=1, by=1)) / 
      2^(rep(1:J, 2^(1:J))) / 2
    
    ## Define some useful parameters for the wavelet packet tree
                                        # n <- length(y)
    length.jn <- n / rep(2^(1:J), 2^(1:J))
    scale.jn <- rep(2^(1:J+1), 2^(1:J))
    
    ## Initialize various parameters for the reduced LL
    Basis <- (1:length(y.basis))[y.basis]
    bp.var <- numeric(length(Basis))
    delta.n <- 100

    ## Compute the band-pass variances according to \delta and f_G
    omega.diag <- NULL
    for(i in 1:sum(y.basis)) {
      jn <- Basis[i]
      bp.var[i] <- bandpass.spp(a[jn], b[jn], delta, fG)
      omega.diag <- c(omega.diag,
                      scale.jn[jn] * rep(bp.var[i], length.jn[jn]))
    }
    
    ## Compute reduced log-likelihood 
    rLL <- n * log(1/n * sum(y.dwpt^2 / omega.diag, na.rm=TRUE)) +
      sum(length.jn[y.basis] * log(scale.jn[y.basis] * bp.var))
    rLL
  }
  
  n <- length(y)
  x0 <- numeric(2)

  ## Perform discrete wavelet packet transform (DWPT) on Y
  y.dwpt <- dwpt(y, wf, n.levels=J)
  n <- length(y)
  if(frac < 1) {
    for(i in 1:length(y.dwpt)) {
      vec <- y.dwpt[[i]]
      ni <- length(vec)
      j <- rep(1:J, 2^(1:J))[i]
      vec[trunc(frac * n/2^j):ni] <- NA
      y.dwpt[[i]] <- vec
    }
  }
  y.basis <- as.logical(ortho.basis(portmanteau.test(y.dwpt, p)))
  y.dwpt <- as.matrix(unlist(y.dwpt[y.basis]))

  ## Compute initial estimate of the Gegenbauer frequency
  y.per <- per(y - mean(y))
  x0[2] <- (0:(n/2)/n)[max(y.per) == y.per]

  ## Compute initial estimate of the fractional difference parameter
  muJ <- (unlist(apply(matrix(2^(1:J)-1), 1, seq, from=0, by=1)) / 
          2^(rep(1:J, 2^(1:J))) + 
          unlist(apply(matrix(2^(1:J)), 1, seq, from=1, by=1)) /  
          2^(rep(1:J, 2^(1:J)))) / 4
  y.modwpt <- modwpt(y, wf=wf, n.levels=J)
  y.varJ <- rep(2^(1:J), 2^(1:J)) *
    unlist(lapply(y.modwpt,
                  FUN=function(x)sum(x*x,na.rm=TRUE)/length(x[!is.na(x)])))
  x0[1] <- min(-0.5 * lsfit(log(abs(muJ[y.basis] - x0[2])), 
                            log(y.varJ[y.basis]))$coef[2], 0.49)

  cat(paste("Initial parameters are: delta =", round(x0[1],4), 
            "freqG =", round(x0[2],4), "\n"))
  result <- optim(par=x0, fn=sppLL, method="L-BFGS-B",
                  lower=c(0.001,0.001), upper=c(0.499,0.499),
                  control=list(trace=0, fnscale=2),
                  y=list(y.dwpt, y.basis, n, J))
  return(result)
}

spp2.mle <- function(y, wf, J=log(length(y),2)-1, p=0.01,
                     dyadic=TRUE, frac=1)
{

  spp2LL <- function(x, y) {
    d1 <- x[1]
    f1 <- x[2]
    d2 <- x[3]
    f2 <- x[4]
    ## cat("Parameters are: d1 =", round(d1,6), ", and f1 =", round(f1,6),
    ##     ", d2 =", round(d2,6), ", and f2 =", round(f2,6), fill=TRUE)

    y.dwpt <- y[[1]]
    y.basis <- y[[2]]
    n <- y[[3]]
    J <- y[[4]]

    ## Establish the limits of integration for the band-pass variances
    a <- unlist(apply(matrix(2^(1:J)-1), 1, seq, from=0, by=1)) / 
      2^(rep(1:J, 2^(1:J))) / 2
    b <- unlist(apply(matrix(2^(1:J)), 1, seq, from=1, by=1)) / 
      2^(rep(1:J, 2^(1:J))) / 2
    
    ## Define some useful parameters for the wavelet packet tree
    length.jn <- n / rep(2^(1:J), 2^(1:J))
    scale.jn <- rep(2^(1:J+1), 2^(1:J))
    
    ## Initialize various parameters for the reduced LL
    Basis <- (1:length(y.basis))[y.basis]
    bp.var <- numeric(length(Basis))
    delta.n <- 100

    ## Compute the band-pass variances according to \delta and f_G
    omega.diag <- NULL
    for(i in 1:sum(y.basis)) {
      jn <- Basis[i]
      bp.var[i] <- bandpass.spp2(a[jn], b[jn], d1, f1, d2, f2)
      omega.diag <- c(omega.diag,
                      scale.jn[jn] * rep(bp.var[i], length.jn[jn]))
    }
    
    ## Compute reduced log-likelihood 
    n * log(1/n * sum(y.dwpt^2 / omega.diag, na.rm=TRUE)) +
      sum(length.jn[y.basis] * log(scale.jn[y.basis] * bp.var), na.rm=TRUE)
  }

  n <- length(y)
  x0 <- numeric(4)

  ## Perform discrete wavelet packet transform (DWPT) on Y
  y.dwpt <- dwpt(y, wf, n.levels=J)
  if(!dyadic) {
    for(i in 1:length(y.dwpt)) {
      vec <- y.dwpt[[i]]
      ni <- length(vec)
      j <- rep(1:J, 2^(1:J))[i]
      vec[trunc(frac * n/2^j):ni] <- NA
      y.dwpt[[i]] <- vec
    }
  }
  y.basis <- as.logical(ortho.basis(portmanteau.test(y.dwpt, p, type="other")))
  y.dwpt <- as.vector(unlist(y.dwpt[y.basis]))

  ## Compute initial estimate of the Gegenbauer frequencies
  if(dyadic)
    y.per <- per(y - mean(y))
  else
    y.per <- per(y[1:(frac*n)] - mean(y[1:(frac*n)]))
  freq.y <- (0:(frac*n %/% 2))/(frac*n)
  x0[2] <- freq.y[max(y.per) == y.per]
  x0[4] <- freq.y[max(y.per[freq.y > x0[2] + freq.y[10] | 
    freq.y < x0[2] - freq.y[10]]) == y.per]
  if(x0[2] > x0[4]) {
    xx <- x0[2]
    x0[2] <- x0[4]
    x0[4] <- xx
    rm(xx)
  }

  ## Compute initial estimate of the fractional difference parameters
  muJ <- (unlist(apply(matrix(2^(1:J)-1), 1, seq, from=0, by=1)) / 
      2^(rep(1:J, 2^(1:J))) + 
      unlist(apply(matrix(2^(1:J)), 1, seq, from=1, by=1)) /  
      2^(rep(1:J, 2^(1:J)))) / 4
  y.modwpt <- modwpt(y, wf=wf, n.levels=J)
  y.varJ <- rep(2^(1:J), 2^(1:J)) *
    unlist(lapply(y.modwpt,
                  FUN = function(x) sum(x*x,na.rm=TRUE)/length(x[!is.na(x)])))
  x0.mid <- (x0[2] + x0[4]) / 2
  muJ <- muJ[y.basis]
  y.varJ <- y.varJ[y.basis]
  x0[1] <- min(-0.5 * lsfit(log(abs(muJ[muJ < x0.mid] - x0[2])), 
                            log(y.varJ[muJ < x0.mid]))$coef[2], 0.49)
  x0[3] <- min(-0.5 * lsfit(log(abs(muJ[muJ > x0.mid] - x0[4])), 
                            log(y.varJ[muJ > x0.mid]))$coef[2], 0.49)

  cat(paste("Initial parameters: d1 = ", round(x0[1],4), 
            ", f1 = ", round(x0[2],4), ", d2 = ", round(x0[3],4), 
            ", f2 = ", round(x0[4],4), sep=""), fill=TRUE)
  result <- optim(par=x0, fn=spp2LL, method="L-BFGS-B",
                  lower=rep(0.001,4), upper=rep(0.499,4),
                  control=list(trace=1, fnscale=2),
                  y=list(y.dwpt, y.basis, n, J))
  return(result)
}

#' Circularly Shift Matrices from a 2D MODWT
#' 
#' Compute phase shifts for wavelet sub-matrices based on the ``center of
#' energy'' argument of Hess-Nielsen and Wickerhauser (1996).
#' 
#' The "center of energy" technique of Wickerhauser and Hess-Nielsen (1996) is
#' employed to find circular shifts for the wavelet sub-matrices such that the
#' coefficients are aligned with the original series.  This corresponds to
#' applying a (near) linear-phase filtering operation.
#' 
#' @param z Two-dimensional MODWT object
#' @param inverse Boolean value on whether to perform the forward or inverse
#' operation.
#' @return Two-dimensional MODWT object with circularly shifted coefficients.
#' @author B. Whitcher
#' @seealso \code{\link{phase.shift}}, \code{\link{modwt.2d}}.
#' @references Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
#' time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
#' 523-540.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @examples
#' 
#' n <- 512
#' G1 <- G2 <- dnorm(seq(-n/4, n/4, length=n))
#' G <- 100 * zapsmall(outer(G1, G2))
#' G <- modwt.2d(G, wf="la8", J=6)
#' k <- 50
#' xr <- yr <- trunc(n/2) + (-k:k)
#' par(mfrow=c(3,3), mar=c(1,1,2,1), pty="s")
#' for (j in names(G)[1:9]) {
#'   image(G[[j]][xr,yr], col=rainbow(64), axes=FALSE, main=j)
#' }
#' Gs <- shift.2d(G)
#' for (j in names(G)[1:9]) {
#'   image(Gs[[j]][xr,yr], col=rainbow(64), axes=FALSE, main=j)
#' }
#' 
#' @export shift.2d
shift.2d <- function(z, inverse=FALSE) {
  ## "Center of Energy"
  coe <- function(g) { 
    sum(0:(length(g)-1) * g^2) / sum(g^2)
  }

  wf <- attributes(z)$wavelet
  h <- wave.filter(wf)$hpf
  g <- wave.filter(wf)$lpf
  
  J <- (length(z) - 1) / 3
  m <- nrow(z[[1]])
  n <- ncol(z[[1]])
  
  nu.H <- round(2^(1:J-1) * (coe(g) + coe(h)) - coe(g), 0)
  nu.Hm <- ifelse(nu.H/m < 1, nu.H, nu.H - trunc(nu.H/m) * m)
  nu.Hn <- ifelse(nu.H/n < 1, nu.H, nu.H - trunc(nu.H/n) * n)
  nu.G <- round((2^(1:J) - 1) * coe(g), 0)
  nu.Gm <- ifelse(nu.G/m < 1, nu.G, nu.G - trunc(nu.G/m) * m)
  nu.Gn <- ifelse(nu.G/n < 1, nu.G, nu.G - trunc(nu.G/n) * n)
  
  if (!inverse) {
    ## Apply the phase shifts
    for (j in 0:(J-1)) {
      Hm.order <- c((nu.H[j+1]+1):m, 1:nu.H[j+1])
      Hn.order <- c((nu.H[j+1]+1):n, 1:nu.H[j+1])
      Gm.order <- c((nu.G[j+1]+1):m, 1:nu.G[j+1])
      Gn.order <- c((nu.G[j+1]+1):n, 1:nu.G[j+1])
      z[[3*j+1]] <- z[[3*j+1]][Gm.order, Hn.order]
      z[[3*j+2]] <- z[[3*j+2]][Hm.order, Gn.order]
      z[[3*j+3]] <- z[[3*j+3]][Hm.order, Hn.order]
    } 
    z[[3*J+1]] <- z[[3*J+1]][Gm.order, Gn.order]
  } else {
    ## Apply the phase shifts "reversed"
    for (j in 0:(J-1)) {
      Hm.order <- c((m-nu.H[j+1]+1):m, 1:(m-nu.H[j+1]))
      Hn.order <- c((n-nu.H[j+1]+1):n, 1:(n-nu.H[j+1]))
      Gm.order <- c((m-nu.G[j+1]+1):m, 1:(m-nu.G[j+1]))
      Gn.order <- c((n-nu.G[j+1]+1):n, 1:(n-nu.G[j+1]))
      z[[3*j+1]] <- z[[3*j+1]][Gm.order, Hn.order]
      z[[3*j+2]] <- z[[3*j+2]][Hm.order, Gn.order]
      z[[3*j+3]] <- z[[3*j+3]][Hm.order, Hn.order]
    }
    z[[3*J+1]] <- z[[3*J+1]][Gm.order, Gn.order]
  }
  return(z)
}

#' Autocovariance and Autocorrelation Sequences for a Seasonal Persistent
#' Process
#' 
#' The autocovariance and autocorrelation sequences from the time series model
#' in Figures 8, 9, 10, and 11 of Andel (1986).  They were obtained through
#' numeric integration of the spectral density function.
#' 
#' @usage data(acvs.andel8)
#' @usage data(acvs.andel9)
#' @usage data(acvs.andel10)
#' @usage data(acvs.andel11)
#' @name acvs.andel8
#' @docType data
#' @aliases acvs.andel9 acvs.andel10 acvs.andel11
#' @format A data frame with 4096 rows and three columns: lag, autocovariance
#' sequence, autocorrelation sequence.
#' @references Andel, J. (1986) Long memory time series models,
#' \emph{Kypernetika}, \bold{22}, No. 2, 105-123.
#' @keywords datasets
NULL

#' Simulated AR(1) Series
#' 
#' Simulated AR(1) series used in Gencay, Selcuk and Whitcher (2001).
#' 
#' @usage data(ar1)
#' @name ar1
#' @docType data
#' @format A vector containing 200 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @keywords datasets
NULL

#' Barbara Test Image
#' 
#' The Barbara image comes from Allen Gersho's lab at the University of
#' California, Santa Barbara.
#' 
#' @usage data(barbara)
#' @name barbara
#' @docType data
#' @format A 256 \eqn{\times}{x} 256 matrix.
#' @source Internet.
#' @keywords datasets
NULL

#' A Piecewise-Constant Function
#' 
#' \deqn{blocks(x) = \sum_{j=1}^{11}(1 + {\rm sign}(x-p_j)) h_j / 2}{%
#' blocks(x) = sum[j=1,11] (1 + sign(x - p_j)) h_j/2}
#' 
#' @usage data(blocks)
#' @name blocks
#' @docType data
#' @format A vector containing 512 observations.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' U.S. Consumer Price Index
#' 
#' Monthly U.S. consumer price index from 1948:1 to 1999:12.
#' 
#' @usage data(cpi)
#' @name cpi
#' @docType data
#' @format A vector containing 624 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @source Unknown.
#' @keywords datasets
NULL

#' Digital Photograph of Ingrid Daubechies
#' 
#' A digital photograph of Ingrid Daubechies taken at the 1993 AMS winter
#' meetings in San Antonio, Texas.  The photograph was taken by David Donoho
#' with a Canon XapShot video still frame camera.
#' 
#' @usage data(dau)
#' @name dau
#' @docType data
#' @format A 256 \eqn{\times}{x} 256 matrix.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' Sinusoid with Changing Amplitude and Frequency
#' 
#' \deqn{doppler(x) = \sqrt{x(1 - x)} }{% doppler(x) = sqrt{x(1-x)}
#' sin[(2.1*pi)/(x+0.05)]}\deqn{ \sin\left(\frac{2.1\pi}{x+0.05}\right)}{%
#' doppler(x) = sqrt{x(1-x)} sin[(2.1*pi)/(x+0.05)]}
#' 
#' @usage data(doppler)
#' @name doppler
#' @docType data
#' @format A vector containing 512 observations.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' Exchange Rates Between the Deutsche Mark, Japanese Yen and U.S. Dollar
#' 
#' Monthly foreign exchange rates for the Deutsche Mark - U.S. Dollar (DEM-USD)
#' and Japanese Yen - U.S. Dollar (JPY-USD) starting in 1970.
#' 
#' @usage data(exchange)
#' @name exchange
#' @docType data
#' @format A bivariate time series containing 348 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @source Unknown.
#' @keywords datasets
NULL

#' Sine with Jumps at 0.3 and 0.72
#' 
#' \deqn{heavisine(x) = 4\sin(4{\pi}x) - \mathrm{sign}(x-0.3) - }{%
#' heavisine(x) = 4*sin(4*pi*x) - sign(x-0.3) - sign(0.72-x)}\deqn{
#' \mathrm{sign}(0.72-x)}{% heavisine(x) = 4*sin(4*pi*x) - sign(x-0.3) -
#' sign(0.72-x)}
#' 
#' @usage data(heavisine)
#' @name heavisine
#' @docType data
#' @format A vector containing 512 observations.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' Daily IBM Stock Prices
#' 
#' Daily IBM stock prices spanning May~17, 1961 to November~2, 1962.
#' 
#' @usage data(ibm)
#' @name ibm
#' @docType data
#' @format A vector containing 369 observations.
#' @source Box, G. E.P. and Jenkins, G. M. (1976) \emph{Time Series Analysis:
#' Forecasting and Control}, Holden Day, San Francisco, 2nd edition.
#' @keywords datasets
NULL

#' Japanese Gross National Product
#' 
#' Quarterly Japanese gross national product from 1955:1 to 1996:4.
#' 
#' @usage data(japan)
#' @name japan
#' @docType data
#' @format A vector containing 169 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Hecq, A. (1998) Does seasonal adjustment induce common cycles?,
#' \emph{Empirical Economics}, \bold{59}, 289-297.
#' @source Unknown.
#' @keywords datasets
NULL

#' Sine with Jumps at 0.625 and 0.875
#' 
#' \deqn{jumpsine(x) = 10\left( \sin(4{\pi}x) +
#' I_{[0.625 < x \leq 0.875]}\right)}{%
#' jumpsine(x) = 10*(sin(4*pi*x) + I_[0.625 < x <= 0.875])}
#' 
#' @usage data(jumpsine)
#' @name jumpsine
#' @docType data
#' @format A vector containing 512 observations.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' 1995 Kobe Earthquake Data
#' 
#' Seismograph (vertical acceleration, nm/sq.sec) of the Kobe earthquake,
#' recorded at Tasmania University, HobarTRUE, Australia on 16 January 1995
#' beginning at 20:56:51 (GMTRUE) and continuing for 51 minutes at 1 second
#' intervals.
#' 
#' @usage data(kobe)
#' @name kobe
#' @docType data
#' @format A vector containing 3048 observations.
#' @source Data management centre, Washington University.
#' @keywords datasets
NULL

#' Linear Chirp
#' 
#' \deqn{linchirp(x) = \sin(0.125 \pi n x^2)}{% 
#' linchirp(x) = sin(0.125*pi*n*x^2)}
#' 
#' @usage data(linchirp)
#' @name linchirp
#' @docType data
#' @format A vector containing 512 observations.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' Mexican Money Supply
#' 
#' Percentage changes in monthly Mexican money supply.
#' 
#' @usage data(mexm)
#' @name mexm
#' @docType data
#' @format A vector containing 516 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @source Unknown.
#' @keywords datasets
NULL

#' Nile River Minima
#' 
#' Yearly minimal water levels of the Nile river for the years 622 to 1281,
#' measured at the Roda gauge near Cairo (Tousson, 1925, p. 366-385). The data
#' are listed in chronological sequence by row.
#' 
#' The original Nile river data supplied by Beran only contained only 500
#' observations (622 to 1121).  However, the book claimed to have 660
#' observations (622 to 1281).  The remaining observations from the book were
#' added, by hand, but the series still only contained 653 observations (622 to
#' 1264).
#' 
#' Note, now the data consists of 663 observations (spanning the years
#' 622-1284) as in original source (Toussoun, 1925).
#' 
#' @usage data(nile)
#' @name nile
#' @docType data
#' @format A length 663 vector.
#' @references Beran, J. (1994) \emph{Statistics for Long-Memory Processes},
#' Chapman Hall: Englewood, NJ.
#' @source Toussoun, O. (1925) M\'emoire sur l'Histoire du Nil, Volume 18 in
#' \emph{M\'emoires a l'Institut d'Egypte}, pp. 366-404.
#' @keywords datasets
NULL

#' U.S. Tourism
#' 
#' Quarterly U.S. tourism figures from 1960:1 to 1999:4.
#' 
#' @usage data(tourism)
#' @name tourism
#' @docType data
#' @format A vector containing 160 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @source Unknown.
#' @keywords datasets
NULL

#' U.S. Unemployment
#' 
#' Monthly U.S. unemployment figures from 1948:1 to 1999:12.
#' 
#' @usage data(unemploy)
#' @name unemploy
#' @docType data
#' @format A vector containing 624 observations.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' @source Unknown.
#' @keywords datasets
NULL

#' Image with Box and X
#' 
#' \deqn{xbox(i,j) = I_{[i=n/4,\;3n/4,\;j;~ n/4 \leq j \leq 3n/4]} + }{%
#' xbox(i,j) = I_[i = n/4, 3n/4, j; n/4 \leq j \leq 3n/4] + I_[n/4 \leq i \leq
#' 3n/4; j = n/4, 3n/4, i]}\deqn{ I_{[n/4 \leq i \leq 3n/4;~
#' j=n/4,\;3n/4,\;i]}}{% xbox(i,j) = I_[i = n/4, 3n/4, j; n/4 \leq j \leq 3n/4]
#' + I_[n/4 \leq i \leq 3n/4; j = n/4, 3n/4, i]}
#' 
#' @usage data(xbox)
#' @name xbox
#' @docType data
#' @format A 128 \eqn{\times}{x} 128 matrix.
#' @references Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
#' with S-PLUS}, Springer: New York.
#' @source S+WAVELETS.
#' @keywords datasets
NULL

#' Stack Plot
#' 
#' Stack plot of an object.  This function attempts to mimic a function called
#' \code{stack.plot} in S+WAVELETS.
#' 
#' Produces a set of plots, one for each element (column) of \code{x}.
#' 
#' @param x \code{ts} object
#' @param layout Doublet defining the dimension of the panel.  If not
#' specified, the dimensions are chosen automatically.
#' @param same.scale Vector the same length as the number of series to be
#' plotted.  If not specified, all panels will have unique axes.
#' @param plot.type,panel,log,col,bg,pch,cex,lty,lwd,ann,xlab,main,oma,... See
#' \code{plot.ts}.
#' @author B. Whitcher
#' @keywords hplot
#' @export stackPlot
stackPlot <-
  function (x, plot.type = c("multiple", "single"), panel = lines, 
    log = "", col = par("col"), bg = NA, pch = par("pch"), cex = par("cex"),
    lty = par("lty"), lwd = par("lwd"), ann = par("ann"), xlab = "Time",
    main = NULL, oma = c(6, 0, 5, 0), layout = NULL,
    same.scale = 1:dim(x)[2], ...) 
{
  addmain <- function(main, cex.main = par("cex.main"),
                      font.main = par("font.main"), 
                      col.main = par("col.main"), ...) {
    mtext(main, 3, 3, cex = cex.main, font = font.main, col = col.main, 
          ...)
  }
  plot.type <- match.arg(plot.type)
  panel <- match.fun(panel)
  nser <- NCOL(x)
  if (plot.type == "single" || nser == 1) {
    m <- match.call()
    m[[1]] <- as.name("plot.ts")
    m$plot.type <- "single"
    return(eval(m, parent.frame()))
  }
  if (nser > 10) 
    stop("Can't plot more than 10 series")
  if (is.null(main)) 
    main <- deparse(substitute(x))
  nm <- colnames(x)
  if (is.null(nm)) 
    nm <- paste("Series", 1:nser)
  nc <- if (nser > 4) 
    2
  else 1
  oldpar <- par("mar", "oma", "mfcol")
  on.exit(par(oldpar))
  par(mar = c(0, 5.1, 0, 2.1), oma = oma)
  nr <- ceiling(nser/nc)
  ## Begin added code
  if(!is.null(same.scale)) {
    unique.scales <- length(unique(same.scale))
    ylim <- vector("list", unique.scales)
    for (i in 1:unique.scales)
      ylim[[i]] <- range(x[, same.scale==i])
  }
  else
    for (i in 1:dim(x)[2])
      ylim[[i]] <- range(x[,i])
  if(is.null(layout))
    par(mfcol = c(nr, nc))
  else {
    par(mfcol = layout)
    nr <- layout[1]
  }
  ## End added code
  for (i in 1:nser) {
    plot(x[, i], axes = FALSE, xlab = "", ylab = "", log = log, 
         col = col, bg = bg, pch = pch, ann = ann, type = "n", 
         ylim=ylim[[same.scale[i]]], ...)
    panel(x[, i], col = col, bg = bg, pch = pch, ...)
    box()
    axis(2, xpd = NA)
    mtext(nm[i], 2, 3)
    if (i%%nr == 0 || i == nser) 
      axis(1, xpd = NA)
  }
  if (ann) {
    mtext(xlab, 1, 3, ...)
    if (!is.null(main)) {
      par(mfcol = c(1, 1))
      addmain(main, ...)
    }
  }
  invisible()
}

#' Discrete Hilbert Wavelet Transforms
#' 
#' The discrete Hilbert wavelet transforms (DHWTs) for seasonal and
#' time-varying time series analysis.  Transforms include the usual orthogonal
#' (decimated), maximal-overlap (non-decimated) and maximal-overlap packet
#' transforms.
#' 
#' @usage dwt.hilbert(x, wf, n.levels = 4, boundary = "periodic", ...)
#' @usage dwt.hilbert.nondyadic(x, ...) 
#' @usage idwt.hilbert(y)
#' @usage modwt.hilbert(x, wf, n.levels = 4, boundary = "periodic", ...)
#' @usage imodwt.hilbert(y)
#' @usage modwpt.hilbert(x, wf, n.levels = 4, boundary = "periodic")
#' @aliases dwt.hilbert dwt.hilbert.nondyadic idwt.hilbert modwt.hilbert
#' imodwt.hilbert modwpt.hilbert
#' @param x Real-valued time series or vector of observations.
#' @param wf Hilbert wavelet pair
#' @param n.levels Number of levels (depth) of the wavelet transform.
#' @param boundary Boundary treatment, currently only \code{periodic} and
#' \code{reflection}.
#' @param \ldots Additional parametes to be passed on.
#' @param y An object of S3 class \code{dwt.hilbert}.
#' @return Hilbert wavelet transform object (list).
#' @author B. Whitcher
#' @seealso \code{\link{hilbert.filter}}
#' @references Selesnick, I. (200X). \emph{IEEE Signal Processing Magazine}
#' 
#' Selesnick, I. (200X). \emph{IEEE Transactions in Signal Processing}
#' 
#' Whither, B. and P.F. Craigmile (2004). Multivariate Spectral Analysis Using
#' Hilbert Wavelet Pairs, \emph{International Journal of Wavelets,
#' Multiresolution and Information Processing}, \bold{2}(4), 567--587.
#' @keywords ts
dwt.hilbert <- function(x, wf, n.levels=4, boundary="periodic", ...) {
  switch(boundary,
         "reflection" =  x <- c(x, rev(x)),
         "periodic" = invisible(),
         stop("Invalid boundary rule in dwt.hilbert"))
  N <- length(x)
  J <- n.levels
  if(N/2^J != trunc(N/2^J)) 
    stop("Sample size is not divisible by 2^J")
  if(2^J > N) 
    stop("Wavelet transform exceeds sample size in dwt")

  dict <- hilbert.filter(wf)
  L <- dict$length; storage.mode(L) <- "integer"
  h0 <- dict$lpf[[1]]; storage.mode(h0) <- "double"
  g0 <- dict$lpf[[2]]; storage.mode(g0) <- "double"
  h1 <- dict$hpf[[1]]; storage.mode(h1) <- "double"
  g1 <- dict$hpf[[2]]; storage.mode(g1) <- "double"

  y <- vector("list", J+1)
  names(y) <- c(paste("d", 1:J, sep=""), paste("s", J, sep=""))
  x.h <- x.g <- x
  for(j in 1:J) {
    W <- V <- numeric(N/2^j)
    out.h <- .C(C_dwt, as.double(x.h), as.integer(N/2^(j-1)), L, h1, h0, 
                W = W, V = V)[6:7]
    out.g <- .C(C_dwt, as.double(x.g), as.integer(N/2^(j-1)), L, g1, g0, 
                W = W, V = V)[6:7]
    y[[j]] <- complex(real = out.h$W, imaginary = out.g$W)
    x.h <- out.h$V
    x.g <- out.g$V
  }
  y[[J+1]] <- complex(real = x.h, imaginary = x.g)
  attr(y, "wavelet") <- wf
  attr(y, "levels") <- n.levels
  attr(y, "boundary") <- boundary
  return(y)
}

########################################################################

dwt.hilbert.nondyadic <- function(x, ...) {
  M <- length(x)
  N <- 2^(ceiling(log(M, 2)))
  xx <- c(x, rep(0, N - M))
  y <- dwt.hilbert(xx, ...)
  
  J <- length(y) - 1
  for(j in 1:J) {
    y[[j]] <- y[[j]][1:trunc(M/2^j)]
  }

  return(y)
}

########################################################################

idwt.hilbert <- function(y) {
  switch(attributes(y)$boundary,
    "reflection" =  y <- c(y, rev(y)),
    "periodic" = invisible(),
    stop("Invalid boundary rule in dwt.dbp"))
  J <- attributes(y)$levels
 
  dict <- hilbert.filter(attributes(y)$wavelet)
  L <- dict$length; storage.mode(L) <- "integer"
  h <- dict$hpf; storage.mode(h) <- "double"
  g <- dict$lpf; storage.mode(g) <- "double"

  jj <- paste("s", J, sep="")
  X <- y[[jj]]
  for(j in J:1) {
    jj <- paste("d", j, sep="")
    XX <- numeric(2 * length(y[[jj]]))
    X <- .C(C_idwt, y[[jj]], as.double(X), as.integer(length(X)),
            L, h, g, XX=XX)$XX
  }
  return(X)
}

########################################################################

modwt.hilbert <- function(x, wf, n.levels=4, boundary="periodic", ...) {
  switch(boundary,
         "reflection" =  x <- c(x, rev(x)),
         "periodic" = invisible(),
         stop("Invalid boundary rule in modwt"))
  N <- length(x)
  storage.mode(N) <- "integer"
  J <- n.levels
  if(2^J > N) stop("wavelet transform exceeds sample size in modwt")

  dict <- hilbert.filter(wf)
  L <- dict$length; storage.mode(L) <- "integer"
  h0 <- dict$lpf[[1]] / sqrt(2); storage.mode(h0) <- "double"
  g0 <- dict$lpf[[2]] / sqrt(2); storage.mode(g0) <- "double"
  h1 <- dict$hpf[[1]] / sqrt(2); storage.mode(h1) <- "double"
  g1 <- dict$hpf[[2]] / sqrt(2); storage.mode(g1) <- "double"

  y <- vector("list", J+1)
  names(y) <- c(paste("d", 1:J, sep=""), paste("s", J, sep=""))
  W <- V <- numeric(N)

  x.h <- x.g <- x  
  for(j in 1:J) {
    out.h <- .C(C_modwt, as.double(x.h), N, as.integer(j), L, h1, h0,
                W = W, V = V)[7:8]
    out.g <- .C(C_modwt, as.double(x.g), N, as.integer(j), L, g1, g0,
                W = W, V = V)[7:8]
    y[[j]] <- complex(real = out.h$W, imaginary = out.g$W)
    x.h <- out.h$V
    x.g <- out.g$V
  }
  y[[J+1]] <- complex(real = x.h, imaginary = x.g)
  attr(y, "wavelet") <- wf
  attr(y, "boundary") <- boundary
  attr(y, "levels") <- n.levels
  return(y)
}

########################################################################

imodwt.hilbert <- function(y) {
  if(attributes(y)$boundary != "periodic")
    stop("Invalid boundary rule in imodwt")
  J <- length(y) - 1

  dict <- hilbert.filter(attributes(y)$wavelet)
  L <- dict$length
  ht <- dict$hpf / sqrt(2)
  gt <- dict$lpf / sqrt(2)

  jj <- paste("s", J, sep="")
  X <- y[[jj]]; N <- length(X)
  XX <- numeric(N)
  for(j in J:1) {
    jj <- paste("d", j, sep="")
    X <- .C(C_imodwt, y[[jj]], X, as.integer(N), as.integer(j), 
      as.integer(L), ht, gt, XX)[[8]]
  }
  return(X)
}

########################################################################



#' Select a Hilbert Wavelet Pair
#' 
#' Converts name of Hilbert wavelet pair to filter coefficients.
#' 
#' Simple \code{switch} statement selects the appropriate HWP.  There are two
#' parameters that define a Hilbert wavelet pair using the notation of
#' Selesnick (2001,2002), \eqn{K} and \eqn{L}.  Currently, the only implemented
#' combinations \eqn{(K,L)} are (3,3), (3,5), (4,2) and (4,4).
#' 
#' @param name Character string of Hilbert wavelet pair, see acceptable names
#' below (e.g., \code{"k3l3"}).
#' @return List containing the following items: \item{L}{length of the wavelet
#' filter} \item{h0,g0}{low-pass filter coefficients} \item{h1,g1}{high-pass
#' filter coefficients}
#' @author B. Whitcher
#' @seealso \code{\link{wave.filter}}
#' @references Selesnick, I.W. (2001). Hilbert transform pairs of wavelet
#' bases. \emph{IEEE Signal Processing Letters} \bold{8}(6), 170--173.
#' 
#' Selesnick, I.W. (2002). The design of approximate Hilbert transform pairs
#' of wavelet bases. \emph{IEEE Transactions on Signal Processing} 
#' \bold{50}(5), 1144--1152.
#' @keywords ts
#' @examples
#' 
#' hilbert.filter("k3l3")
#' hilbert.filter("k3l5")
#' hilbert.filter("k4l2")
#' hilbert.filter("k4l4")
#' 
#' @export hilbert.filter
hilbert.filter <- function(name) {
  select.K3L3 <- function() {
    L <- 12
    h0 <- c(1.1594353e-04, -2.2229002e-03, -2.2046914e-03, 4.3427642e-02,
            -3.3189896e-02, -1.5642755e-01, 2.8678636e-01, 7.9972652e-01,
            4.9827824e-01, 2.4829160e-02, -4.2679177e-02, -2.2260892e-03)
    h1 <- qmf(h0)
    g0 <- c(1.6563361e-05, -5.2543406e-05, -6.1909121e-03, 1.9701141e-02,
            3.2369691e-02, -1.2705043e-01, -1.5506397e-02, 6.1333712e-01,
            7.4585008e-01, 2.1675412e-01, -4.9432248e-02, -1.5582624e-02)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(h1, g1), lpf = list(h0, g0)))
  }
    select.K3L5 <- function() {
    L <- 12
    h0 <- c(5.4258791e-06, -2.1310518e-04, -2.6140914e-03,  1.0212881e-02,
            3.5747880e-02, -4.5576766e-02, 3.9810341e-03, 5.3402475e-01,
            7.8757164e-01, 2.6537457e-01, -1.3008915e-01, -5.9573795e-02,
            1.2733976e-02, 2.8641011e-03, -2.2992683e-04, -5.8541759e-06)
    h1 <- qmf(h0)
    g0 <- c(4.9326174e-07, 3.5727140e-07, -1.1664703e-03, -8.4003116e-04,
            2.8601474e-02, 9.2509748e-03, -7.4562251e-02, 2.2929480e-01,
            7.6509138e-01, 5.8328559e-01, -4.6218010e-03, -1.2336841e-01,
            -6.2826896e-03, 9.5478911e-03, 4.6642226e-05, -6.4395935e-05)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(h1, g1), lpf = list(h0, g0)))
  }
  select.K4L2 <- function() {
    L <- 12
    h0 <- c(-1.7853301e-03, 1.3358873e-02, 3.6090743e-02, -3.4722190e-02,
            4.1525062e-02, 5.6035837e-01, 7.7458617e-01, 2.2752075e-01,
            -1.6040927e-01, -6.1694251e-02, 1.7099408e-02, 2.2852293e-03)
    h1 <- qmf(h0)
    g0 <- c(-3.5706603e-04, -1.8475351e-04, 3.2591486e-02, 1.3449902e-02,
            -5.8466725e-02, 2.7464308e-01, 7.7956622e-01, 5.4097379e-01,
            -4.0315008e-02, -1.3320138e-01, -5.9121296e-03, 1.1426146e-02)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(h1, g1), lpf = list(h0, g0)))
  }
  select.K4L4 <- function() {
    L <- 16
    h0 <- c(2.5734665593981519e-05, -6.6909066441298817e-04, 
            -5.5482443985275260e-03, 1.3203474646343588e-02,
            3.8605327384848696e-02, -5.0687259299773510e-02,
            8.1364447220208733e-03, 5.3021727476690994e-01,
            7.8330912249663232e-01, 2.7909546754271131e-01,
            -1.3372674246928601e-01, -6.9759509629953295e-02,
            1.6979390952358446e-02, 5.7323570134311854e-03,
            -6.7425216644469892e-04, -2.5933188060087743e-05)
    h1 <- qmf(h0)
    g0 <- c(2.8594072882201687e-06, 1.9074538622058143e-06,
            -2.9903835439216066e-03, -1.9808995184875909e-03,
            3.3554663884350758e-02, 7.7023844121478988e-03,
            -7.7084571412435535e-02, 2.3298110528093252e-01,
            7.5749376288995063e-01, 5.8834703992067783e-01,
            5.1708789323078770e-03, -1.3520099946241465e-01,
            -9.1961246067629732e-03, 1.5489641793018745e-02,
            1.5569563641876791e-04, -2.3339869254078969e-04)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(h1, g1), lpf = list(h0, g0)))
  }
  select.K5L7 <- function() {
    L <- 24
    h0 <- c(-2.5841959496364648e-10, 6.0231243121018760e-10,
            2.1451486802217960e-06,  -4.9989222844980982e-06,
            -2.2613489535132104e-04, 5.1967501391358343e-04,
            3.4011963595840899e-03,  -7.1996997688061597e-03,
            -1.7721433874932836e-02, 3.5491112173858148e-02,
            3.0580617312936355e-02,  -1.3452365188777773e-01,
            2.1741748603083836e-03, 5.8046856094922639e-01,
            7.4964083145768690e-01, 2.6775497264154541e-01,
            -7.9593287728224230e-02,  -4.3942149960221458e-02,
            1.9574969406037097e-02, 8.8554643330725387e-03,
            -7.2770446614145033e-04,  -3.1310992841759443e-04,
            1.4045333283124608e-06, 6.0260907100656169e-07)
    h1 <- qmf(h0)
    g0 <- c(-3.8762939244546978e-09, 2.9846463282743695e-07,
            5.6276030758515370e-06, -7.7697066311187957e-05,
            -2.1442686434841905e-04, 2.1948612668324223e-03,
            9.5408758453423542e-04, -1.7149735951945008e-02,
            1.5212479104581677e-03, 5.6600564413983846e-02,
            -4.8900162376504831e-02, -1.3993440493611778e-01,
            2.7793346796113222e-01, 7.6735603850281364e-01,
            5.4681951651005178e-01, 3.6275855872448776e-02,
            -8.8224410289407154e-02, 3.2821708368951431e-05,
            1.7994969189524142e-02, 1.8662128501760204e-03,
            -7.8622878632753014e-04, -5.8077443328549205e-05,
            3.0932895975646042e-06, 4.0173938067104100e-08)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(h1, g1), lpf = list(h0, g0)))
  }
  select.K6L6 <- function() {
    L <- 24
    h0 <- c(1.4491207137947255e-09  -3.4673992369566253e-09,
            -6.7544152844875963e-06, 1.6157040144070828e-05,
            4.0416340595645441e-04, -9.4536696039781878e-04,
            -4.2924086033924620e-03, 9.0688042722858742e-03,
            1.8690864167884680e-02, -3.7883945370993717e-02,
            -2.7337592282061701e-02, 1.3185812419468312e-01,
            -2.1034481553730465e-02, -5.9035515013747486e-01,
            -7.4361804647499452e-01, -2.5752016951708306e-01,
            9.2725410672739983e-02, 4.9100676534870831e-02,
            -2.4411085480175867e-02, -1.1190458223944993e-02,
            1.7793885751382626e-03, 7.4715940333597059e-04,
            -6.2392430013359510e-06, -2.6075498267775052e-06)
    h1 <- qmf(h0)
    g0 <- c(1.8838569279331431e-08, -1.1000360697229965e-06,
            -1.4600820117782769e-05, 1.6936567299204319e-04,
            2.6967189953984829e-04, -3.1633669438102655e-03,
            -7.2081460313487946e-04, 1.9638595542490079e-02,
            -3.0968325940269846e-03, -5.6722348677476261e-02,
            5.2260784738219289e-02, 1.2763836788794369e-01,
            -2.9566169882112192e-01, -7.6771793937333599e-01,
            -5.3818432160802543e-01, -2.4023872575927138e-02,
            9.9019132161496132e-02, -1.2059411664071501e-03,
            -2.2693488886969308e-02, -1.8724943382560243e-03,
            1.7270823778712107e-03, 1.5415480681200776e-04,
            -1.1712464100067407e-05, -2.0058075590596196e-07)
    g1 <- qmf(g0)
    return(list(length = L, hpf = list(-h1, -g1), lpf = list(-h0, -g0)))
  }

  switch(name,
         "k3l3" = select.K3L3(),
         "k3l5" = select.K3L5(),
         "k4l2" = select.K4L2(),
         "k4l4" = select.K4L4(),
         "k5l7" = select.K5L7(),
         "k6l6" = select.K6L6(),
         stop("Invalid selection for hilbert.filter"))
}

########################################################################



#' Phase Shift for Hilbert Wavelet Coefficients
#' 
#' Wavelet coefficients are circularly shifted by the amount of phase shift
#' induced by the discrete Hilbert wavelet transform.
#' 
#' The "center-of-energy" argument of Hess-Nielsen and Wickerhauser (1996) is
#' used to provide a flexible way to circularly shift wavelet coefficients
#' regardless of the wavelet filter used.
#' 
#' @aliases phase.shift.hilbert phase.shift.hilbert.packet
#' @param x Discete Hilbert wavelet transform (DHWT) object.
#' @param wf character string; Hilbert wavelet pair used in DHWT
#' @return DHWT (DHWPT) object with coefficients circularly shifted.
#' @author B. Whitcher
#' @seealso \code{\link{phase.shift}}
#' @references Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
#' time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
#' 523-540.
#' @keywords ts
#' @export phase.shift.hilbert
phase.shift.hilbert <- function(x, wf) {
  coe <- function(g)
    sum(0:(length(g)-1) * g^2) / sum(g^2)

  J <- length(x) - 1

  h0 <- hilbert.filter(wf)$lpf[[1]]
  h1 <- hilbert.filter(wf)$hpf[[1]]
  
  for(j in 1:J) {
    ph <- round(2^(j-1) * (coe(h0) + coe(h1)) - coe(h0), 0)
    Nj <- length(x[[j]])
    x[[j]] <- c(x[[j]][(ph+1):Nj], x[[j]][1:ph])
  }

  ph <- round((2^J-1) * coe(h0), 0)
  J <- J + 1
  x[[J]] <- c(x[[J]][(ph+1):Nj], x[[J]][1:ph])

  return(x)
}

########################################################################

modwpt.hilbert <- function(x, wf, n.levels=4, boundary="periodic") {
  N <- length(x)
  storage.mode(N) <- "integer"
  J <- n.levels
  if(2^J > N) stop("wavelet transform exceeds sample size in modwpt")

  dict <- hilbert.filter(wf)
  L <- dict$length; storage.mode(L) <- "integer"
  h0 <- dict$lpf[[1]] / sqrt(2); storage.mode(h0) <- "double"
  g0 <- dict$lpf[[2]] / sqrt(2); storage.mode(g0) <- "double"
  h1 <- dict$hpf[[1]] / sqrt(2); storage.mode(h1) <- "double"
  g1 <- dict$hpf[[2]] / sqrt(2); storage.mode(g1) <- "double"

  y <- vector("list", sum(2^(1:J)))
  yn <- length(y)
  crystals1 <- rep(1:J, 2^(1:J))
  crystals2 <- unlist(apply(as.matrix(2^(1:J) - 1), 1, seq, from=0))
  names(y) <- paste("w", crystals1, ".", crystals2, sep="")

  W <- V <- numeric(N)
  storage.mode(W) <- storage.mode(V) <- "double"
  for(j in 1:J) {
    ## cat(paste("j =", j, fill=T))
    index <- 0
    jj <- min((1:yn)[crystals1 == j])
    for(n in 0:(2^j / 2 - 1)) {
      index <- index + 1
      if(j > 1)
        x <- y[[(1:yn)[crystals1 == j-1][index]]]
      else
        x <- complex(real=x, imaginary=x)

      if(n %% 2 == 0) {
        zr <- .C(C_modwt, as.double(Re(x)), N, as.integer(j), L, h1, h0, 
                 W = W, V = V)[7:8]
        zc <- .C(C_modwt, as.double(Im(x)), N, as.integer(j), L, g1, g0, 
                 W = W, V = V)[7:8]
        y[[jj + 2*n + 1]] <- complex(real=zr$W, imaginary=zc$W)
        y[[jj + 2*n]] <- complex(real=zr$V, imaginary=zc$V)
      }
      else {
        zr <- .C(C_modwt, as.double(Re(x)), N, as.integer(j), L, h1, h0, 
                 W = W, V = V)[7:8]
        zc <- .C(C_modwt, as.double(Im(x)), N, as.integer(j), L, g1, g0, 
                 W = W, V = V)[7:8]
        y[[jj + 2*n]] <- complex(real=zr$W, imaginary=zc$W)
        y[[jj + 2*n + 1 ]] <- complex(real=zr$V, imaginary=zc$V)
      }
    }
  }
  attr(y, "wavelet") <- wf
  return(y)
}

########################################################################

phase.shift.hilbert.packet <- function(x, wf) {
  coe <- function(g)
    sum(0:(length(g)-1) * g^2) / sum(g^2)

  dict <- hilbert.filter(wf)
  h0 <- dict$lpf[[1]]; h1 <- dict$hpf[[1]]
  g0 <- dict$lpf[[2]]; g1 <- dict$hpf[[2]]

  xn <- length(x)
  N <- length(x[[1]])
  J <- trunc(log(xn,2))
  jbit <- vector("list", xn)
  jbit[[1]] <- FALSE; jbit[[2]] <- TRUE
  crystals1 <- rep(1:J, 2^(1:J))

  for(j in 1:J) {
    jj <- min((1:xn)[crystals1 == j])
    for(n in 0:(2^j - 1)) {
      if(j > 1) {
        jp <- min((1:xn)[crystals1 == j-1])
        if(n %% 4 == 0 | n %% 4 == 3)
          jbit[[jj + n]] <- c(jbit[[jp + floor(n/2)]], FALSE)
        else
          jbit[[jj + n]] <- c(jbit[[jp + floor(n/2)]], TRUE)
      }
      Sjn0 <- sum((1 - jbit[[jj + n]]) * 2^(0:(j-1)))
      Sjn1 <- sum(jbit[[jj + n]] * 2^(0:(j-1)))
      ph <- round(Sjn0 * coe(h0) + Sjn1 * coe(h1), 0)
      x[[jj + n]] <- c(x[[jj + n]][(ph+1):N], x[[jj + n]][1:ph])
    }
  }
  return(x)
}

#' Time-varying and Seasonal Analysis Using Hilbert Wavelet Pairs
#' 
#' Performs time-varying or seasonal coherence and phase anlaysis between two
#' time seris using the maximal-overlap discrete Hilbert wavelet transform
#' (MODHWT).
#' 
#' The idea of seasonally-varying spectral analysis (SVSA, Madden 1986) is
#' generalized using the MODWT and Hilbert wavelet pairs.  For the seasonal
#' case, \eqn{S} seasons are used to produce a consistent estimate of the
#' coherence and phase.  For the non-seasonal case, a simple rectangular
#' (moving-average) filter is applied to the MODHWT coefficients in order to
#' produce consistent estimates.
#' 
#' @usage modhwt.coh(x, y, f.length = 0)
#' @usage modhwt.phase(x, y, f.length = 0)
#' @usage modhwt.coh.seasonal(x, y, S = 10, season = 365)
#' @usage modhwt.phase.seasonal(x, y, season = 365)
#' @aliases modhwt.coh modhwt.phase modhwt.coh.seasonal modhwt.phase.seasonal
#' @param x MODHWT object.
#' @param y MODHWT object.
#' @param f.length Length of the rectangular filter.
#' @param S Number of "seasons".
#' @param season Length of the "season".
#' @return Time-varying or seasonal coherence and phase between two time
#' series.  The coherence estimates are between zero and one, while the phase
#' estimates are between \eqn{-\pi}{-pi} and \eqn{\pi}{pi}.
#' @author B. Whitcher
#' @seealso \code{\link{hilbert.filter}}
#' @references Madden, R.A. (1986). Seasonal variation of the 40--50 day
#' oscillation in the tropics. \emph{Journal of the Atmospheric Sciences}
#' \bold{43}(24), 3138--3158.
#' 
#' Whither, B. and P.F. Craigmile (2004). Multivariate Spectral Analysis Using
#' Hilbert Wavelet Pairs, \emph{International Journal of Wavelets,
#' Multiresolution and Information Processing}, \bold{2}(4), 567--587.
#' @keywords ts
modhwt.coh <- function(x, y, f.length = 0) {
  filt <- rep(1, f.length + 1)
  filt <- filt / length(filt)

  J <- length(x) - 1
  coh <- vector("list", J)
  for(j in 1:J) {
    co.spec <- filter(Re(x[[j]] * Conj(y[[j]])), filt) 
    quad.spec <- filter(-Im(x[[j]] * Conj(y[[j]])), filt)
    x.spec <- filter(Mod(x[[j]])^2, filt)
    y.spec <- filter(Mod(y[[j]])^2, filt)
    coh[[j]] <- (co.spec^2 + quad.spec^2) / x.spec / y.spec
  }
  coh
}

########################################################################

modhwt.phase <- function(x, y, f.length = 0) {
  filt <- rep(1, f.length + 1)
  filt <- filt / length(filt)

  J <- length(x) - 1
  phase <- vector("list", J)
  for(j in 1:J) {
    co.spec <- filter(Re(x[[j]] * Conj(y[[j]])), filt) 
    quad.spec <- filter(-Im(x[[j]] * Conj(y[[j]])), filt)
    phase[[j]] <- Arg(co.spec - 1i * quad.spec)
  }
  phase
}

########################################################################

modhwt.coh.seasonal <- function(x, y, S=10, season=365) {
  J <- length(x) - 1
  coh <- shat <- vector("list", J)
  for(j in 1:J) {
    xj <- x[[j]]
    yj <- y[[j]]

    ## Cospectrum
    co <- matrix(Re(xj * Conj(yj)), ncol=season, byrow=TRUE)
    co.spec <- c(apply(co, 2, mean, na.rm=TRUE))
    gamma.c <- my.acf(as.vector(co))
    omega.c <- sum(gamma.c[c(1, rep(seq(season+1, S*season, by=season),
                                    each=2))])
    
    ## Quadrature spectrum
    quad <- matrix(-Im(xj * Conj(yj)), ncol=season, byrow=TRUE)
    quad.spec <- c(apply(quad, 2, mean, na.rm=TRUE))
    gamma.q <- my.acf(as.vector(quad))
    omega.q <- sum(gamma.q[c(1, rep(seq(season+1, S*season, by=season),
                                    each=2))])

    gamma.cq <- my.ccf(as.vector(co), as.vector(quad))
    omega.cq <- sum(gamma.cq[S*season + seq(-S*season+1, S*season, by=season)])

    ## Autospectrum(X)
    autoX <- matrix(Mod(xj)^2, ncol=season, byrow=TRUE)
    x.spec <- c(apply(autoX, 2, mean, na.rm=TRUE))

    ## Autospectrum(Y)
    autoY <- matrix(Mod(yj)^2, ncol=season, byrow=TRUE)
    y.spec <- c(apply(autoY, 2, mean, na.rm=TRUE))

    shat[[j]] <- 4 * (co.spec*omega.c + quad.spec * omega.q +
                      2*co.spec*quad.spec*omega.cq) / x.spec^2 / y.spec^2
    coh[[j]] <- (co.spec^2 + quad.spec^2) / x.spec / y.spec
  }
  list(coh = coh, var = shat)
}

########################################################################

modhwt.phase.seasonal <- function(x, y, season=365) {
  J <- length(x) - 1
  phase <- vector("list", J)
  for(j in 1:J) {
    co.spec <- Re(x[[j]] * Conj(y[[j]]))
    co.spec <- c(apply(matrix(co.spec, ncol=season, byrow=TRUE), 2,
                       mean, na.rm=TRUE))
    quad.spec <- -Im(x[[j]] * Conj(y[[j]]))
    quad.spec <- c(apply(matrix(quad.spec, ncol=season, byrow=TRUE), 2,
                         mean, na.rm=TRUE))
    phase[[j]] <- Arg(co.spec - 1i * quad.spec)
  }
  phase
}

#' Periodogram
#' 
#' Computation of the periodogram via the Fast Fourier Transform (FFT).
#' 
#' 
#' @param z time series
#' @author Author: Jan Beran; modified: Martin Maechler, Date: Sep 1995.
#' @keywords ts
per <- function(z) {
  n <- length(z)
  (Mod(fft(z)) ** 2 / (2 * pi * n)) [1:(n %/% 2 + 1)]
}

#' Rotated Cumulative Variance
#' 
#' Provides the normalized cumulative sums of squares from a sequence of
#' coefficients with the diagonal line removed.
#' 
#' The rotated cumulative variance, when plotted, provides a qualitative way to
#' study the time dependence of the variance of a series.  If the variance is
#' stationary over time, then only small deviations from zero should be
#' present.  If on the other hand the variance is non-stationary, then large
#' departures may exist.  Formal hypothesis testing may be performed based on
#' boundary crossings of Brownian bridge processes.
#' 
#' @param x vector of coefficients to be cumulatively summed (missing values
#' excluded)
#' @return Vector of coefficients that are the sumulative sum of squared input
#' coefficients.
#' @author B. Whitcher
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @export rotcumvar
rotcumvar <- function(x) {
  x <- x[!is.na(x)]
  n <- length(x)
  plus <- 1:n/(n-1) - cumsum(x^2)/sum(x^2)
  minus <- cumsum(x^2)/sum(x^2) - 0:(n-1)/(n-1)
  pmax(abs(plus), abs(minus))
}



#' Testing for Homogeneity of Variance
#' 
#' A recursive algorithm for detecting and locating multiple variance change
#' points in a sequence of random variables with long-range dependence.
#' 
#' For details see Section 9.6 of Percival and Walden (2000) or Section 7.3 in
#' Gencay, Selcuk and Whitcher (2001).
#' 
#' @param x Sequence of observations from a (long memory) time series.
#' @param wf Name of the wavelet filter to use in the decomposition.
#' @param J Specifies the depth of the decomposition.  This must be a number
#' less than or equal to \eqn{\log(\mbox{length}(x),2)}{log(length(x),2)}.
#' @param min.coef Minimum number of wavelet coefficients for testing purposes.
#' Empirical results suggest that 128 is a reasonable number in order to apply
#' asymptotic critical values.
#' @param debug Boolean variable: if set to \code{TRUE}, actions taken by the
#' algorithm are printed to the screen.
#' @return Matrix whose columns include (1) the level of the wavelet transform
#' where the variance change occurs, (2) the value of the test statistic, (3)
#' the DWT coefficient where the change point is located, (4) the MODWT
#' coefficient where the change point is located.  Note, there is currently no
#' checking that the MODWT is contained within the associated support of the
#' DWT coefficient.  This could lead to incorrect estimates of the location of
#' the variance change.
#' @author B. Whitcher
#' @seealso \code{\link{dwt}}, \code{\link{modwt}}, \code{\link{rotcumvar}},
#' \code{\link{mult.loc}}.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @export testing.hov
testing.hov <- function(x, wf, J, min.coef=128, debug=FALSE) {
  n <- length(x)
  change.points <- NULL

  x.dwt <- dwt(x, wf, J)
  x.dwt.bw <- brick.wall(x.dwt, wf, method="dwt") 
  x.modwt <- modwt(x, wf, J)
  x.modwt.bw <- brick.wall(x.modwt, wf)

  for(j in 1:J) {
    cat("##### Level ", j, " #####", fill=TRUE)
    Nj <- n/2^j
    dwt.list <- list(dwt = (x.dwt.bw[[j]])[!is.na(x.dwt.bw[[j]])],
                     left = min((1:Nj)[!is.na(x.dwt.bw[[j]])]) + 1,
                     right = sum(!is.na(x.dwt.bw[[j]])))
    modwt.list <- list(modwt = (x.modwt.bw[[j]])[!is.na(x.modwt.bw[[j]])],
                       left = min((1:n)[!is.na(x.modwt.bw[[j]])]) + 1,
                       right = sum(!is.na(x.modwt.bw[[j]])))
    if(debug) cat("Starting recursion; using", dwt.list$left,
                  "to", dwt.list$right - 1, "...  ")
    change.points <-
      rbind(change.points,
            mult.loc(dwt.list, modwt.list, wf, j, min.coef, debug))
  }
  dimnames(change.points) <-
    list(NULL, c("level", "crit.value", "loc.dwt", "loc.modwt"))
  return(change.points)
}



#' Wavelet-based Testing and Locating for Variance Change Points
#' 
#' This is the major subroutine for \code{\link{testing.hov}}, providing the
#' workhorse algorithm to recursively test and locate multiple variance changes
#' in so-called long memory processes.
#' 
#' For details see Section 9.6 of Percival and Walden (2000) or Section 7.3 in
#' Gencay, Selcuk and Whitcher (2001).
#' 
#' @param dwt.list List of wavelet vector coefficients from the \code{dwt}.
#' @param modwt.list List of wavelet vector coefficients from the \code{modwt}.
#' @param wf Name of the wavelet filter to use in the decomposition.
#' @param level Specifies the depth of the decomposition.
#' @param min.coef Minimum number of wavelet coefficients for testing purposes.
#' @param debug Boolean variable: if set to \code{TRUE}, actions taken by the
#' algorithm are printed to the screen.
#' @return Matrix.
#' @author B. Whitcher
#' @seealso \code{\link{rotcumvar}}, \code{\link{testing.hov}}.
#' @references Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
#' Introduction to Wavelets and Other Filtering Methods in Finance and
#' Economics}, Academic Press.
#' 
#' Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
#' Series Analysis}, Cambridge University Press.
#' @keywords ts
#' @export mult.loc
mult.loc <- function(dwt.list, modwt.list, wf, level, min.coef, debug)
{
  Nj <- length(dwt.list$dwt)
  N <- length(modwt.list$modwt)
  crit <- 1.358
  change.points <- NULL
  
  if(Nj > min.coef) {
    ## test statistic using the DWT
    P <- cumsum(dwt.list$dwt^2) / sum(dwt.list$dwt^2)
    test.stat <- pmax((1:Nj) / (Nj-1) - P, P - (1:Nj - 1) / (Nj-1))
    loc.dwt <- (1:Nj)[max(test.stat) == test.stat]
    test.stat <- max(test.stat)

    ## location using the MODWT
    P <- cumsum(modwt.list$modwt^2) / sum(modwt.list$modwt^2)
    loc.stat <- pmax((1:N) / (N-1) - P, P - (1:N - 1) / (N-1))
    loc.modwt <- (1:N)[max(loc.stat) == loc.stat]

    if(test.stat > sqrt(2) * crit / sqrt(Nj)) {
      if(debug) cat("Accepted!", fill=TRUE)
      ## Left
      if(debug) cat("Going left; using", dwt.list$left,
                    "to", loc.dwt + dwt.list$left - 1, "...  ")
      temp.dwt.list <- list(dwt = dwt.list$dwt[1:(loc.dwt-1)],
                            left = dwt.list$left,
                            right = loc.dwt + dwt.list$left - 1)
      temp.modwt.list <- list(modwt = modwt.list$modwt[1:(loc.modwt-1)],
                              left = modwt.list$left,
                              right = loc.modwt + modwt.list$left - 1)
      change.points <-
        rbind(c(level, test.stat, loc.dwt + dwt.list$left,
                loc.modwt + modwt.list$left),
              Recall(temp.dwt.list, temp.modwt.list, wf, level, min.coef, debug))
      ## Right
      if(debug) cat("Going right; using", loc.dwt + dwt.list$left + 1,
                    "to", dwt.list$right, "...  ")
      temp.dwt.list <- list(dwt = dwt.list$dwt[(loc.dwt+1):Nj],
                            left = loc.dwt + dwt.list$left + 1,
                            right = dwt.list$right)
      temp.modwt.list <- list(modwt = modwt.list$modwt[(loc.modwt+1):N],
                              left = loc.modwt + modwt.list$left + 1,
                              right = modwt.list$right)
      change.points <-
        rbind(change.points,
              Recall(temp.dwt.list, temp.modwt.list, wf, level, min.coef, debug))
    }
    else
      if(debug) cat("Rejected!", fill=TRUE)
  }
  else
    if(debug) cat("Sample size does not exceed ", min.coef, "!",
                  sep="", fill=TRUE)

  return(change.points)
}

#' Spectral Density Functions for Long-Memory Processes
#' 
#' Draws the spectral density functions (SDFs) for standard long-memory
#' processes including fractional difference (FD), seasonal persistent (SP),
#' and seasonal fractional difference (SFD) processes.
#' 
#' 
#' @usage fdp.sdf(freq, d, sigma2 = 1)
#' @usage spp.sdf(freq, d, fG, sigma2 = 1)
#' @usage spp2.sdf(freq, d1, f1, d2, f2, sigma2 = 1)
#' @usage sfd.sdf(freq, s, d, sigma2 = 1)
#' @aliases fdp.sdf spp.sdf spp2.sdf sfd.sdf
#' @param freq vector of frequencies, normally from 0 to 0.5
#' @param d,d1,d2 fractional difference parameter
#' @param fG,f1,f2 Gegenbauer frequency
#' @param s seasonal parameter
#' @param sigma2 innovations variance
#' @return The power spectrum from an FD, SP or SFD process.
#' @author B. Whitcher
#' @seealso \code{\link{fdp.mle}}, \code{\link{spp.mle}}.
#' @keywords ts
#' @examples
#' 
#' dB <- function(x) 10 * log10(x)
#' 
#' fdp.main <- expression(paste("FD", group("(",d==0.4,")")))
#' sfd.main <- expression(paste("SFD", group("(",list(s==12, d==0.4),")")))
#' spp.main <- expression(paste("SPP",
#'     group("(",list(delta==0.4, f[G]==1/12),")")))
#' 
#' freq <- 0:512/1024
#' 
#' par(mfrow=c(2,2), mar=c(5-1,4,4-1,2), col.main="darkred")
#' plot(freq, dB(fdp.sdf(freq, .4)), type="l", xlab="frequency",
#'      ylab="spectrum (dB)", main=fdp.main)
#' plot(freq, dB(spp.sdf(freq, .4, 1/12)), type="l", xlab="frequency",
#'      ylab="spectrum (dB)", font.main=1, main=spp.main)
#' plot(freq, dB(sfd.sdf(freq, 12, .4)), type="l", xlab="frequency",
#'      ylab="spectrum (dB)", main=sfd.main)
fdp.sdf <- function(freq, d, sigma2 = 1)
  sigma2 / ((2 * sin(pi * freq)) ^ 2) ^ d

bandpass.fdp <- function(a, b, d)
  2 * integrate(fdp.sdf, lower = a, upper = b, d = d)$value

spp.sdf <- function(freq, d, fG, sigma2 = 1)
  sigma2 * abs(2 * (cos(2 * pi * freq) - cos(2 * pi * fG))) ^ (-2 * d)

spp2.sdf <- function(freq, d1, f1, d2, f2, sigma2 = 1) {
  sigma2 * abs(2 * (cos(2 * pi * freq) - cos(2 * pi * f1))) ^ (-2 * d1) * 
    abs(2 * (cos(2 * pi * freq) - cos(2 * pi * f2))) ^ (-2 * d2)
}

sfd.sdf <- function(freq, s, d, sigma2=1)
  sigma2 / (2 * (1 - cos(s * 2 * pi * freq))) ^ d

bandpass.spp <- function(a, b, d, fG) {
  if (fG > a && fG < b) {
    result1 <- integrate(spp.sdf, lower=a, upper=fG, d=d, fG=fG)$value
    result2 <- integrate(spp.sdf, lower=fG, upper=b, d=d, fG=fG)$value
  }
  else {
    result1 <- integrate(spp.sdf, lower=a, upper=b, d=d, fG=fG)$value
    result2 <- 0
  }
  return(2*(result1 + result2))
}

bandpass.spp2 <- function(a, b, d1, f1, d2, f2) {
  a1 <- a
  b1 <- b
  if(a1 < f1 && b1 > f2) {
    a2 <- f1
    b2 <- f2
    result1 <- integrate(spp2.sdf, a1, a2, d1=d1, f1=f1, d2=d2, f2=f2)$value
    result2 <- integrate(spp2.sdf, a1, b2, d1=d1, f1=f1, d2=d2, f2=f2)$value
    result3 <- integrate(spp2.sdf, b2, b1, d1=d1, f1=f1, d2=d2, f2=f2)$value
  }
  else {
    if (a1 < f1 && b1 < f2) {
      a2 <- f1
      result1 <- integrate(spp2.sdf, a1, a2, d1=d1, f1=f1, d2=d2, f2=f2)$value
      result2 <- integrate(spp2.sdf, a2, b1, d1=d1, f1=f1, d2=d2, f2=f2)$value
      result3 <- 0
    }
    else {
      if (a1 < f1 && b1 > f1 && b1 < f2) {
        a2 <- f1
        result1 <- integrate(spp2.sdf, a1, a2, d1=d1, f1=f1, d2=d2, f2=f2)$value
        result2 <- integrate(spp2.sdf, a2, b1, d1=d1, f1=f1, d2=d2, f2=f2)$value
        result3 <- 0
      }
      else {
        if (a1 > f1 && a1 < f2 && b1 > f2) {
          a2 <- f2
        result1 <- integrate(spp2.sdf, a1, a2, d1=d1, f1=f1, d2=d2, f2=f2)$value
        result2 <- integrate(spp2.sdf, a2, b1, d1=d1, f1=f1, d2=d2, f2=f2)$value
        result3 <- 0
        }
        else {
          result1 <- integrate(spp2.sdf, a1, b1, d1=d1, f1=f1, d2=d2, f2=f2)$value
          result2 <- 0
          result3 <- 0
        }
      }
    }
  }
  return(2 * (result1 + result2 + result3))
}

#' Variance of a Seasonal Persistent Process
#' 
#' Computes the variance of a seasonal persistent (SP) process using a
#' hypergeometric series expansion.
#' 
#' See Lapsa (1997).  The subroutine to compute a hypergeometric series was
#' taken from \emph{Numerical Recipes in C}.
#' 
#' @usage spp.var(d, fG, sigma2 = 1)
#' @usage Hypergeometric(a, b, c, z)
#' @aliases spp.var Hypergeometric
#' @param d Fractional difference parameter.
#' @param fG Gegenbauer frequency.
#' @param sigma2 Innovations variance.
#' @param a,b,c,z Parameters for the hypergeometric series.
#' @return The variance of an SP process.
#' @author B. Whitcher
#' @references Lapsa, P.M. (1997) Determination of Gegenbauer-type random
#' process models.  \emph{Signal Processing} \bold{63}, 73-90.
#' 
#' Press, W.H., S.A. Teukolsky, W.T. Vetterling and B.P. Flannery (1992)
#' \emph{Numerical Recipes in C}, 2nd edition, Cambridge University Press.
#' @keywords ts
#' @export spp.var
spp.var <- function(d, fG, sigma2 = 1) {
  ## Hypergeometric series representation of the variance taken from
  ## Lapsa (1997)
  omega <- 2 * pi * fG
  A <- sigma2 / 2 / sqrt(pi) * gamma(1 - 2 * d) / gamma(3 / 2 - 2 * d) * sin(omega) ^(1 - 4 * d)
  P1 <- Hypergeometric(1 - 2 * d, 1 - 2 * d, 3 / 2 - 2 * d, sin(omega / 2) ^ 2)
  P2 <- Hypergeometric(1 - 2 * d, 1 - 2 * d, 3 / 2 - 2 * d, cos(omega / 2) ^ 2)
  return(A * (P1 + P2))
}



Hypergeometric <- function(a, b, c, z) {
  ## Recursive implementation taken from Numerical Recipes in C (6.12)
  ## Press, Teukolsky, Vetterling and Flannery (1992)
  fac <- 1
  temp <- fac
  aa <- a
  bb <- b
  cc <- c
  for (n in 1:1000) {
    fac <- fac * (aa * bb) / cc
    fac <- fac * z / n
    series <- temp + fac
    if (series == temp)
      return(series)
    temp <- series
    aa <- aa + 1
    bb <- bb + 1
    cc <- cc + 1
  }
  stop("convergence failure in Hypergeometric")
}

#' Dual-tree Complex 2D Discrete Wavelet Transform
#' 
#' Dual-tree complex 2D discrete wavelet transform (DWT).
#' 
#' 
#' @usage cplxdual2D(x, J, Faf, af)
#' @usage icplxdual2D(w, J, Fsf, sf)
#' @aliases cplxdual2D icplxdual2D
#' @param x 2D array.
#' @param w wavelet coefficients.
#' @param J number of stages.
#' @param Faf first stage analysis filters for tree i.
#' @param af analysis filters for the remaining stages on tree i.
#' @param Fsf last stage synthesis filters for tree i.
#' @param sf synthesis filters for the preceeding stages.
#' @return For the analysis of \code{x}, the output is \item{w}{wavelet
#' coefficients indexed by \code{[[j]][[i]][[d1]][[d2]]}, where
#' \eqn{j=1,\ldots,J} (scale), \eqn{i=1} (real part) or \eqn{i=2} (imag part),
#' \eqn{d1=1,2} and \eqn{d2=1,2,3} (orientations).} For the synthesis of
#' \code{w}, the output is \item{y}{output signal.}
#' @author Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
#' @seealso \code{\link{FSfarras}}, \code{\link{farras}}, \code{\link{afb2D}},
#' \code{\link{sfb2D}}.
#' @keywords ts
#' @examples
#' 
#' \dontrun{
#' ## EXAMPLE: cplxdual2D
#' x = matrix(rnorm(32*32), 32, 32)
#' J = 5
#' Faf = FSfarras()$af
#' Fsf = FSfarras()$sf
#' af = dualfilt1()$af
#' sf = dualfilt1()$sf
#' w = cplxdual2D(x, J, Faf, af)
#' y = icplxdual2D(w, J, Fsf, sf)
#' err = x - y
#' max(abs(err))
#' }
#' 
cplxdual2D <- function(x, J, Faf, af) {

  ## Dual-Tree Complex 2D Discrete Wavelet Transform
  ##
  ## USAGE:
  ##   w = cplxdual2D(x, J, Faf, af)
  ## INPUT:
  ##   x - 2-D array
  ##   J - number of stages
  ##   Faf{i}: first stage filters for tree i
  ##   af{i}:  filters for remaining stages on tree i
  ## OUTPUT:
  ##   w{j}{i}{d1}{d2} - wavelet coefficients
  ##       j = 1..J (scale)
  ##       i = 1 (real part); i = 2 (imag part)
  ##       d1 = 1,2; d2 = 1,2,3 (orientations)
  ##   w{J+1}{m}{n} - lowpass coefficients
  ##       d1 = 1,2; d2 = 1,2 
  ## EXAMPLE:
  ##   x = rand(256);
  ##   J = 5;
  ##   [Faf, Fsf] = FSfarras;
  ##   [af, sf] = dualfilt1;
  ##   w = cplxdual2D(x, J, Faf, af);
  ##   y = icplxdual2D(w, J, Fsf, sf);
  ##   err = x - y;
  ##   max(max(abs(err)))
  ##
  ## WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY
  ## http://eeweb.poly.edu/iselesni/WaveletSoftware/

  ## normalization
  x <- x/2
  w <- vector("list", J+1)
  
  for (m in 1:2) {
    w[[1]][[m]] <- vector("list", 2)
    for (n in 1:2) {
      w[[1]][[m]][[n]] <- vector("list", 2)
      temp <- afb2D(x, Faf[[m]], Faf[[n]])
      lo <- temp$lo
      w[[1]][[m]][[n]] <- temp$hi
      if (J > 1) {
        for (j in 2:J) {
          temp <- afb2D(lo, af[[m]], af[[n]])
          lo <- temp$lo
          w[[j]][[m]][[n]] <- temp$hi
        }
        w[[J+1]][[m]][[n]] <- lo
      }
    }
  }

  for (j in 1:J) {
    for (m in 1:3) {
      w[[j]][[1]][[1]][[m]] <- pm(w[[j]][[1]][[1]][[m]])
      w[[j]][[2]][[2]][[m]] <- pm(w[[j]][[2]][[2]][[m]])
      w[[j]][[1]][[2]][[m]] <- pm(w[[j]][[1]][[2]][[m]])
      w[[j]][[2]][[1]][[m]] <- pm(w[[j]][[2]][[1]][[m]])
    }
  }
  return(w)
}

icplxdual2D <- function(w, J, Fsf, sf) {

  ## Inverse Dual-Tree Complex 2D Discrete Wavelet Transform
  ## 
  ## USAGE:
  ##   y = icplxdual2D(w, J, Fsf, sf)
  ## INPUT:
  ##   w - wavelet coefficients
  ##   J - number of stages
  ##   Fsf - synthesis filters for final stage
  ##   sf - synthesis filters for preceeding stages
  ## OUTPUT:
  ##   y - output array
  ## See cplxdual2D
  ##
  ## WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY
  ## http://eeweb.poly.edu/iselesni/WaveletSoftware/

  for (j in 1:J) {
    for (m in 1:3) {
      w[[j]][[1]][[1]][[m]] <- pm(w[[j]][[1]][[1]][[m]])
      w[[j]][[2]][[2]][[m]] <- pm(w[[j]][[2]][[2]][[m]])
      w[[j]][[1]][[2]][[m]] <- pm(w[[j]][[1]][[2]][[m]])
      w[[j]][[2]][[1]][[m]] <- pm(w[[j]][[2]][[1]][[m]])
    }
  }

  y <- matrix(0, 2*nrow(w[[1]][[1]][[1]][[1]]), 2*ncol(w[[1]][[1]][[1]][[1]]))
  for (m in 1:2) {
    for (n in 1:2) {
      lo <- w[[J+1]][[m]][[n]]
      if (J > 1) {
        for (j in J:2) {
          lo <- sfb2D(lo, w[[j]][[m]][[n]], sf[[m]], sf[[n]])
        }
        lo <- sfb2D(lo, w[[1]][[m]][[n]], Fsf[[m]], Fsf[[n]])
        y <- y + lo
      }
    }
  }

  ## normalization
  return(y/2)
}

###########################################################################
###########################################################################
###########################################################################



#' Three Dimensional Separable Discrete Wavelet Transform
#' 
#' Three-dimensional separable discrete wavelet transform (DWT).
#' 
#' 
#' @usage dwt.3d(x, wf, J = 4, boundary = "periodic")
#' @usage idwt.3d(y)
#' @aliases dwt.3d idwt.3d
#' @param x input array
#' @param wf name of the wavelet filter to use in the decomposition
#' @param J depth of the decomposition, must be a number less than or equal to
#' log(minZ,Y,Z,2)
#' @param boundary only \code{"periodic"} is currently implemented
#' @param y an object of class \code{dwt.3d}
#' @author B. Whitcher
#' @keywords ts
#' @export dwt.3d
dwt.3d <- function(x, wf, J=4, boundary="periodic")
{
  nx <- dim(x)[1]
  storage.mode(nx) <- "integer"
  ny <- dim(x)[2]
  storage.mode(ny) <- "integer"
  nz <- dim(x)[3]
  storage.mode(nz) <- "integer"

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  z <- array(0, dim=c(nx,ny,nz)/2)
  storage.mode(z) <- "double"

  x.wt <- vector("list", 7*J+1)
  x.names <- NULL
  for(j in 1:J) {
    out <- .C(C_three_D_dwt, "cube"=as.double(x), "NX"=nx, "NY"=ny,
              "NZ"=nz, "filter.length"=L, "hpf"=h, "lpf"=g, "LLL"=z,
              "HLL"=z, "LHL"=z, "LLH"=z, "HHL"=z, "HLH"=z, "LHH"=z,
              "HHH"=z)[8:15]
    if(j < J) {
      index <- (7*(j-1)+1):(7*j)
      x.wt[index] <- out[-1]
      x.names <- c(x.names, sapply(names(out)[-1], paste, j, sep=""))
      x <- out[[1]]
      nx <- dim(x)[1]
      storage.mode(nx) <- "integer"
      ny <- dim(x)[2]
      storage.mode(ny) <- "integer"
      nz <- dim(x)[3]
      storage.mode(nz) <- "integer"
      z <- array(0, dim=c(nx,ny,nz)/2)
      storage.mode(z) <- "double"
    }
    else {
      index <- (7*(j-1)+1):(7*j+1)
      x.wt[index] <- out[c(2:8,1)]
      x.names <- c(x.names, sapply(names(out)[c(2:8,1)], paste, j, sep=""))
    }
  }

  names(x.wt) <- x.names
  class(x.wt) <- "dwt.3d"
  attr(x.wt, "J") <- J
  attr(x.wt, "wavelet") <- wf
  attr(x.wt, "boundary") <- boundary
  return(x.wt)
}

###########################################################################
###########################################################################
###########################################################################

idwt.3d <- function(y)
{
  J <- attributes(y)$J
  LLL <- paste("LLL", J, sep="")

  wf <- attributes(y)$wavelet
  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf
  storage.mode(h) <- "double"
  g <- dict$lpf
  storage.mode(g) <- "double"

  y.in <- y$LLL

  for(j in J:1) {
    HLL <- paste("HLL", j, sep="")
    LHL <- paste("LHL", j, sep="")
    LLH <- paste("LLH", j, sep="")
    HHL <- paste("HHL", j, sep="")
    HLH <- paste("HLH", j, sep="")
    LHH <- paste("LHH", j, sep="")
    HHH <- paste("HHH", j, sep="")
    
    nx <- dim(y.in)[1]
    storage.mode(nx) <- "integer"
    ny <- dim(y.in)[2]
    storage.mode(ny) <- "integer"
    nz <- dim(y.in)[3]
    storage.mode(nz) <- "integer"

    z <- array(0, dim=2*c(nx, ny, nz))
    storage.mode(z) <- "double"

    out <- .C(C_three_D_idwt, as.double(y.in), as.double(y[[HLL]]),
              as.double(y[[LHL]]), as.double(y[[LLH]]),
              as.double(y[[HHL]]), as.double(y[[HLH]]),
              as.double(y[[LHH]]), as.double(y[[HHH]]), 
              nx, ny, nz, L, h, g, "Y"=z)

    y.in <- out$Y
  }
  zapsmall(y.in)
}



#' Three Dimensional Separable Maximal Ovelrap Discrete Wavelet Transform
#' 
#' Three-dimensional separable maximal overlap discrete wavelet transform
#' (MODWT).
#' 
#' 
#' @usage modwt.3d(x, wf, J = 4, boundary = "periodic")
#' @usage imodwt.3d(y)
#' @aliases modwt.3d imodwt.3d
#' @param x input array
#' @param wf name of the wavelet filter to use in the decomposition
#' @param J depth of the decomposition
#' @param boundary only \code{"periodic"} is currently implemented
#' @param y an object of class \code{modwt.3d}
#' @author B. Whitcher
#' @keywords ts
#' @export modwt.3d 
#' @export imodwt.3d
modwt.3d <- function(x, wf, J=4, boundary="periodic")
{
  nx <- dim(x)[1]
  storage.mode(nx) <- "integer"
  ny <- dim(x)[2]
  storage.mode(ny) <- "integer"
  nz <- dim(x)[3]
  storage.mode(nz) <- "integer"

  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf / sqrt(2)
  storage.mode(h) <- "double"
  g <- dict$lpf / sqrt(2)
  storage.mode(g) <- "double"

  z <- array(0, dim=c(nx,ny,nz))
  storage.mode(z) <- "double"

  x.wt <- vector("list", 7*J+1)
  x.names <- NULL
  for(j in 1:J) {
    out <- .C(C_three_D_modwt, "cube"=as.double(x), "NX"=nx, "NY"=ny,
              "NZ"=nz, "J"=j, "filter.length"=L, "hpf"=h, "lpf"=g,
              "LLL"=z, "HLL"=z, "LHL"=z, "LLH"=z, "HHL"=z, "HLH"=z,
              "LHH"=z, "HHH"=z)[9:16]
    if(j < J) {
      index <- (7*(j-1)+1):(7*j)
      x.wt[index] <- out[-1]
      x.names <- c(x.names, sapply(names(out)[-1], paste, j, sep=""))
      x <- out[[1]]
      nx <- dim(x)[1]
      storage.mode(nx) <- "integer"
      ny <- dim(x)[2]
      storage.mode(ny) <- "integer"
      nz <- dim(x)[3]
      storage.mode(nz) <- "integer"
      z <- array(0, dim=c(nx,ny,nz))
      storage.mode(z) <- "double"
    }
    else {
      index <- (7*(j-1)+1):(7*j+1)
      x.wt[index] <- out[c(2:8,1)]
      x.names <- c(x.names, sapply(names(out)[c(2:8,1)], paste, j, sep=""))
    }
  }

  names(x.wt) <- x.names
  class(x.wt) <- "modwt.3d"
  attr(x.wt, "J") <- J
  attr(x.wt, "wavelet") <- wf
  attr(x.wt, "boundary") <- boundary
  return(x.wt)
}

###########################################################################
###########################################################################
###########################################################################

imodwt.3d <- function(y)
{
  J <- attributes(y)$J
  LLL <- paste("LLL", J, sep="")

  wf <- attributes(y)$wavelet
  dict <- wave.filter(wf)
  L <- dict$length
  storage.mode(L) <- "integer"
  h <- dict$hpf / sqrt(2)
  storage.mode(h) <- "double"
  g <- dict$lpf / sqrt(2)
  storage.mode(g) <- "double"

  y.in <- y$LLL

  for(j in J:1) {
    HLL <- paste("HLL", j, sep="")
    LHL <- paste("LHL", j, sep="")
    LLH <- paste("LLH", j, sep="")
    HHL <- paste("HHL", j, sep="")
    HLH <- paste("HLH", j, sep="")
    LHH <- paste("LHH", j, sep="")
    HHH <- paste("HHH", j, sep="")
    
    nx <- dim(y.in)[1]
    storage.mode(nx) <- "integer"
    ny <- dim(y.in)[2]
    storage.mode(ny) <- "integer"
    nz <- dim(y.in)[3]
    storage.mode(nz) <- "integer"

    z <- array(0, dim=c(nx, ny, nz))
    storage.mode(z) <- "double"

    out <- .C(C_three_D_imodwt, as.double(y.in), as.double(y[[HLL]]),
              as.double(y[[LHL]]), as.double(y[[LLH]]),
              as.double(y[[HHL]]), as.double(y[[HLH]]),
              as.double(y[[LHH]]), as.double(y[[HHH]]), 
              nx, ny, nz, j, L, h, g, "Y"=z)

    y.in <- out$Y
  }
  zapsmall(y.in)
}

###########################################################################
###########################################################################
###########################################################################



#' Three Dimensional Multiresolution Analysis
#' 
#' This function performs a level \eqn{J} additive decomposition of the input
#' array using the pyramid algorithm (Mallat 1989).
#' 
#' This code implements a three-dimensional multiresolution analysis by
#' performing the one-dimensional pyramid algorithm (Mallat 1989) on each
#' dimension of the input array.  Either the DWT or MODWT may be used to
#' compute the multiresolution analysis, which is an additive decomposition of
#' the original array.
#' 
#' @param x A three-dimensional array containing the data be to decomposed.
#' This must be have dyadic length in all three dimensions (but not necessarily
#' the same) for \code{method="dwt"}.
#' @param wf Name of the wavelet filter to use in the decomposition.  By
#' default this is set to \code{"la8"}, the Daubechies orthonormal compactly
#' supported wavelet of length \eqn{L=8} least asymmetric family.
#' @param J Specifies the depth of the decomposition.  This must be a number
#' less than or equal to \eqn{\log(\mbox{length}(x),2)}{log(length(x),2)}.
#' @param method Either \code{"dwt"} or \code{"modwt"}.
#' @param boundary Character string specifying the boundary condition.  If
#' \code{boundary=="periodic"} the default and only method implemented, then
#' the matrix you decompose is assumed to be periodic on its defined interval.
#' @return List structure containing the filter triplets associated with the
#' multiresolution analysis.
#' @author B. Whitcher
#' @seealso \code{\link{dwt.3d}}, \code{\link{modwt.3d}}
#' @references Mallat, S. G. (1989) A theory for multiresolution signal
#' decomposition: the wavelet representation, \emph{IEEE Transactions on
#' Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.
#' 
#' Mallat, S. G. (1998) \emph{A Wavelet Tour of Signal Processing}, Academic
#' Press.
#' @keywords ts
#' @export mra.3d
mra.3d <- function(x, wf="la8", J=4, method="modwt", boundary="periodic")
{
  nx <- dim(x)[1]
  ny <- dim(x)[2]
  nz <- dim(x)[3]

  if(method == "modwt") {
    x.wt <- modwt.3d(x, wf, J, "periodic")
  } else {
    x.wt <- dwt.3d(x, wf, J, "periodic")
  }
  
  x.mra <- vector("list", 7*J+1)
  names(x.mra) <-
    c(matrix(rbind(paste("HLL", 1:J, sep=""), paste("LHL", 1:J, sep=""),
                   paste("LLH", 1:J, sep=""), paste("HHL", 1:J, sep=""),
                   paste("HLH", 1:J, sep=""), paste("LHH", 1:J, sep=""),
                   paste("HHH", 1:J, sep="")), nrow=1),
      paste("LLL", J, sep=""))

  ## Smooth
  zero <- vector("list", 7*J+1)
  names(zero) <- names(x.mra)
  attr(zero, "J") <- J
  attr(zero, "wavelet") <- wf
  attr(zero, "boundary") <- boundary
  zero[[7*J+1]] <- x.wt[[7*J+1]]
  if(method == "modwt") {
    class(x.wt) <- "modwt.3d"
    for(k in 1:(7*J))
      zero[[k]] <- array(0, dim=c(nx,ny,nz))
    x.mra[[7*J+1]] <- imodwt.3d(zero)
  } else {
    class(x.wt) <- "dwt.3d"
    for(k in 1:J)
      zero[[7*(k-1)+1]] <- zero[[7*(k-1)+2]] <- zero[[7*(k-1)+3]] <-
        zero[[7*(k-1)+4]] <- zero[[7*(k-1)+5]] <- zero[[7*(k-1)+6]] <-
          zero[[7*k]] <- array(0, dim=c(nx,ny,nz)/2^k)
    x.mra[[7*J+1]] <- idwt.3d(zero)
  }

  ## Details
  for(j in (7*J):1) {
    Jj <- ceiling(j/7)
    zero <- vector("list", 7*Jj+1)
    names(zero) <-
      c(matrix(rbind(paste("HLL", 1:Jj, sep=""), paste("LHL", 1:Jj, sep=""),
                     paste("LLH", 1:Jj, sep=""), paste("HHL", 1:Jj, sep=""),
                     paste("HLH", 1:Jj, sep=""), paste("LHH", 1:Jj, sep=""),
                     paste("HHH", 1:Jj, sep="")), nrow=1),
        paste("LLL", Jj, sep=""))
    attr(zero, "J") <- Jj
    attr(zero, "wavelet") <- wf
    attr(zero, "boundary") <- boundary
    zero[[j]] <- x.wt[[j]]
    if(method == "modwt") {
      for(k in names(zero)[-charmatch(names(zero)[j], names(zero))])
        zero[[k]] <- array(0, dim=c(nx,ny,nz))
      x.mra[[j]] <- imodwt.3d(zero)
    } else {
      for(k in 1:Jj)
        zero[[7*(k-1)+1]] <- zero[[7*(k-1)+2]] <- zero[[7*(k-1)+3]] <-
          zero[[7*(k-1)+4]] <- zero[[7*(k-1)+5]] <- zero[[7*(k-1)+6]] <-
            zero[[7*k]] <- array(0, dim=c(nx,ny,nz)/2^k)
      zero[[7*Jj+1]] <- array(0, dim=c(nx,ny,nz)/2^Jj)
      zero[[j]] <- x.wt[[j]]
      x.mra[[j]] <- idwt.3d(zero)
    }
  }
  return(x.mra)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cascade.R
\name{wavelet.filter}
\alias{wavelet.filter}
\title{Higher-Order Wavelet Filters}
\usage{
wavelet.filter(wf.name, filter.seq = "L", n = 512)
}
\arguments{
\item{wf.name}{Character string of wavelet filter.}

\item{filter.seq}{Character string of filter sequence.  \code{H} means
high-pass filtering and \code{L} means low-pass filtering.  Sequence is read
from right to left.}

\item{n}{Length of zero-padded filter.  Frequency resolution will be
\code{n}/2+1.}
}
\value{
Vector of wavelet coefficients.
}
\description{
Create a wavelet filter at arbitrary scale.
}
\details{
Uses \code{cascade} subroutine to compute higher-order wavelet coefficient
vector from a given filtering sequence.
}
\examples{

## Figure 4.14 in Gencay, Selcuk and Whitcher (2001)
par(mfrow=c(3,1), mar=c(5-2,4,4-1,2))
f.seq <- "HLLLLL"
plot(c(rep(0,33), wavelet.filter("mb4", f.seq), rep(0,33)), type="l",
     xlab="", ylab="", main="D(4) in black, MB(4) in red")
lines(c(rep(0,33), wavelet.filter("d4", f.seq), rep(0,33)), col=2)
plot(c(rep(0,35), -wavelet.filter("mb8", f.seq), rep(0,35)), type="l",
     xlab="", ylab="", main="D(8) in black, -MB(8) in red")
lines(c(rep(0,35), wavelet.filter("d8", f.seq), rep(0,35)), col=2)
plot(c(rep(0,39), wavelet.filter("mb16", f.seq), rep(0,39)), type="l",
     xlab="", ylab="", main="D(16) in black, MB(16) in red")
lines(c(rep(0,39), wavelet.filter("d16", f.seq), rep(0,39)), col=2)

}
\references{
Bruce, A. and H.-Y. Gao (1996).  \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.

Doroslovacki, M. L. (1998) On the least asymmetric wavelets, \emph{IEEE
Transactions on Signal Processing}, \bold{46}, No. 4, 1125-1130.

Daubechies, I. (1992) \emph{Ten Lectures on Wavelets}, CBMS-NSF Regional
Conference Series in Applied Mathematics, SIAM: Philadelphia.

Morris and Peravali (1999) Minimum-bandwidth discrete-time wavelets,
\emph{Signal Processing}, \bold{76}, No. 2, 181-193.

Nielsen, M. (2001) On the Construction and Frequency Localization of Finite
Orthogonal Quadrature Filters, \emph{Journal of Approximation Theory},
\bold{108}, No. 1, 36-52.
}
\seealso{
\code{\link{squared.gain}}, \code{\link{wave.filter}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sdf.R
\name{fdp.sdf}
\alias{fdp.sdf}
\alias{spp.sdf}
\alias{spp2.sdf}
\alias{sfd.sdf}
\title{Spectral Density Functions for Long-Memory Processes}
\usage{
fdp.sdf(freq, d, sigma2 = 1)

spp.sdf(freq, d, fG, sigma2 = 1)

spp2.sdf(freq, d1, f1, d2, f2, sigma2 = 1)

sfd.sdf(freq, s, d, sigma2 = 1)
}
\arguments{
\item{freq}{vector of frequencies, normally from 0 to 0.5}

\item{d, d1, d2}{fractional difference parameter}

\item{sigma2}{innovations variance}

\item{fG, f1, f2}{Gegenbauer frequency}

\item{s}{seasonal parameter}
}
\value{
The power spectrum from an FD, SP or SFD process.
}
\description{
Draws the spectral density functions (SDFs) for standard long-memory
processes including fractional difference (FD), seasonal persistent (SP),
and seasonal fractional difference (SFD) processes.
}
\examples{

dB <- function(x) 10 * log10(x)

fdp.main <- expression(paste("FD", group("(",d==0.4,")")))
sfd.main <- expression(paste("SFD", group("(",list(s==12, d==0.4),")")))
spp.main <- expression(paste("SPP",
    group("(",list(delta==0.4, f[G]==1/12),")")))

freq <- 0:512/1024

par(mfrow=c(2,2), mar=c(5-1,4,4-1,2), col.main="darkred")
plot(freq, dB(fdp.sdf(freq, .4)), type="l", xlab="frequency",
     ylab="spectrum (dB)", main=fdp.main)
plot(freq, dB(spp.sdf(freq, .4, 1/12)), type="l", xlab="frequency",
     ylab="spectrum (dB)", font.main=1, main=spp.main)
plot(freq, dB(sfd.sdf(freq, 12, .4)), type="l", xlab="frequency",
     ylab="spectrum (dB)", main=sfd.main)
}
\seealso{
\code{\link{fdp.mle}}, \code{\link{spp.mle}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/two_D.R
\name{dwt.2d}
\alias{dwt.2d}
\alias{idwt.2d}
\title{Two-Dimensional Discrete Wavelet Transform}
\usage{
dwt.2d(x, wf, J = 4, boundary = "periodic")

idwt.2d(y)
}
\arguments{
\item{x}{input matrix (image)}

\item{wf}{name of the wavelet filter to use in the decomposition}

\item{J}{depth of the decomposition, must be a number less than or equal to
log(minM,N,2)}

\item{boundary}{only \code{"periodic"} is currently implemented}

\item{y}{an object of class \code{dwt.2d}}
}
\value{
List structure containing the \eqn{3J+1} sub-matrices from the
decomposition.
}
\description{
Performs a separable two-dimensional discrete wavelet transform (DWT) on a
matrix of dyadic dimensions.
}
\details{
See references.
}
\examples{

## Xbox image
data(xbox)
xbox.dwt <- dwt.2d(xbox, "haar", 3)
par(mfrow=c(1,1), pty="s")
plot.dwt.2d(xbox.dwt)
par(mfrow=c(2,2), pty="s")
image(1:dim(xbox)[1], 1:dim(xbox)[2], xbox, xlab="", ylab="",
      main="Original Image")
image(1:dim(xbox)[1], 1:dim(xbox)[2], idwt.2d(xbox.dwt), xlab="", ylab="",
      main="Wavelet Reconstruction")
image(1:dim(xbox)[1], 1:dim(xbox)[2], xbox - idwt.2d(xbox.dwt),
      xlab="", ylab="", main="Difference")

## Daubechies image
data(dau)
par(mfrow=c(1,1), pty="s")
image(dau, col=rainbow(128))
sum(dau^2)
dau.dwt <- dwt.2d(dau, "d4", 3)
plot.dwt.2d(dau.dwt)
sum(plot.dwt.2d(dau.dwt, plot=FALSE)^2)

}
\references{
Mallat, S. (1998) \emph{A Wavelet Tour of Signal Processing},
Academic Press.

Vetterli, M. and J. Kovacevic (1995) \emph{Wavelets and Subband Coding},
Prentice Hall.
}
\seealso{
\code{\link{modwt.2d}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwt.R
\name{phase.shift}
\alias{phase.shift}
\alias{phase.shift.packet}
\title{Phase Shift Wavelet Coefficients}
\usage{
phase.shift(z, wf, inv = FALSE)

phase.shift.packet(z, wf, inv = FALSE)
}
\arguments{
\item{z}{DWT object}

\item{wf}{character string; wavelet filter used in DWT}

\item{inv}{Boolean variable; if \code{inv=TRUE} then the inverse phase shift
is applied}
}
\value{
DWT (DWPT) object with coefficients circularly shifted.
}
\description{
Wavelet coefficients are circularly shifted by the amount of phase shift
induced by the wavelet transform.
}
\details{
The center-of-energy argument of Hess-Nielsen and Wickerhauser (1996) is
used to provide a flexible way to circularly shift wavelet coefficients
regardless of the wavelet filter used.  The results are not identical to
those used by Percival and Walden (2000), but are more flexible.

\code{phase.shift.packet} is not yet implemented fully.
}
\references{
Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
523-540.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cov.R
\name{spin.covariance}
\alias{spin.covariance}
\alias{spin.correlation}
\title{Compute Wavelet Cross-Covariance Between Two Time Series}
\usage{
spin.covariance(x, y, lag.max = NA)

spin.correlation(x, y, lag.max = NA)
}
\arguments{
\item{x}{first time series}

\item{y}{second time series, same length as \code{x}}

\item{lag.max}{maximum lag to compute cross-covariance (correlation)}
}
\value{
List structure holding the wavelet cross-covariances (correlations)
according to scale.
}
\description{
Computes wavelet cross-covariance or cross-correlation between two time
series.
}
\details{
See references.
}
\examples{

## Figure 7.9 from Gencay, Selcuk and Whitcher (2001)
data(exchange)
returns <- diff(log(exchange))
returns <- ts(returns, start=1970, freq=12)
wf <- "d4"
demusd.modwt <- modwt(returns[,"DEM.USD"], wf, 8)
demusd.modwt.bw <- brick.wall(demusd.modwt, wf)
jpyusd.modwt <- modwt(returns[,"JPY.USD"], wf, 8)
jpyusd.modwt.bw <- brick.wall(jpyusd.modwt, wf)
n <- dim(returns)[1]
J <- 6
lmax <- 36
returns.cross.cor <- NULL
for(i in 1:J) {
  blah <- spin.correlation(demusd.modwt.bw[[i]], jpyusd.modwt.bw[[i]], lmax)
  returns.cross.cor <- cbind(returns.cross.cor, blah)
}
returns.cross.cor <- ts(as.matrix(returns.cross.cor), start=-36, freq=1)
dimnames(returns.cross.cor) <- list(NULL, paste("Level", 1:J))
lags <- length(-lmax:lmax)
lower.ci <- tanh(atanh(returns.cross.cor) - qnorm(0.975) /
                 sqrt(matrix(trunc(n/2^(1:J)), nrow=lags, ncol=J, byrow=TRUE)
                      - 3))
upper.ci <- tanh(atanh(returns.cross.cor) + qnorm(0.975) /
                 sqrt(matrix(trunc(n/2^(1:J)), nrow=lags, ncol=J, byrow=TRUE)
                      - 3))
par(mfrow=c(3,2), las=1, pty="m", mar=c(5,4,4,2)+.1)
for(i in J:1) {
  plot(returns.cross.cor[,i], ylim=c(-1,1), xaxt="n", xlab="Lag (months)",
       ylab="", main=dimnames(returns.cross.cor)[[2]][i])
  axis(side=1, at=seq(-36, 36, by=12))
  lines(lower.ci[,i], lty=1, col=2)
  lines(upper.ci[,i], lty=1, col=2)
  abline(h=0,v=0)
}

}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Whitcher, B., P. Guttorp and D. B. Percival (2000) Wavelet analysis of
covariance with application to atmospheric time series, \emph{Journal of
Geophysical Research}, \bold{105}, No. D11, 14,941-14,962.
}
\seealso{
\code{\link{wave.covariance}}, \code{\link{wave.correlation}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt_boot.R
\name{dwpt.boot}
\alias{dwpt.boot}
\title{Bootstrap Time Series Using the DWPT}
\usage{
dwpt.boot(y, wf, J = log(length(y), 2) - 1, p = 1e-04, frac = 1)
}
\arguments{
\item{y}{Not necessarily dyadic length time series.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  See
\code{\link{wave.filter}} for those wavelet filters available.}

\item{J}{Depth of the discrete wavelet packet transform.}

\item{p}{Level of significance for the white noise testing procedure.}

\item{frac}{Fraction of the time series that should be used in constructing
the likelihood function.}
}
\value{
Time series of length $N$, where $N$ is the length of \code{y}.
}
\description{
An adaptive orthonormal basis is selected in order to perform the naive
bootstrap within nodes of the wavelet packet tree.  A bootstrap realization
of the time series is produce by applying the inverse DWPT.
}
\details{
A subroutines is used to select an adaptive orthonormal basis for the
piecewise-constant approximation to the underlying spectral density function
(SDF).  Once selected, sampling with replacement is performed within each
wavelet packet coefficient vector and the new collection of wavelet packet
coefficients are reconstructed into a bootstrap realization of the original
time series.
}
\references{
Percival, D.B., S. Sardy, A. Davision (2000) Wavestrapping Time
Series: Adaptive Wavelet-Based Bootstrapping, in B.J. Fitzgerald, R.L.
Smith, A.T. Walden, P.C. Young (Eds.)  \emph{Nonlinear and Nonstationary
Signal Processing}, pp. 442-471.

Whitcher, B. (2001) Simulating Gaussian Stationary Time Series with
Unbounded Spectra, \emph{Journal of Computational and Graphical Statistics},
\bold{10}, No. 1, 112-134.

Whitcher, B. (2004) Wavelet-Based Estimation for Seasonal Long-Memory
Processes, \emph{Technometrics}, \bold{46}, No. 2, 225-238.
}
\seealso{
\code{\link{dwpt.sim}}, \code{\link{spp.mle}}
}
\author{
B. Whitcher
}
\keyword{ts}

\name{HWP Analysis}
\alias{modhwt.coh}
\alias{modhwt.phase}
\alias{modhwt.coh.seasonal}
\alias{modhwt.phase.seasonal}
\title{Time-varying and Seasonal Analysis Using Hilbert Wavelet Pairs}
\description{
  Performs time-varying or seasonal coherence and phase anlaysis between
  two time seris using the maximal-overlap discrete Hilbert wavelet
  transform (MODHWT). 
}
\usage{
modhwt.coh(x, y, f.length = 0)
modhwt.phase(x, y, f.length = 0)
modhwt.coh.seasonal(x, y, S = 10, season = 365)
modhwt.phase.seasonal(x, y, season = 365)
}
\arguments{
  \item{x}{MODHWT object.}
  \item{y}{MODHWT object.}
  \item{f.length}{Length of the rectangular filter.}
  \item{S}{Number of "seasons".}
  \item{season}{Length of the "season".}
}
\value{
  Time-varying or seasonal coherence and phase between two time series.
  The coherence estimates are between zero and one, while the phase
  estimates are between \eqn{-\pi}{-pi} and \eqn{\pi}{pi}.
}
\details{
  The idea of seasonally-varying spectral analysis (SVSA, Madden 1986)
  is generalized using the MODWT and Hilbert wavelet pairs.  For the
  seasonal case, \eqn{S} seasons are used to produce a consistent
  estimate of the coherence and phase.  For the non-seasonal case, a
  simple rectangular (moving-average) filter is applied to the MODHWT
  coefficients in order to produce consistent estimates.
}  
\references{
  Madden, R.A. (1986).  Seasonal variation of the 40--50 day oscillation
  in the tropics.  \emph{Journal of the Atmospheric Sciences\/}
  \bold{43\/}(24), 3138--3158.

  Whither, B. and P.F. Craigmile (2004).  Multivariate Spectral Analysis 
  Using Hilbert Wavelet Pairs, \emph{International Journal of Wavelets, 
  Multiresolution and Information Processing}, to appear.
}
\seealso{
  \code{\link{hilbert.filter}}
}
%\examples{}
\author{B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{kobe}
\alias{kobe}
\title{1995 Kobe Earthquake Data}
\format{
A vector containing 3048 observations.
}
\source{
Data management centre, Washington University.
}
\usage{
data(kobe)
}
\description{
Seismograph (vertical acceleration, nm/sq.sec) of the Kobe earthquake,
recorded at Tasmania University, HobarTRUE, Australia on 16 January 1995
beginning at 20:56:51 (GMTRUE) and continuing for 51 minutes at 1 second
intervals.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiple.R
\name{mult.loc}
\alias{mult.loc}
\title{Wavelet-based Testing and Locating for Variance Change Points}
\usage{
mult.loc(dwt.list, modwt.list, wf, level, min.coef, debug)
}
\arguments{
\item{dwt.list}{List of wavelet vector coefficients from the \code{dwt}.}

\item{modwt.list}{List of wavelet vector coefficients from the \code{modwt}.}

\item{wf}{Name of the wavelet filter to use in the decomposition.}

\item{level}{Specifies the depth of the decomposition.}

\item{min.coef}{Minimum number of wavelet coefficients for testing purposes.}

\item{debug}{Boolean variable: if set to \code{TRUE}, actions taken by the
algorithm are printed to the screen.}
}
\value{
Matrix.
}
\description{
This is the major subroutine for \code{\link{testing.hov}}, providing the
workhorse algorithm to recursively test and locate multiple variance changes
in so-called long memory processes.
}
\details{
For details see Section 9.6 of Percival and Walden (2000) or Section 7.3 in
Gencay, Selcuk and Whitcher (2001).
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{rotcumvar}}, \code{\link{testing.hov}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cascade.R
\name{squared.gain}
\alias{squared.gain}
\title{Squared Gain Function of a Filter}
\usage{
squared.gain(wf.name, filter.seq = "L", n = 512)
}
\arguments{
\item{wf.name}{Character string of wavelet filter.}

\item{filter.seq}{Character string of filter sequence.  \code{H} means
high-pass filtering and \code{L} means low-pass filtering.  Sequence is read
from right to left.}

\item{n}{Length of zero-padded filter.  Frequency resolution will be
\code{n}/2+1.}
}
\value{
Squared gain function.
}
\description{
Produces the modulus squared of the Fourier transform for a given filtering
sequence.
}
\details{
Uses \code{cascade} subroutine to compute the squared gain function from a
given filtering sequence.
}
\examples{

par(mfrow=c(2,2))
f.seq <- "H"
plot(0:256/512, squared.gain("d4", f.seq), type="l", ylim=c(0,2),
     xlab="frequency", ylab="L = 4", main="Level 1")
lines(0:256/512, squared.gain("fk4", f.seq), col=2)
lines(0:256/512, squared.gain("mb4", f.seq), col=3)
abline(v=c(1,2)/4, lty=2)
legend(-.02, 2, c("Daubechies", "Fejer-Korovkin", "Minimum-Bandwidth"),
       lty=1, col=1:3, bty="n", cex=1)
f.seq <- "HL"
plot(0:256/512, squared.gain("d4", f.seq), type="l", ylim=c(0,4),
     xlab="frequency", ylab="", main="Level 2")
lines(0:256/512, squared.gain("fk4", f.seq), col=2)
lines(0:256/512, squared.gain("mb4", f.seq), col=3)
abline(v=c(1,2)/8, lty=2)
f.seq <- "H"
plot(0:256/512, squared.gain("d8", f.seq), type="l", ylim=c(0,2),
     xlab="frequency", ylab="L = 8", main="")
lines(0:256/512, squared.gain("fk8", f.seq), col=2)
lines(0:256/512, squared.gain("mb8", f.seq), col=3)
abline(v=c(1,2)/4, lty=2)
f.seq <- "HL"
plot(0:256/512, squared.gain("d8", f.seq), type="l", ylim=c(0,4),
     xlab="frequency", ylab="", main="")
lines(0:256/512, squared.gain("fk8", f.seq), col=2)
lines(0:256/512, squared.gain("mb8", f.seq), col=3)
abline(v=c(1,2)/8, lty=2)

}
\seealso{
\code{\link{wave.filter}}, \code{\link{wavelet.filter}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ibm}
\alias{ibm}
\title{Daily IBM Stock Prices}
\format{
A vector containing 369 observations.
}
\source{
Box, G. E.P. and Jenkins, G. M. (1976) \emph{Time Series Analysis:
Forecasting and Control}, Holden Day, San Francisco, 2nd edition.
}
\usage{
data(ibm)
}
\description{
Daily IBM stock prices spanning May~17, 1961 to November~2, 1962.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/denoise.R
\name{manual.thresh}
\alias{manual.thresh}
\alias{Thresholding}
\alias{da.thresh}
\alias{hybrid.thresh}
\alias{sure.thresh}
\alias{universal.thresh}
\alias{universal.thresh.modwt}
\alias{bishrink}
\alias{soft}
\title{Wavelet Shrinkage via Thresholding}
\usage{
da.thresh(wc, alpha = .05, max.level = 4, verbose = FALSE, return.thresh = FALSE)

hybrid.thresh(wc, max.level = 4, verbose = FALSE, seed = 0)

manual.thresh(wc, max.level = 4, value, hard = TRUE)

sure.thresh(wc, max.level = 4, hard = TRUE)

universal.thresh(wc, max.level = 4, hard = TRUE)

universal.thresh.modwt(wc, max.level = 4, hard = TRUE)
}
\arguments{
\item{wc}{wavelet coefficients}

\item{max.level}{maximum level of coefficients to be affected by threshold}

\item{value}{threshold value (only utilized in \code{manual.thresh})}

\item{hard}{Boolean value, if \code{hard=F} then soft thresholding is used}

\item{alpha}{level of the hypothesis tests}

\item{verbose}{if \code{verbose=TRUE} then information is printed to the
screen}

\item{seed}{sets random seed (only utilized in \code{hybrid.thresh})}

\item{return.thresh}{if \code{return.thresh=TRUE} then the vector of
threshold values is returned, otherwise the surviving wavelet coefficients
are returned}
}
\value{
The default output is a list structure, the same length as was
input, containing only those wavelet coefficients surviving the threshold.
}
\description{
Perform wavelet shrinkage using data-analytic, hybrid SURE, manual, SURE, or
universal thresholding.
}
\details{
An extensive amount of literature has been written on wavelet shrinkage.
The functions here represent the most basic approaches to the problem of
nonparametric function estimation.  See the references for further
information.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Ogden, R. T. (1996) \emph{Essential Wavelets for Statistical Applications
and Data Analysis}, Birkhauser.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.

Vidakovic, B. (1999) \emph{Statistical Modeling by Wavelets}, John Wiley and
Sons.
}
\author{
B. Whitcher (some code taken from R. Todd Ogden)
}
\keyword{ts}

\name{Dualtree Complex}
\alias{cplxdual2D}
\alias{icplxdual2D}
\title{Dual-tree Complex 2D Discrete Wavelet Transform}
\description{
  Dual-tree complex 2D discrete wavelet transform (DWT).
}
\usage{
cplxdual2D(x, J, Faf, af)
icplxdual2D(w, J, Fsf, sf)
}
\arguments{
  \item{x}{2D array.}
  \item{w}{wavelet coefficients.}
  \item{J}{number of stages.}
  \item{Faf}{first stage analysis filters for tree \eqn{i}.}
  \item{af}{analysis filters for the remaining stages on tree \eqn{i}.}
  \item{Fsf}{last stage synthesis filters for tree \eqn{i}.}
  \item{sf}{synthesis filters for the preceeding stages.}
}
%\details{}
\value{
  For the analysis of \code{x}, the output is
  \item{w}{wavelet coefficients indexed by
    \code{[[j]][[i]][[d1]][[d2]]}, where \eqn{j=1,\ldots,J} (scale),
    \eqn{i=1} (real part) or \eqn{i=2} (imag part), \eqn{d1=1,2} and
    \eqn{d2=1,2,3} (orientations).}
  For the synthesis of \code{w}, the output is 
  \item{y}{output signal.}
}
\references{
  WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY\cr
  \url{http://eeweb.poly.edu/iselesni/WaveletSoftware/}
}
\seealso{
  \code{\link{FSfarras}}, \code{\link{farras}}, \code{\link{afb2D}}, 
  \code{\link{sfb2D}}.
}
\examples{
\dontrun{
## EXAMPLE: cplxdual2D
x = matrix(rnorm(32*32), 32, 32)
J = 5
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = cplxdual2D(x, J, Faf, af)
y = icplxdual2D(w, J, Fsf, sf)
err = x - y
max(abs(err))
}
}
\author{Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiple.R
\name{rotcumvar}
\alias{rotcumvar}
\title{Rotated Cumulative Variance}
\usage{
rotcumvar(x)
}
\arguments{
\item{x}{vector of coefficients to be cumulatively summed (missing values
excluded)}
}
\value{
Vector of coefficients that are the sumulative sum of squared input
coefficients.
}
\description{
Provides the normalized cumulative sums of squares from a sequence of
coefficients with the diagonal line removed.
}
\details{
The rotated cumulative variance, when plotted, provides a qualitative way to
study the time dependence of the variance of a series.  If the variance is
stationary over time, then only small deviations from zero should be
present.  If on the other hand the variance is non-stationary, then large
departures may exist.  Formal hypothesis testing may be performed based on
boundary crossings of Brownian bridge processes.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree2D.R
\name{convolve2D}
\alias{convolve2D}
\title{Fast Column-wise Convolution of a Matrix}
\usage{
convolve2D(x, y, conj = TRUE, type = c("circular", "open"))
}
\arguments{
\item{x}{MxN matrix.}

\item{y}{numeric sequence of length N.}

\item{conj}{logical; if \code{TRUE}, take the complex \emph{conjugate}
before back-transforming (default, and used for usual convolution).}

\item{type}{character; one of \code{circular}, \code{open} (beginning of
word is ok).  For \code{circular}, the two sequences are treated as
\emph{circular}, i.e., periodic.

For \code{open} and \code{filter}, the sequences are padded with zeros (from
left and right) first; \code{filter} returns the middle sub-vector of
\code{open}, namely, the result of running a weighted mean of \code{x} with
weights \code{y}.}
}
\description{
Use the Fast Fourier Transform to perform convolutions between a sequence
and each column of a matrix.
}
\details{
This is a corrupted version of \code{convolve} made by replacing \code{fft}
with \code{mvfft} in a few places.  It would be nice to submit this to the R
Developers for inclusion.
}
\seealso{
\code{\link{convolve}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mra.2d.R
\name{mra.2d}
\alias{mra.2d}
\title{Multiresolution Analysis of an Image}
\usage{
mra.2d(x, wf = "la8", J = 4, method = "modwt", boundary = "periodic")
}
\arguments{
\item{x}{A matrix or image containing the data be to decomposed.  This must
be have dyadic length in both dimensions (but not necessarily the same) for
\code{method="dwt"}.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length L=8 least asymmetric family.}

\item{J}{Specifies the depth of the decomposition.  This must be a number
less than or equal to log(length(x),2).}

\item{method}{Either \code{"dwt"} or \code{"modwt"}.}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the default, then the matrix you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the matrix beyond its boundaries is assumed
to be a symmetric reflection of itself.}
}
\value{
Basically, a list with the following components \item{LH?}{Wavelet
detail image in the horizontal direction.} \item{HL?}{Wavelet detail image
in the vertical direction.} \item{HH?}{Wavelet detail image in the diagonal
direction.} \item{LLJ}{Wavelet smooth image at the coarsest resolution.}
\item{J}{Depth of the wavelet transform.} \item{wavelet}{Name of the wavelet
filter used.} \item{boundary}{How the boundaries were handled.}
}
\description{
This function performs a level \eqn{J} additive decomposition of the input
matrix or image using the pyramid algorithm (Mallat 1989).
}
\details{
This code implements a two-dimensional multiresolution analysis by
performing the one-dimensional pyramid algorithm (Mallat 1989) on the rows
and columns of the input matrix.  Either the DWT or MODWT may be used to
compute the multiresolution analysis, which is an additive decomposition of
the original matrix (image).
}
\examples{

## Easy check to see if it works...
## --------------------------------

x <- matrix(rnorm(32*32), 32, 32)
# MODWT
x.mra <- mra.2d(x, method="modwt")
x.mra.sum <- x.mra[[1]]
for(j in 2:length(x.mra))
  x.mra.sum <- x.mra.sum + x.mra[[j]]
sum((x - x.mra.sum)^2)

# DWT
x.mra <- mra.2d(x, method="dwt")
x.mra.sum <- x.mra[[1]]
for(j in 2:length(x.mra))
  x.mra.sum <- x.mra.sum + x.mra[[j]]
sum((x - x.mra.sum)^2)

}
\references{
Mallat, S. G. (1989) A theory for multiresolution signal
decomposition: the wavelet representation, \emph{IEEE Transactions on
Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.

Mallat, S. G. (1998) \emph{A Wavelet Tour of Signal Processing}, Academic
Press.
}
\seealso{
\code{\link{dwt.2d}}, \code{\link{modwt.2d}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{dau}
\alias{dau}
\title{Digital Photograph of Ingrid Daubechies}
\format{
A 256 \eqn{\times}{x} 256 matrix.
}
\source{
S+WAVELETS.
}
\usage{
data(dau)
}
\description{
A digital photograph of Ingrid Daubechies taken at the 1993 AMS winter
meetings in San Antonio, Texas.  The photograph was taken by David Donoho
with a Canon XapShot video still frame camera.
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tapers.R
\name{sine.taper}
\alias{sine.taper}
\title{Computing Sinusoidal Data Tapers}
\usage{
sine.taper(n, k)
}
\arguments{
\item{n}{length of data taper(s)}

\item{k}{number of data tapers}
}
\value{
A vector or matrix of data tapers (cols = tapers).
}
\description{
Computes sinusoidal data tapers directly from equations.
}
\details{
See reference.
}
\references{
Riedel, K. S. and A. Sidorenko (1995) Minimum bias multiple
taper spectral estimation, \emph{IEEE Transactions on Signal Processing},
\bold{43}, 188-195.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree.R
\name{afb}
\alias{afb}
\alias{afb2D}
\alias{afb2D.A}
\alias{sfb}
\alias{sfb2D}
\alias{sfb2D.A}
\title{Filter Banks for Dual-Tree Wavelet Transforms}
\usage{
afb(x, af)

afb2D(x, af1, af2 = NULL)

afb2D.A(x, af, d)

sfb(lo, hi, sf)

sfb2D(lo, hi, sf1, sf2 = NULL)

sfb2D.A(lo, hi, sf, d)
}
\arguments{
\item{x}{vector or matrix of observations}

\item{af}{analysis filters.  First element of the list is the low-pass
filter, second element is the high-pass filter.}

\item{af1, af2}{analysis filters for the first and second dimension of a 2D
array.}

\item{sf}{synthesis filters.  First element of the list is the low-pass
filter, second element is the high-pass filter.}

\item{sf1, sf2}{synthesis filters for the first and second dimension of a 2D
array.}

\item{d}{dimension of filtering (d = 1 or 2)}

\item{lo}{low-frequecy coefficients}

\item{hi}{high-frequency coefficients}
}
\value{
In one dimension the output for the analysis filter bank
(\code{afb}) is a list with two elements \item{lo}{Low frequecy output}
\item{hi}{High frequency output} and the output for the synthesis filter
bank (\code{sfb}) is the output signal.

In two dimensions the output for the analysis filter bank (\code{afb2D}) is
a list with four elements \item{lo}{low-pass subband} \item{hi[[1]]}{'lohi'
subband} \item{hi[[2]]}{'hilo' subband} \item{hi[[3]]}{'hihi' subband} and
the output for the synthesis filter bank (\code{sfb2D}) is the output array.
}
\description{
Analysis and synthesis filter banks used in dual-tree wavelet algorithms.
}
\details{
The functions \code{afb2D.A} and \code{sfb2D.A} implement the convolutions,
either for analysis or synthesis, in one dimension only.  Thus, they are the
workhorses of \code{afb2D} and \code{sfb2D}.  The output for the analysis
filter bank along one dimension (\code{afb2D.A}) is a list with two elements
\describe{ \item{lo}{low-pass subband} \item{hi}{high-pass subband} } where
the dimension of analysis will be half its original length.  The output for
the synthesis filter bank along one dimension (\code{sfb2D.A}) will be the
output array, where the dimension of synthesis will be twice its original
length.
}
\examples{

## EXAMPLE: afb, sfb
af = farras()$af
sf = farras()$sf
x = rnorm(64)
x.afb = afb(x, af)
lo = x.afb$lo
hi = x.afb$hi
y = sfb(lo, hi, sf)
err = x - y
max(abs(err))

## EXAMPLE: afb2D, sfb2D
x = matrix(rnorm(32*64), 32, 64)
af = farras()$af
sf = farras()$sf
x.afb2D = afb2D(x, af, af)
lo = x.afb2D$lo
hi = x.afb2D$hi
y = sfb2D(lo, hi, sf, sf)
err = x - y
max(abs(err))

## Example: afb2D.A, sfb2D.A
x = matrix(rnorm(32*64), 32, 64)
af = farras()$af
sf = farras()$sf
x.afb2D.A = afb2D.A(x, af, 1)
lo = x.afb2D.A$lo
hi = x.afb2D.A$hi
y = sfb2D.A(lo, hi, sf, 1)
err = x - y
max(abs(err))
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt.R
\name{dwpt}
\alias{dwpt}
\alias{idwpt}
\alias{modwpt}
\title{(Inverse) Discrete Wavelet Packet Transforms}
\usage{
dwpt(x, wf = "la8", n.levels = 4, boundary = "periodic")

idwpt(y, y.basis)
}
\arguments{
\item{x}{a vector or time series containing the data be to decomposed. This
must be a dyadic length vector (power of 2).}

\item{wf}{Name of the wavelet filter to use in the decomposition. By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.}

\item{n.levels}{Specifies the depth of the decomposition.This must be a
number less than or equal to
\eqn{\log(\mbox{length}(x),2)}{log2[length(x)]}.}

\item{boundary}{Character string specifying the boundary condition. If
\code{boundary=="periodic"} the default, then the vector you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the vector beyond its boundaries is assumed
to be a symmetric reflection of itself.}

\item{y}{Object of S3 class \code{dwpt}.}

\item{y.basis}{Vector of character strings that describe leaves on the DWPT 
basis tree.}
}
\value{
Basically, a list with the following components 
\item{w?.?}{Wavelet coefficient vectors.  The first index is associated with 
the scale of the decomposition while the second is associated with the 
frequency partition within that level.} 
\item{wavelet}{Name of the wavelet filter used.}
\item{boundary}{How the boundaries were handled.}
}
\description{
All possible filtering combinations (low- and high-pass) are performed to
decompose a vector or time series.  The resulting coefficients are
associated with a binary tree structure corresponding to a partitioning of
the frequency axis.
}
\details{
The code implements the one-dimensional DWPT using the pyramid algorithm
(Mallat, 1989).
}
\examples{

data(mexm)
J <- 4
mexm.mra <- mra(log(mexm), "mb8", J, "modwt", "reflection")
mexm.nomean <- ts(
  apply(matrix(unlist(mexm.mra), ncol=J+1, byrow=FALSE)[,-(J+1)], 1, sum), 
  start=1957, freq=12)
mexm.dwpt <- dwpt(mexm.nomean[-c(1:4)], "mb8", 7, "reflection")

}
\references{
Mallat, S. G. (1989) A theory for multiresolution signal
decomposition: the wavelet representation, \emph{IEEE Transactions on
Pattern Analysis and Machine Intelligence}, \bold{11}(7), 674--693.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.

Wickerhauser, M. V. (1994) \emph{Adapted Wavelet Analysis from Theory to
Software}, A K Peters.
}
\seealso{
\code{\link{dwt}}, \code{\link{modwpt}}, \code{\link{wave.filter}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spp.R
\name{spp.mle}
\alias{spp.mle}
\alias{spp2.mle}
\title{Wavelet-based Maximum Likelihood Estimation for Seasonal Persistent
Processes}
\usage{
spp.mle(y, wf, J = log(length(y), 2) - 1, p = 0.01, frac = 1)

spp2.mle(y, wf, J = log(length(y), 2) - 1, p = 0.01, dyadic = TRUE, frac = 1)
}
\arguments{
\item{y}{Not necessarily dyadic length time series.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  See
\code{\link{wave.filter}} for those wavelet filters available.}

\item{J}{Depth of the discrete wavelet packet transform.}

\item{p}{Level of significance for the white noise testing procedure.}

\item{frac}{Fraction of the time series that should be used in constructing
the likelihood function.}

\item{dyadic}{Logical parameter indicating whether or not the original time
series is dyadic in length.}
}
\value{
List containing the maximum likelihood estimates (MLEs) of
\eqn{\delta}, \eqn{f_G} and \eqn{\sigma^2}, along with the value of the
likelihood for those estimates.
}
\description{
Parameter estimation for a seasonal persistent (seasonal long-memory)
process is performed via maximum likelihood on the wavelet coefficients.
}
\details{
The variance-covariance matrix of the original time series is approximated
by its wavelet-based equivalent.  A Whittle-type likelihood is then
constructed where the sums of squared wavelet coefficients are compared to
bandpass filtered version of the true spectral density function.
Minimization occurs for the fractional difference parameter \eqn{d} and the
Gegenbauer frequency \eqn{f_G}, while the innovations variance is
subsequently estimated.
}
\references{
Whitcher, B. (2004) Wavelet-based estimation for seasonal
long-memory processes, \emph{Technometrics}, \bold{46}, No. 2, 225-238.
}
\seealso{
\code{\link{fdp.mle}}
}
\author{
B. Whitcher
}
\keyword{ts}

\name{Band-pass variance}
\alias{bandpass.fdp}
\alias{bandpass.spp}
\alias{bandpass.spp2}
\alias{bandpass.var.spp}
\title{Bandpass Variance for Long-Memory Processes}
\description{
  Computes the band-pass variance for fractional difference (FD) or
  seasonal persistent (SP) processes using numeric integration of their
  spectral density function.
}
\usage{
bandpass.fdp(a, b, d)
bandpass.spp(a, b, d, fG)
bandpass.spp2(a, b, d1, f1, d2, f2)
bandpass.var.spp(delta, fG, J, Basis, Length)
}
\arguments{
  \item{a}{Left-hand boundary for the definite integral.}
  \item{b}{Right-hand boundary for the definite integral.}
  \item{d,delta,d1,d2}{Fractional difference parameter.}
  \item{fG,f1,f2}{Gegenbauer frequency.}
  \item{J}{Depth of the wavelet transform.}
  \item{Basis}{Logical vector representing the adaptive basis.}
  \item{Length}{Number of elements in Basis.}
}
\value{
  Band-pass variance for the FD or SP process between \eqn{a} and
  \eqn{b}.
}
\details{
  See references.
}
\references{
  McCoy, E. J., and A. T. Walden (1996)
  Wavelet analysis and synthesis of stationary long-memory processes,
  \emph{Journal for Computational and Graphical Statistics}, \bold{5},
  No. 1, 26-56.

  Whitcher, B. (2001)
  Simulating Gaussian stationary processes with unbounded spectra,
  \emph{Journal for Computational and Graphical Statistics}, \bold{10},
  No. 1, 112-134.
}
%\seealso{}
%\examples{}
\author{Brandon Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exchange}
\alias{exchange}
\title{Exchange Rates Between the Deutsche Mark, Japanese Yen and U.S. Dollar}
\format{
A bivariate time series containing 348 observations.
}
\source{
Unknown.
}
\usage{
data(exchange)
}
\description{
Monthly foreign exchange rates for the Deutsche Mark - U.S. Dollar (DEM-USD)
and Japanese Yen - U.S. Dollar (JPY-USD) starting in 1970.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/misc.R
\name{my.acf}
\alias{my.acf}
\alias{my.ccf}
\title{Autocovariance Functions via the Discrete Fourier Transform}
\usage{
my.acf(x)

my.ccf(a, b)
}
\arguments{
\item{x, a, b}{time series}
}
\value{
The autocovariance function for all nonnegative lags or the
cross-covariance function for all lags.
}
\description{
Computes the autocovariance function (ACF) for a time series or the
cross-covariance function (CCF) between two time series.
}
\details{
The series is zero padded to twice its length before the discrete Fourier
transform is applied.  Only the values corresponding to nonnegative lags are
provided (for the ACF).
}
\examples{

data(ibm)
ibm.returns <- diff(log(ibm))
plot(1:length(ibm.returns) - 1, my.acf(ibm.returns), type="h",
     xlab="lag", ylab="ACVS", main="Autocovariance Sequence for IBM Returns")

}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt.R
\name{ortho.basis}
\alias{ortho.basis}
\title{Derive Orthonormal Basis from Wavelet Packet Tree}
\usage{
ortho.basis(xtree)
}
\arguments{
\item{xtree}{is a vector whose entries are associated with a wavelet packet
tree.}
}
\value{
Boolean vector describing the orthonormal basis for the DWPT.
}
\description{
An orthonormal basis for the discrete wavelet transform may be characterized
via a disjoint partitioning of the frequency axis that covers
\eqn{[0,\frac{1}{2})}{[0,1/2)}.  This subroutine produces an orthonormal
basis from a full wavelet packet tree.
}
\details{
A wavelet packet tree is a binary tree of Boolean variables.  Parent nodes
are removed if any of their children exist.
}
\examples{

data(japan)
J <- 4
wf <- "mb8"
japan.mra <- mra(log(japan), wf, J, boundary="reflection")
japan.nomean <-
  ts(apply(matrix(unlist(japan.mra[-(J+1)]), ncol=J, byrow=FALSE), 1, sum),
     start=1955, freq=4)
japan.nomean2 <- ts(japan.nomean[42:169], start=1965.25, freq=4)
plot(japan.nomean2, type="l")
japan.dwpt <- dwpt(japan.nomean2, wf, 6)
japan.basis <-
  ortho.basis(portmanteau.test(japan.dwpt, p=0.01, type="other"))
# Not implemented yet
# par(mfrow=c(1,1))
# plot.basis(japan.basis)

}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mexm}
\alias{mexm}
\title{Mexican Money Supply}
\format{
A vector containing 516 observations.
}
\source{
Unknown.
}
\usage{
data(mexm)
}
\description{
Percentage changes in monthly Mexican money supply.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tapers.R
\name{dpss.taper}
\alias{dpss.taper}
\title{Calculating Thomson's Spectral Multitapers by Inverse Iteration}
\usage{
dpss.taper(n, k, nw = 4)
}
\arguments{
\item{n}{length of data taper(s)}

\item{k}{number of data tapers; 1, 2, 3, ... (do not use 0!)}

\item{nw}{product of length and half-bandwidth parameter (w)}
}
\value{
\item{v}{matrix of data tapers (cols = tapers)}
\item{eigen}{eigenvalue associated with each data taper, discarded}
}
\description{
This is now a wrapper to the function multitaper::dpss().
}
\references{
Percival, D. B. and A. T. Walden (1993) \emph{Spectral Estimation for
Physical Applications: Multitaper and Conventional Univariate Techniques},
Cambridge University Press.
}
\seealso{
\code{\link{sine.taper}}.
}
\author{
B. Whitcher
}
\keyword{ts}

\name{Dualtree}
\alias{dualtree}
\alias{idualtree}
\alias{dualtree2D}
\alias{idualtree2D}
\title{Dual-tree Complex Discrete Wavelet Transform}
\description{
  One- and two-dimensional dual-tree complex discrete wavelet transforms
  developed by Kingsbury and Selesnick \emph{et al.}
}
\usage{
dualtree(x, J, Faf, af)
idualtree(w, J, Fsf, sf)
dualtree2D(x, J, Faf, af)
idualtree2D(w, J, Fsf, sf)
}
\arguments{
  \item{x}{\eqn{N}-point vector or \eqn{M{\times}N}{MxN} matrix.}
  \item{w}{DWT coefficients.}
  \item{J}{number of stages.}
  \item{Faf}{analysis filters for the first stage.}
  \item{af}{analysis filters for the remaining stages.}
  \item{Fsf}{synthesis filters for the last stage.}
  \item{sf}{synthesis filters for the preceeding stages.}
}
\value{
  For the analysis of \code{x}, the output is
  \item{w}{DWT coefficients.  Each wavelet scale is a list containing
    the real and imaginary parts.  The final scale (\eqn{J+1}) contains
    the low-pass filter coefficients.}
  For the synthesis of \code{w}, the output is 
  \item{y}{output signal}
}
\details{
  In one dimension \eqn{N} is divisible by \eqn{2^J} and
  \eqn{N\ge2^{J-1}\cdot\mbox{length}(\mbox{\code{af}})}.

  In two dimensions, these two conditions must hold for both \eqn{M} and 
  \eqn{N}.
}
\references{
  WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY\cr
  \url{http://eeweb.poly.edu/iselesni/WaveletSoftware/}
}
\seealso{
  \code{\link{FSfarras}}, \code{\link{farras}}, \code{\link{convolve}},
  \code{\link{cshift}}, \code{\link{afb}}, \code{\link{sfb}}.
}
\examples{
## EXAMPLE: dualtree
x = rnorm(512)
J = 4
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = dualtree(x, J, Faf, af)
y = idualtree(w, J, Fsf, sf)
err = x - y
max(abs(err))

## Example: dualtree2D
x = matrix(rnorm(64*64), 64, 64)
J = 3
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = dualtree2D(x, J, Faf, af)
y = idualtree2D(w, J, Fsf, sf)
err = x - y
max(abs(err))

## Display 2D wavelets of dualtree2D.m

J <- 4
L <- 3 * 2^(J+1)
N <- L / 2^J
Faf <- FSfarras()$af
Fsf <- FSfarras()$sf
af <- dualfilt1()$af
sf <- dualfilt1()$sf
x <- matrix(0, 2*L, 3*L)
w <- dualtree2D(x, J, Faf, af)
w[[J]][[1]][[1]][N/2, N/2+0*N] <- 1
w[[J]][[1]][[2]][N/2, N/2+1*N] <- 1
w[[J]][[1]][[3]][N/2, N/2+2*N] <- 1
w[[J]][[2]][[1]][N/2+N, N/2+0*N] <- 1
w[[J]][[2]][[2]][N/2+N, N/2+1*N] <- 1
w[[J]][[2]][[3]][N/2+N, N/2+2*N] <- 1
y <- idualtree2D(w, J, Fsf, sf)
image(t(y), col=grey(0:64/64), axes=FALSE)
}
\author{Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree.R
\name{dualtree}
\alias{dualtree}
\alias{idualtree}
\alias{dualtree2D}
\alias{idualtree2D}
\title{Dual-tree Complex Discrete Wavelet Transform}
\usage{
dualtree(x, J, Faf, af)

idualtree(w, J, Fsf, sf)

dualtree2D(x, J, Faf, af)

idualtree2D(w, J, Fsf, sf)
}
\arguments{
\item{x}{N-point vector or MxN matrix.}

\item{J}{number of stages.}

\item{Faf}{analysis filters for the first stage.}

\item{af}{analysis filters for the remaining stages.}

\item{w}{DWT coefficients.}

\item{Fsf}{synthesis filters for the last stage.}

\item{sf}{synthesis filters for the preceeding stages.}
}
\value{
For the analysis of \code{x}, the output is \item{w}{DWT
coefficients.  Each wavelet scale is a list containing the real and
imaginary parts.  The final scale (J+1) contains the low-pass filter
coefficients.} For the synthesis of \code{w}, the output is \item{y}{output
signal}
}
\description{
One- and two-dimensional dual-tree complex discrete wavelet transforms
developed by Kingsbury and Selesnick \emph{et al.}
}
\details{
In one dimension \eqn{N} is divisible by \eqn{2^J} and
\eqn{N\ge2^{J-1}\cdot\mbox{length}(\mbox{\code{af}})}.

In two dimensions, these two conditions must hold for both \eqn{M} and
\eqn{N}.
}
\examples{

## EXAMPLE: dualtree
x = rnorm(512)
J = 4
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = dualtree(x, J, Faf, af)
y = idualtree(w, J, Fsf, sf)
err = x - y
max(abs(err))

## Example: dualtree2D
x = matrix(rnorm(64*64), 64, 64)
J = 3
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = dualtree2D(x, J, Faf, af)
y = idualtree2D(w, J, Fsf, sf)
err = x - y
max(abs(err))

## Display 2D wavelets of dualtree2D.m

J <- 4
L <- 3 * 2^(J+1)
N <- L / 2^J
Faf <- FSfarras()$af
Fsf <- FSfarras()$sf
af <- dualfilt1()$af
sf <- dualfilt1()$sf
x <- matrix(0, 2*L, 3*L)
w <- dualtree2D(x, J, Faf, af)
w[[J]][[1]][[1]][N/2, N/2+0*N] <- 1
w[[J]][[1]][[2]][N/2, N/2+1*N] <- 1
w[[J]][[1]][[3]][N/2, N/2+2*N] <- 1
w[[J]][[2]][[1]][N/2+N, N/2+0*N] <- 1
w[[J]][[2]][[2]][N/2+N, N/2+1*N] <- 1
w[[J]][[2]][[3]][N/2+N, N/2+2*N] <- 1
y <- idualtree2D(w, J, Fsf, sf)
image(t(y), col=grey(0:64/64), axes=FALSE)

}
\seealso{
\code{\link{FSfarras}}, \code{\link{farras}},
\code{\link{convolve}}, \code{\link{cshift}}, \code{\link{afb}},
\code{\link{sfb}}.
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwt.R
\name{dwt}
\alias{dwt}
\alias{dwt.nondyadic}
\alias{idwt}
\title{Discrete Wavelet Transform (DWT)}
\usage{
dwt(x, wf = "la8", n.levels = 4, boundary = "periodic")

dwt.nondyadic(x)

idwt(y)
}
\arguments{
\item{x}{a vector or time series containing the data be to decomposed.  This
must be a dyadic length vector (power of 2).}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.}

\item{n.levels}{Specifies the depth of the decomposition.  This must be a
number less than or equal to log(length(x),2).}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the default, then the vector you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the vector beyond its boundaries is assumed
to be a symmetric reflection of itself.}

\item{y}{An object of S3 class \code{dwt}.}
}
\value{
Basically, a list with the following components 
\item{d?}{Wavelet coefficient vectors.} 
\item{s?}{Scaling coefficient vector.}
\item{wavelet}{Name of the wavelet filter used.} 
\item{boundary}{How the boundaries were handled.}
}
\description{
This function performs a level \eqn{J} decomposition of the input vector or
time series using the pyramid algorithm (Mallat 1989).
}
\details{
The code implements the one-dimensional DWT using the pyramid algorithm
(Mallat, 1989).  The actual transform is performed in C using pseudocode
from Percival and Walden (2001).  That means convolutions, not inner
products, are used to apply the wavelet filters.

For a non-dyadic length vector or time series, \code{dwt.nondyadic} pads
with zeros, performs the orthonormal DWT on this dyadic length series and
then truncates the wavelet coefficient vectors appropriately.
}
\examples{

## Figures 4.17 and 4.18 in Gencay, Selcuk and Whitcher (2001).
data(ibm)     
ibm.returns <- diff(log(ibm))
## Haar
ibmr.haar <- dwt(ibm.returns, "haar")
names(ibmr.haar) <- c("w1", "w2", "w3", "w4", "v4")
## plot partial Haar DWT for IBM data
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.returns, axes=FALSE, ylab="", main="(a)")
for(i in 1:4)
  plot.ts(up.sample(ibmr.haar[[i]], 2^i), type="h", axes=FALSE,
          ylab=names(ibmr.haar)[i])
plot.ts(up.sample(ibmr.haar$v4, 2^4), type="h", axes=FALSE,
        ylab=names(ibmr.haar)[5])
axis(side=1, at=seq(0,368,by=23), 
     labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
## LA(8)
ibmr.la8 <- dwt(ibm.returns, "la8")
names(ibmr.la8) <- c("w1", "w2", "w3", "w4", "v4")
## must shift LA(8) coefficients
ibmr.la8$w1 <- c(ibmr.la8$w1[-c(1:2)], ibmr.la8$w1[1:2])
ibmr.la8$w2 <- c(ibmr.la8$w2[-c(1:2)], ibmr.la8$w2[1:2])
for(i in names(ibmr.la8)[3:4])
  ibmr.la8[[i]] <- c(ibmr.la8[[i]][-c(1:3)], ibmr.la8[[i]][1:3])
ibmr.la8$v4 <- c(ibmr.la8$v4[-c(1:2)], ibmr.la8$v4[1:2])
## plot partial LA(8) DWT for IBM data
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.returns, axes=FALSE, ylab="", main="(b)")
for(i in 1:4)
  plot.ts(up.sample(ibmr.la8[[i]], 2^i), type="h", axes=FALSE,
          ylab=names(ibmr.la8)[i])
plot.ts(up.sample(ibmr.la8$v4, 2^4), type="h", axes=FALSE,
        ylab=names(ibmr.la8)[5])
axis(side=1, at=seq(0,368,by=23), 
  labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))

}
\references{
Daubechies, I. (1992) \emph{Ten Lectures on Wavelets}, CBMS-NSF
Regional Conference Series in Applied Mathematics, SIAM: Philadelphia.

Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An Introduction to
Wavelets and Other Filtering Methods in Finance and Economics}, Academic
Press.

Mallat, S. G. (1989) A theory for multiresolution signal decomposition: the
wavelet representation, \emph{IEEE Transactions on Pattern Analysis and
Machine Intelligence}, \bold{11}(7), 674--693.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{modwt}}, \code{\link{mra}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fdp.R
\name{fdp.mle}
\alias{fdp.mle}
\title{Wavelet-based Maximum Likelihood Estimation for a Fractional Difference
Process}
\usage{
fdp.mle(y, wf, J = log(length(y), 2))
}
\arguments{
\item{y}{Dyadic length time series.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  See
\code{\link{wave.filter}} for those wavelet filters available.}

\item{J}{Depth of the discrete wavelet transform.}
}
\value{
List containing the maximum likelihood estimates (MLEs) of \eqn{d}
and \eqn{\sigma^2}, along with the value of the likelihood for those
estimates.
}
\description{
Parameter estimation for a fractional difference (long-memory, self-similar)
process is performed via maximum likelihood on the wavelet coefficients.
}
\details{
The variance-covariance matrix of the original time series is approximated
by its wavelet-based equivalent.  A Whittle-type likelihood is then
constructed where the sums of squared wavelet coefficients are compared to
bandpass filtered version of the true spectrum.  Minimization occurs only
for the fractional difference parameter \eqn{d}, while variance is estimated
afterwards.
}
\examples{

## Figure 5.5 in Gencay, Selcuk and Whitcher (2001)
fdp.sdf <- function(freq, d, sigma2=1)
  sigma2 / ((2*sin(pi * freq))^2)^d
dB <- function(x) 10 * log10(x)
per <- function(z) {
  n <- length(z)
  (Mod(fft(z))**2/(2*pi*n))[1:(n \%/\% 2 + 1)]
}
data(ibm)     
ibm.returns <- diff(log(ibm))
ibm.volatility <- abs(ibm.returns)
ibm.vol.mle <- fdp.mle(ibm.volatility, "d4", 4)
freq <- 0:184/368
ibm.vol.per <- 2 * pi * per(ibm.volatility)
ibm.vol.resid <- ibm.vol.per/ fdp.sdf(freq, ibm.vol.mle$parameters[1])
par(mfrow=c(1,1), las=0, pty="m")
plot(freq, dB(ibm.vol.per), type="l", xlab="Frequency", ylab="Spectrum")
lines(freq, dB(fdp.sdf(freq, ibm.vol.mle$parameters[1],
                       ibm.vol.mle$parameters[2]/2)), col=2)

}
\references{
M. J. Jensen (2000) An alternative maximum likelihood estimator
of long-memory processes using compactly supported wavelets, \emph{Journal
of Economic Dynamics and Control}, \bold{24}, No. 3, 361-387.

McCoy, E. J., and A. T. Walden (1996) Wavelet analysis and synthesis of
stationary long-memory processes, \emph{Journal for Computational and
Graphical Statistics}, \bold{5}, No. 1, 26-56.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hilbert.R
\name{hilbert.filter}
\alias{hilbert.filter}
\title{Select a Hilbert Wavelet Pair}
\usage{
hilbert.filter(name)
}
\arguments{
\item{name}{Character string of Hilbert wavelet pair, see acceptable names
below (e.g., \code{"k3l3"}).}
}
\value{
List containing the following items: \item{L}{length of the wavelet
filter} \item{h0,g0}{low-pass filter coefficients} \item{h1,g1}{high-pass
filter coefficients}
}
\description{
Converts name of Hilbert wavelet pair to filter coefficients.
}
\details{
Simple \code{switch} statement selects the appropriate HWP.  There are two
parameters that define a Hilbert wavelet pair using the notation of
Selesnick (2001,2002), \eqn{K} and \eqn{L}.  Currently, the only implemented
combinations \eqn{(K,L)} are (3,3), (3,5), (4,2) and (4,4).
}
\examples{

hilbert.filter("k3l3")
hilbert.filter("k3l5")
hilbert.filter("k4l2")
hilbert.filter("k4l4")

}
\references{
Selesnick, I.W. (2001). Hilbert transform pairs of wavelet
bases. \emph{IEEE Signal Processing Letters} \bold{8}(6), 170--173.

Selesnick, I.W. (2002). The design of approximate Hilbert transform pairs
of wavelet bases. \emph{IEEE Transactions on Signal Processing} 
\bold{50}(5), 1144--1152.
}
\seealso{
\code{\link{wave.filter}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/two_D.R
\name{plot.dwt.2d}
\alias{plot.dwt.2d}
\title{Plot Two-dimensional Discrete Wavelet Transform}
\usage{
\method{plot}{dwt.2d}(x, cex.axis = 1, plot = TRUE, ...)
}
\arguments{
\item{x}{input matrix (image)}

\item{cex.axis}{\code{par} plotting parameter that controls the size of the
axis text}

\item{plot}{if \code{plot = FALSE} then the matrix of wavelet coefficients
is returned, the default is \code{plot = TRUE}}

\item{...}{additional graphical parameters if necessary}
}
\value{
Image plot.
}
\description{
Organizes the wavelet coefficients from a 2D DWT into a single matrix and
plots it.  The coarser resolutions are nested within the lower-lefthand
corner of the image.
}
\details{
The wavelet coefficients from the DWT object (a list) are reorganized into a
single matrix of the same dimension as the original image and the result is
plotted.
}
\seealso{
\code{\link{dwt.2d}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiple.R
\name{testing.hov}
\alias{testing.hov}
\title{Testing for Homogeneity of Variance}
\usage{
testing.hov(x, wf, J, min.coef = 128, debug = FALSE)
}
\arguments{
\item{x}{Sequence of observations from a (long memory) time series.}

\item{wf}{Name of the wavelet filter to use in the decomposition.}

\item{J}{Specifies the depth of the decomposition.  This must be a number
less than or equal to \eqn{\log(\mbox{length}(x),2)}{log(length(x),2)}.}

\item{min.coef}{Minimum number of wavelet coefficients for testing purposes.
Empirical results suggest that 128 is a reasonable number in order to apply
asymptotic critical values.}

\item{debug}{Boolean variable: if set to \code{TRUE}, actions taken by the
algorithm are printed to the screen.}
}
\value{
Matrix whose columns include (1) the level of the wavelet transform
where the variance change occurs, (2) the value of the test statistic, (3)
the DWT coefficient where the change point is located, (4) the MODWT
coefficient where the change point is located.  Note, there is currently no
checking that the MODWT is contained within the associated support of the
DWT coefficient.  This could lead to incorrect estimates of the location of
the variance change.
}
\description{
A recursive algorithm for detecting and locating multiple variance change
points in a sequence of random variables with long-range dependence.
}
\details{
For details see Section 9.6 of Percival and Walden (2000) or Section 7.3 in
Gencay, Selcuk and Whitcher (2001).
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{dwt}}, \code{\link{modwt}}, \code{\link{rotcumvar}},
\code{\link{mult.loc}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wave.filter.R
\name{qmf}
\alias{qmf}
\title{Quadrature Mirror Filter}
\usage{
qmf(g, low2high = TRUE)
}
\arguments{
\item{g}{Filter coefficients.}

\item{low2high}{Logical, default is \code{TRUE} which means a low-pass
filter is input and a high-pass filter is output.  Setting \code{low2high=F}
performs the inverse.}
}
\value{
Quadrature mirror filter.
}
\description{
Computes the quadrature mirror filter from a given filter.
}
\details{
None.
}
\examples{

## Haar wavelet filter
g <- wave.filter("haar")$lpf
qmf(g)

}
\references{
Any basic signal processing text.
}
\seealso{
\code{\link{wave.filter}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree.R
\name{dualfilt1}
\alias{dualfilt1}
\alias{AntonB}
\title{Kingsbury's Q-filters for the Dual-Tree Complex DWT}
\usage{
dualfilt1()
}
\value{
\item{af}{List (i=1,2) - analysis filters for tree i} \item{sf}{List
(i=1,2) - synthesis filters for tree i} Note: \code{af[[2]]} is the reverse
of \code{af[[1]]}.
}
\description{
Kingsbury's Q-filters for the dual-tree complex DWT.
}
\details{
These cofficients are rounded to 8 decimal places.
}
\references{
Kingsbury, N.G. (2000).  A dual-tree complex wavelet transform
with improved orthogonality and symmetry properties, \emph{Proceedings of
the IEEE Int. Conf. on Image Proc.} (ICIP).
}
\seealso{
\code{\link{dualtree}}
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt_sim.R
\name{dwpt.sim}
\alias{dwpt.sim}
\title{Simulate Seasonal Persistent Processes Using the DWPT}
\usage{
dwpt.sim(N, wf, delta, fG, M = 2, adaptive = TRUE, epsilon = 0.05)
}
\arguments{
\item{N}{Length of time series to be generated.}

\item{wf}{Character string for the wavelet filter.}

\item{delta}{Long-memory parameter for the seasonal persistent process.}

\item{fG}{Gegenbauer frequency.}

\item{M}{Actual length of simulated time series.}

\item{adaptive}{Logical; if \code{TRUE} the orthonormal basis used in the
DWPT is adapted to the ideal spectrum, otherwise the orthonormal basis is
performed to a maximum depth.}

\item{epsilon}{Threshold for adaptive basis selection.}
}
\value{
Time series of length \code{N}.
}
\description{
A seasonal persistent process may be characterized by a spectral density
function with an asymptote occuring at a particular frequency in
\eqn{[0,\frac{1}{2})}{[0,1/2)}.  It's time domain representation was first
noted in passing by Hosking (1981).  Although an exact time-domain approach
to simulation is possible, this function utilizes the discrete wavelet
packet transform (DWPT).
}
\details{
Two subroutines are used, the first selects an adaptive orthonormal basis
for the true spectral density function (SDF) while the second computes the
bandpass variances associated with the chosen orthonormal basis and SDF.
Finally, when \eqn{M>N}{\code{M} > \code{N}} a uniform random variable is
generated in order to select a random piece of the simulated time series.
For more details see Whitcher (2001).
}
\examples{

## Generate monthly time series with annual oscillation
## library(ts) is required in order to access acf()
x <- dwpt.sim(256, "mb16", .4, 1/12, M=4, epsilon=.001)
par(mfrow=c(2,1))
plot(x, type="l", xlab="Time")
acf(x, lag.max=128, ylim=c(-.6,1))
data(acvs.andel8)
lines(acvs.andel8$lag[1:128], acvs.andel8$acf[1:128], col=2)

}
\references{
Hosking, J. R. M. (1981) Fractional Differencing,
\emph{Biometrika}, \bold{68}, No. 1, 165-176.

Whitcher, B. (2001) Simulating Gaussian Stationary Time Series with
Unbounded Spectra, \emph{Journal of Computational and Graphical Statistics},
\bold{10}, No. 1, 112-134.
}
\seealso{
\code{\link{hosking.sim}} for an exact time-domain method and
\code{\link{wave.filter}} for a list of available wavelet filters.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree.R
\name{cshift}
\alias{cshift}
\alias{cshift2D}
\alias{pm}
\title{Miscellaneous Functions for Dual-Tree Wavelet Software}
\usage{
cshift(x, m)

cshift2D(x, m)

pm(a, b)
}
\arguments{
\item{x}{N-point vector}

\item{m}{amount of shift}

\item{a, b}{input parameters}
}
\value{
\item{y}{vector \code{x} will be shifed by \code{m} samples to the
left or matrix \code{x} will be shifed by \code{m} samples down.}
\item{u}{(a + b) / sqrt(2)} \item{v}{(a - b) / sqrt(2)}
}
\description{
Miscellaneous functions for dual-tree wavelet software.
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

\name{Andel}
\alias{acvs.andel8}
\alias{acvs.andel9}
\alias{acvs.andel10}
\alias{acvs.andel11}
\title{Autocovariance and Autocorrelation Sequences for a Seasonal
  Persistent Process}
\description{
  The autocovariance and autocorrelation sequences from the time series
  model in Figures 8, 9, 10, and 11 of Andel (1986).  They were obtained
  through numeric integration of the spectral density function.
}
\usage{data(acvs.andel8)
data(acvs.andel9)
data(acvs.andel10)
data(acvs.andel11)
}
\format{
  A data frame with 4096 rows and three columns: lag, autocovariance sequence,
  autocorrelation sequence.
}
\references{
  Andel, J. (1986)
  Long memory time series models,
  \emph{Kypernetika}, \bold{22}, No. 2, 105-123.
}
\keyword{datasets}

\name{stackPlot}
\alias{stackPlot}
\title{Stack Plot}
\description{
  Stack plot of an object.  This function attempts to mimic a function
  called \code{stack.plot} in S+WAVELETS.  It is mostly a hacked version
  of \code{plot.ts} in \R.
}
\usage{stackPlot(x, plot.type = c("multiple", "single"), panel = lines, 
    log = "", col = par("col"), bg = NA, pch = par("pch"), cex = par("cex"),
    lty = par("lty"), lwd = par("lwd"), ann = par("ann"), xlab = "Time",
    main = NULL, oma = c(6, 0, 5, 0), layout = NULL,
    same.scale = 1:dim(x)[2], ...)
}
\arguments{
  \item{x}{\code{ts} object}
  \item{layout}{Doublet defining the dimension of the panel.  If not
    specified, the dimensions are chosen automatically.}
  \item{same.scale}{Vector the same length as the number of series to be
    plotted.  If not specified, all panels will have unique axes.}
  \item{plot.type,panel,log,col,bg,pch,cex,lty,lwd,ann,xlab,main,oma,...}{See \code{plot.ts}.}
}
%\value{}
\details{
  Produces a set of plots, one for each element (column) of \code{x}.
}
%\references{}
%\seealso{}
\author{Brandon Whitcher}
%\examples{}
\keyword{hplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{barbara}
\alias{barbara}
\title{Barbara Test Image}
\format{
A 256 \eqn{\times}{x} 256 matrix.
}
\source{
Internet.
}
\usage{
data(barbara)
}
\description{
The Barbara image comes from Allen Gersho's lab at the University of
California, Santa Barbara.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hilbert.R
\name{modhwt.coh}
\alias{modhwt.coh}
\alias{modhwt.phase}
\alias{modhwt.coh.seasonal}
\alias{modhwt.phase.seasonal}
\title{Time-varying and Seasonal Analysis Using Hilbert Wavelet Pairs}
\usage{
modhwt.coh(x, y, f.length = 0)

modhwt.phase(x, y, f.length = 0)

modhwt.coh.seasonal(x, y, S = 10, season = 365)

modhwt.phase.seasonal(x, y, season = 365)
}
\arguments{
\item{x}{MODHWT object.}

\item{y}{MODHWT object.}

\item{f.length}{Length of the rectangular filter.}

\item{S}{Number of "seasons".}

\item{season}{Length of the "season".}
}
\value{
Time-varying or seasonal coherence and phase between two time
series.  The coherence estimates are between zero and one, while the phase
estimates are between \eqn{-\pi}{-pi} and \eqn{\pi}{pi}.
}
\description{
Performs time-varying or seasonal coherence and phase anlaysis between two
time seris using the maximal-overlap discrete Hilbert wavelet transform
(MODHWT).
}
\details{
The idea of seasonally-varying spectral analysis (SVSA, Madden 1986) is
generalized using the MODWT and Hilbert wavelet pairs.  For the seasonal
case, \eqn{S} seasons are used to produce a consistent estimate of the
coherence and phase.  For the non-seasonal case, a simple rectangular
(moving-average) filter is applied to the MODHWT coefficients in order to
produce consistent estimates.
}
\references{
Madden, R.A. (1986). Seasonal variation of the 40--50 day
oscillation in the tropics. \emph{Journal of the Atmospheric Sciences}
\bold{43}(24), 3138--3158.

Whither, B. and P.F. Craigmile (2004). Multivariate Spectral Analysis Using
Hilbert Wavelet Pairs, \emph{International Journal of Wavelets,
Multiresolution and Information Processing}, \bold{2}(4), 567--587.
}
\seealso{
\code{\link{hilbert.filter}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwt.R
\name{modwt}
\alias{modwt}
\alias{imodwt}
\title{(Inverse) Maximal Overlap Discrete Wavelet Transform}
\usage{
modwt(x, wf = "la8", n.levels = 4, boundary = "periodic")

imodwt(y)
}
\arguments{
\item{x}{a vector or time series containing the data be to decomposed.
There is \bold{no} restriction on its length.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length L=8 (Daubechies, 1992), least asymmetric family.}

\item{n.levels}{Specifies the depth of the decomposition.  This must be a
number less than or equal to log(length(x),2).}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the defaulTRUE, then the vector you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the vector beyond its boundaries is assumed
to be a symmetric reflection of itself.}

\item{y}{an object of class \code{"modwt"}}
}
\value{
Basically, a list with the following components 
\item{d?}{Wavelet coefficient vectors.} 
\item{s?}{Scaling coefficient vector.} 
\item{wavelet}{Name of the wavelet filter used.}
\item{boundary}{How the boundaries were handled.}
}
\description{
This function performs a level \eqn{J} decomposition of the input vector
using the non-decimated discrete wavelet transform. The inverse transform
performs the reconstruction of a vector or time series from its maximal
overlap discrete wavelet transform.
}
\details{
The code implements the one-dimensional non-decimated DWT using the pyramid
algorithm.  The actual transform is performed in C using pseudocode from
Percival and Walden (2001).  That means convolutions, not inner products,
are used to apply the wavelet filters.

The MODWT goes by several names in the statistical and engineering
literature, such as, the ``stationary DWT'', ``translation-invariant DWT'',
and ``time-invariant DWT''.

The inverse MODWT implements the one-dimensional inverse transform using the
pyramid algorithm (Mallat, 1989).
}
\examples{

## Figure 4.23 in Gencay, Selcuk and Whitcher (2001)
data(ibm)     
ibm.returns <- diff(log(ibm))
# Haar
ibmr.haar <- modwt(ibm.returns, "haar")
names(ibmr.haar) <- c("w1", "w2", "w3", "w4", "v4")
# LA(8)
ibmr.la8 <- modwt(ibm.returns, "la8")
names(ibmr.la8) <- c("w1", "w2", "w3", "w4", "v4")
# shift the MODWT vectors
ibmr.la8 <- phase.shift(ibmr.la8, "la8")
## plot partial MODWT for IBM data
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.returns, axes=FALSE, ylab="", main="(a)")
for(i in 1:5)
  plot.ts(ibmr.haar[[i]], axes=FALSE, ylab=names(ibmr.haar)[i])
axis(side=1, at=seq(0,368,by=23), 
  labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.returns, axes=FALSE, ylab="", main="(b)")
for(i in 1:5)
  plot.ts(ibmr.la8[[i]], axes=FALSE, ylab=names(ibmr.la8)[i])
axis(side=1, at=seq(0,368,by=23), 
  labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))

}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Percival, D. B. and P. Guttorp (1994) Long-memory processes, the Allan
variance and wavelets, In \emph{Wavelets and Geophysics}, pages 325-344,
Academic Press.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{dwt}}, \code{\link{idwt}}, \code{\link{mra}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{cpi}
\alias{cpi}
\title{U.S. Consumer Price Index}
\format{
A vector containing 624 observations.
}
\source{
Unknown.
}
\usage{
data(cpi)
}
\description{
Monthly U.S. consumer price index from 1948:1 to 1999:12.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hilbert.R
\name{phase.shift.hilbert}
\alias{phase.shift.hilbert}
\alias{phase.shift.hilbert.packet}
\title{Phase Shift for Hilbert Wavelet Coefficients}
\usage{
phase.shift.hilbert(x, wf)
}
\arguments{
\item{x}{Discete Hilbert wavelet transform (DHWT) object.}

\item{wf}{character string; Hilbert wavelet pair used in DHWT}
}
\value{
DHWT (DHWPT) object with coefficients circularly shifted.
}
\description{
Wavelet coefficients are circularly shifted by the amount of phase shift
induced by the discrete Hilbert wavelet transform.
}
\details{
The "center-of-energy" argument of Hess-Nielsen and Wickerhauser (1996) is
used to provide a flexible way to circularly shift wavelet coefficients
regardless of the wavelet filter used.
}
\references{
Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
523-540.
}
\seealso{
\code{\link{phase.shift}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{japan}
\alias{japan}
\title{Japanese Gross National Product}
\format{
A vector containing 169 observations.
}
\source{
Unknown.
}
\usage{
data(japan)
}
\description{
Quarterly Japanese gross national product from 1955:1 to 1996:4.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Hecq, A. (1998) Does seasonal adjustment induce common cycles?,
\emph{Empirical Economics}, \bold{59}, 289-297.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt_sim.R
\name{find.adaptive.basis}
\alias{find.adaptive.basis}
\title{Determine an Orthonormal Basis for the Discrete Wavelet Packet Transform}
\usage{
find.adaptive.basis(wf, J, fG, eps)
}
\arguments{
\item{wf}{Character string; name of the wavelet filter.}

\item{J}{Depth of the discrete wavelet packet transform.}

\item{fG}{Gegenbauer frequency.}

\item{eps}{Threshold for the squared gain function.}
}
\value{
Boolean vector describing the orthonormal basis for the DWPT.
}
\description{
Subroutine for use in simulating seasonal persistent processes using the
discrete wavelet packet transform.
}
\details{
The squared gain functions for a Daubechies (extremal phase or least
asymmetric) wavelet family are used in a filter cascade to compute the value
of the squared gain function for the wavelet packet filter at the
Gengenbauer frequency.  This is done for all nodes of the wavelet packet
table.

The idea behind this subroutine is to approximate the relationship between
the discrete wavelet transform and long-memory processes, where the squared
gain function is zero at frequency zero for all levels of the DWT.
}
\seealso{
Used in \code{\link{dwpt.sim}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wave.filter.R
\name{wave.filter}
\alias{wave.filter}
\title{Select a Wavelet Filter}
\usage{
wave.filter(name)
}
\arguments{
\item{name}{Character string of wavelet filter.}
}
\value{
List containing the following items: \item{L}{Length of the wavelet
filter.} \item{hpf}{High-pass filter coefficients.} \item{lpf}{Low-pass
filter coefficients.}
}
\description{
Converts name of wavelet filter to filter coefficients.
}
\details{
Simple \code{switch} statement selects the appropriate filter.
}
\references{
Daubechies, I. (1992) \emph{Ten Lectures on Wavelets}, CBMS-NSF
Regional Conference Series in Applied Mathematics, SIAM: Philadelphia.

Doroslovacki (1998) On the least asymmetric wavelets, \emph{IEEE
Transactions for Signal Processing}, \bold{46}, No. 4, 1125-1130.

Morris and Peravali (1999) Minimum-bandwidth discrete-time wavelets,
\emph{Signal Processing}, \bold{76}, No. 2, 181-193.

Nielsen, M. (2000) On the Construction and Frequency Localization of
Orthogonal Quadrature Filters, \emph{Journal of Approximation Theory},
\bold{108}, No. 1, 36-52.
}
\seealso{
\code{\link{wavelet.filter}}, \code{\link{squared.gain}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt.R
\name{css.test}
\alias{css.test}
\alias{cpgram.test}
\alias{entropy.test}
\alias{portmanteau.test}
\title{Testing the Wavelet Packet Tree for White Noise}
\usage{
cpgram.test(y, p = 0.05, taper = 0.1)

css.test(y)

entropy.test(y)

portmanteau.test(y, p = 0.05, type = "Box-Pierce")
}
\arguments{
\item{y}{wavelet packet tree (from the DWPT)}

\item{p}{significance level}

\item{taper}{weight of cosine bell taper (\code{cpgram.test} only)}

\item{type}{\code{"Box-Pierce"} and \code{other} recognized
(\code{portmanteau.test} only)}
}
\value{
Boolean vector of the same length as the number of nodes in the
wavelet packet tree.
}
\description{
A wavelet packet tree, from the discrete wavelet packet transform (DWPT), is
tested node-by-node for white noise.  This is the first step in selecting an
orthonormal basis for the DWPT.
}
\details{
Top-down recursive testing of the wavelet packet tree is
}
\examples{

data(mexm)
J <- 6
wf <- "la8"
mexm.dwpt <- dwpt(mexm[-c(1:4)], wf, J)
## Not implemented yet
## plot.dwpt(x.dwpt, J)
mexm.dwpt.bw <- dwpt.brick.wall(mexm.dwpt, wf, 6, method="dwpt")
mexm.tree <- ortho.basis(portmanteau.test(mexm.dwpt.bw, p=0.025))
## Not implemented yet
## plot.basis(mexm.tree)

}
\references{
Brockwell and Davis (1991) \emph{Time Series: Theory and
Methods}, (2nd. edition), Springer-Verlag.

Brown, Durbin and Evans (1975) Techniques for testing the constancy of
regression relationships over time, \emph{Journal of the Royal Statistical
Society B}, \bold{37}, 149-163.

Percival, D. B., and A. T. Walden (1993) \emph{Spectral Analysis for
Physical Applications: Multitaper and Conventional Univariate Techniques},
Cambridge University Press.
}
\seealso{
\code{\link{ortho.basis}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{nile}
\alias{nile}
\title{Nile River Minima}
\format{
A length 663 vector.
}
\source{
Toussoun, O. (1925) M\'emoire sur l'Histoire du Nil, Volume 18 in
\emph{M\'emoires a l'Institut d'Egypte}, pp. 366-404.
}
\usage{
data(nile)
}
\description{
Yearly minimal water levels of the Nile river for the years 622 to 1281,
measured at the Roda gauge near Cairo (Tousson, 1925, p. 366-385). The data
are listed in chronological sequence by row.
}
\details{
The original Nile river data supplied by Beran only contained only 500
observations (622 to 1121).  However, the book claimed to have 660
observations (622 to 1281).  The remaining observations from the book were
added, by hand, but the series still only contained 653 observations (622 to
1264).

Note, now the data consists of 663 observations (spanning the years
622-1284) as in original source (Toussoun, 1925).
}
\references{
Beran, J. (1994) \emph{Statistics for Long-Memory Processes},
Chapman Hall: Englewood, NJ.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/periodogram.R
\name{per}
\alias{per}
\title{Periodogram}
\usage{
per(z)
}
\arguments{
\item{z}{time series}
}
\description{
Computation of the periodogram via the Fast Fourier Transform (FFT).
}
\author{
Author: Jan Beran; modified: Martin Maechler, Date: Sep 1995.
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/two_D.R
\name{dwpt.2d}
\alias{dwpt.2d}
\alias{idwpt.2d}
\title{(Inverse) Discrete Wavelet Packet Transforms in Two Dimensions}
\usage{
dwpt.2d(x, wf = "la8", J = 4, boundary = "periodic")

idwpt.2d(y, y.basis)
}
\arguments{
\item{x}{a matrix or image containing the data be to decomposed.  This
ojbect must be dyadic (power of 2) in length in each dimension.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length \eqn{L=8} (Daubechies, 1992), least asymmetric
family.}

\item{J}{Specifies the depth of the decomposition.  This must be a number
less than or equal to \eqn{\log(\mbox{length}(x),2)}.}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the default, then the vector you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the vector beyond its boundaries is assumed
to be a symmetric reflection of itself.}

\item{y}{\code{dwpt.2d} object (list-based structure of matrices)}

\item{y.basis}{Boolean vector, the same length as \eqn{y}, where \code{TRUE}
means the basis tensor should be used in the reconstruction.}
}
\value{
Basically, a list with the following components
\item{w?.?-w?.?}{Wavelet coefficient matrices (images).  The first index is
associated with the scale of the decomposition while the second is
associated with the frequency partition within that level.  The left and
right strings, separated by the dash `-', correspond to the first \eqn{(x)}
and second \eqn{(y)} dimensions.} \item{wavelet}{Name of the wavelet filter
used.} \item{boundary}{How the boundaries were handled.}
}
\description{
All possible filtering combinations (low- and high-pass) are performed to
decompose a matrix or image.  The resulting coefficients are associated with
a quad-tree structure corresponding to a partitioning of the two-dimensional
frequency plane.
}
\details{
The code implements the two-dimensional DWPT using the pyramid algorithm of
Mallat (1989).
}
\references{
Mallat, S. G. (1989) A theory for multiresolution signal
decomposition: the wavelet representation, \emph{IEEE Transactions on
Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.

Wickerhauser, M. V. (1994) \emph{Adapted Wavelet Analysis from Theory to
Software}, A K Peters.
}
\seealso{
\code{\link{dwt.2d}}, \code{\link{modwt.2d}},
\code{\link{wave.filter}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{tourism}
\alias{tourism}
\title{U.S. Tourism}
\format{
A vector containing 160 observations.
}
\source{
Unknown.
}
\usage{
data(tourism)
}
\description{
Quarterly U.S. tourism figures from 1960:1 to 1999:4.
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shift.2d.R
\name{shift.2d}
\alias{shift.2d}
\title{Circularly Shift Matrices from a 2D MODWT}
\usage{
shift.2d(z, inverse = FALSE)
}
\arguments{
\item{z}{Two-dimensional MODWT object}

\item{inverse}{Boolean value on whether to perform the forward or inverse
operation.}
}
\value{
Two-dimensional MODWT object with circularly shifted coefficients.
}
\description{
Compute phase shifts for wavelet sub-matrices based on the ``center of
energy'' argument of Hess-Nielsen and Wickerhauser (1996).
}
\details{
The "center of energy" technique of Wickerhauser and Hess-Nielsen (1996) is
employed to find circular shifts for the wavelet sub-matrices such that the
coefficients are aligned with the original series.  This corresponds to
applying a (near) linear-phase filtering operation.
}
\examples{

n <- 512
G1 <- G2 <- dnorm(seq(-n/4, n/4, length=n))
G <- 100 * zapsmall(outer(G1, G2))
G <- modwt.2d(G, wf="la8", J=6)
k <- 50
xr <- yr <- trunc(n/2) + (-k:k)
par(mfrow=c(3,3), mar=c(1,1,2,1), pty="s")
for (j in names(G)[1:9]) {
  image(G[[j]][xr,yr], col=rainbow(64), axes=FALSE, main=j)
}
Gs <- shift.2d(G)
for (j in names(G)[1:9]) {
  image(Gs[[j]][xr,yr], col=rainbow(64), axes=FALSE, main=j)
}

}
\references{
Hess-Nielsen, N. and M. V. Wickerhauser (1996) Wavelets and
time-frequency analysis, \emph{Proceedings of the IEEE}, \bold{84}, No. 4,
523-540.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{phase.shift}}, \code{\link{modwt.2d}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/var_2D.R
\name{wave.variance.2d}
\alias{wave.variance.2d}
\title{Wavelet Analysis of Images}
\usage{
wave.variance.2d(x, p = 0.025)
}
\arguments{
\item{x}{image}

\item{p}{(one minus the) two-sided p-value for the confidence interval}
}
\value{
Data frame with 3J+1 rows.
}
\description{
Produces an estimate of the multiscale variance with approximate 
confidence intervals using the 2D MODWT.
}
\details{
The wavelet variance is basically the average of the squared wavelet 
coefficients across each scale and direction of an image. As shown 
in Mondal and Percival (2012), the wavelet variance is a 
scale-by-scale decomposition of the variance for a stationary spatial
process, and certain non-stationary spatial processes.
}
\references{
Mondal, D. and D. B. Percival (2012). Wavelet variance 
analysis for random fields on a regular lattice. \emph{IEEE 
Transactions on Image Processing} \bold{21}, 537–549.
}
\author{
B. Whitcher
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/three_D.R
\name{mra.3d}
\alias{mra.3d}
\title{Three Dimensional Multiresolution Analysis}
\usage{
mra.3d(x, wf = "la8", J = 4, method = "modwt", boundary = "periodic")
}
\arguments{
\item{x}{A three-dimensional array containing the data be to decomposed.
This must be have dyadic length in all three dimensions (but not necessarily
the same) for \code{method="dwt"}.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length \eqn{L=8} least asymmetric family.}

\item{J}{Specifies the depth of the decomposition.  This must be a number
less than or equal to \eqn{\log(\mbox{length}(x),2)}{log(length(x),2)}.}

\item{method}{Either \code{"dwt"} or \code{"modwt"}.}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the default and only method implemented, then
the matrix you decompose is assumed to be periodic on its defined interval.}
}
\value{
List structure containing the filter triplets associated with the
multiresolution analysis.
}
\description{
This function performs a level \eqn{J} additive decomposition of the input
array using the pyramid algorithm (Mallat 1989).
}
\details{
This code implements a three-dimensional multiresolution analysis by
performing the one-dimensional pyramid algorithm (Mallat 1989) on each
dimension of the input array.  Either the DWT or MODWT may be used to
compute the multiresolution analysis, which is an additive decomposition of
the original array.
}
\references{
Mallat, S. G. (1989) A theory for multiresolution signal
decomposition: the wavelet representation, \emph{IEEE Transactions on
Pattern Analysis and Machine Intelligence}, \bold{11}, No. 7, 674-693.

Mallat, S. G. (1998) \emph{A Wavelet Tour of Signal Processing}, Academic
Press.
}
\seealso{
\code{\link{dwt.3d}}, \code{\link{modwt.3d}}
}
\author{
B. Whitcher
}
\keyword{ts}

\name{Dual-tree Filter Banks}
\alias{afb}
\alias{afb2D}
\alias{afb2D.A}
\alias{sfb}
\alias{sfb2D}
\alias{sfb2D.A}
\title{Filter Banks for Dual-Tree Wavelet Transforms}
\description{
  Analysis and synthesis filter banks used in dual-tree wavelet
  algorithms.
}
\usage{
afb(x, af)
afb2D(x, af1, af2 = NULL)
afb2D.A(x, af, d)
sfb(lo, hi, sf)
sfb2D(lo, hi, sf1, sf2 = NULL)
sfb2D.A(lo, hi, sf, d)
}
\arguments{
  \item{x}{vector or matrix of observations}
  \item{af}{analysis filters.  First element of the list is the low-pass
    filter, second element is the high-pass filter.}
  \item{af1,af2}{analysis filters for the first and second dimension of
    a 2D array.}
  \item{sf}{synthesis filters.  First element of the list is the
    low-pass filter, second element is the high-pass filter.}
  \item{sf1,sf2}{synthesis filters for the first and second dimension of
    a 2D array.}
  \item{d}{dimension of filtering (d = 1 or 2)}
  \item{lo}{low-frequecy coefficients}
  \item{hi}{high-frequency coefficients}
}
\details{
  The functions \code{afb2D.A} and \code{sfb2D.A} implement the
  convolutions, either for analysis or synthesis, in one dimension
  only.  Thus, they are the workhorses of \code{afb2D} and
  \code{sfb2D}.  The output for the analysis filter bank along one
  dimension (\code{afb2D.A}) is a list with two elements
  \describe{
    \item{lo}{low-pass subband}
    \item{hi}{high-pass subband}
  }
  where the dimension of analysis will be half its original length.  The
  output for the synthesis filter bank along one dimension
  (\code{sfb2D.A}) will be the output array, where the dimension of
  synthesis will be twice its original length.
}
\value{
  In one dimension the output for the analysis filter bank (\code{afb})
  is a list with two elements
  \item{lo}{Low frequecy output}
  \item{hi}{High frequency output}
  and the output for the synthesis filter bank (\code{sfb}) is the
  output signal.
  
  In two dimensions the output for the analysis filter bank
  (\code{afb2D}) is a list with four elements
  \item{lo}{low-pass subband}
  \item{hi[[1]]}{'lohi' subband}
  \item{hi[[2]]}{'hilo' subband}
  \item{hi[[3]]}{'hihi' subband}
  and the output for the synthesis filter bank (\code{sfb2D}) is the
  output array.

}
\references{
  WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY\cr
  \url{http://eeweb.poly.edu/iselesni/WaveletSoftware/}
}
%\seealso{}
\examples{
## EXAMPLE: afb, sfb
af = farras()$af
sf = farras()$sf
x = rnorm(64)
x.afb = afb(x, af)
lo = x.afb$lo
hi = x.afb$hi
y = sfb(lo, hi, sf)
err = x - y
max(abs(err))

## EXAMPLE: afb2D, sfb2D
x = matrix(rnorm(32*64), 32, 64)
af = farras()$af
sf = farras()$sf
x.afb2D = afb2D(x, af, af)
lo = x.afb2D$lo
hi = x.afb2D$hi
y = sfb2D(lo, hi, sf, sf)
err = x - y
max(abs(err))

## Example: afb2D.A, sfb2D.A
x = matrix(rnorm(32*64), 32, 64)
af = farras()$af
sf = farras()$sf
x.afb2D.A = afb2D.A(x, af, 1)
lo = x.afb2D.A$lo
hi = x.afb2D.A$hi
y = sfb2D.A(lo, hi, sf, 1)
err = x - y
max(abs(err))
}
\author{Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{acvs.andel8}
\alias{acvs.andel8}
\alias{acvs.andel9}
\alias{acvs.andel10}
\alias{acvs.andel11}
\title{Autocovariance and Autocorrelation Sequences for a Seasonal Persistent
Process}
\format{
A data frame with 4096 rows and three columns: lag, autocovariance
sequence, autocorrelation sequence.
}
\usage{
data(acvs.andel8)

data(acvs.andel9)

data(acvs.andel10)

data(acvs.andel11)
}
\description{
The autocovariance and autocorrelation sequences from the time series model
in Figures 8, 9, 10, and 11 of Andel (1986).  They were obtained through
numeric integration of the spectral density function.
}
\references{
Andel, J. (1986) Long memory time series models,
\emph{Kypernetika}, \bold{22}, No. 2, 105-123.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{heavisine}
\alias{heavisine}
\title{Sine with Jumps at 0.3 and 0.72}
\format{
A vector containing 512 observations.
}
\source{
S+WAVELETS.
}
\usage{
data(heavisine)
}
\description{
\deqn{heavisine(x) = 4\sin(4{\pi}x) - \mathrm{sign}(x-0.3) - }{%
heavisine(x) = 4*sin(4*pi*x) - sign(x-0.3) - sign(0.72-x)}\deqn{
\mathrm{sign}(0.72-x)}{% heavisine(x) = 4*sin(4*pi*x) - sign(x-0.3) -
sign(0.72-x)}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

\name{Farras}
\alias{farras}
\alias{FSfarras}
\title{Farras nearly symmetric filters}
\description{
  Farras nearly symmetric filters for orthogonal 2-channel perfect
  reconstruction filter bank and Farras filters organized for the
  dual-tree complex DWT.
}
\usage{
farras()
FSfarras()
}
\arguments{
  None.
}
\value{
  \item{af}{List (\eqn{i=1,2}) - analysis filters for tree \eqn{i}}
  \item{sf}{List (\eqn{i=1,2}) - synthesis filters for tree \eqn{i}}
}
%\details{}
\references{
  A. F. Abdelnour and I. W. Selesnick. \dQuote{Nearly symmetric
    orthogonal wavelet bases}, Proc. IEEE Int. Conf. Acoust., Speech,
  Signal Processing (ICASSP), May 2001.

  WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY\cr
  \url{http://eeweb.poly.edu/iselesni/WaveletSoftware/}
}
\seealso{
  \code{\link{afb}}, \code{\link{dualtree}}, \code{\link{dualfilt1}}.
}
%\examples{}
\author{Matlab: S. Cai, K. Li and I. Selesnick; R port: Brandon Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{blocks}
\alias{blocks}
\title{A Piecewise-Constant Function}
\format{
A vector containing 512 observations.
}
\source{
S+WAVELETS.
}
\usage{
data(blocks)
}
\description{
\deqn{blocks(x) = \sum_{j=1}^{11}(1 + {\rm sign}(x-p_j)) h_j / 2}{%
blocks(x) = sum[j=1,11] (1 + sign(x - p_j)) h_j/2}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hilbert.R
\name{dwt.hilbert}
\alias{dwt.hilbert}
\alias{dwt.hilbert.nondyadic}
\alias{idwt.hilbert}
\alias{modwt.hilbert}
\alias{imodwt.hilbert}
\alias{modwpt.hilbert}
\title{Discrete Hilbert Wavelet Transforms}
\usage{
dwt.hilbert(x, wf, n.levels = 4, boundary = "periodic", ...)

dwt.hilbert.nondyadic(x, ...)

idwt.hilbert(y)

modwt.hilbert(x, wf, n.levels = 4, boundary = "periodic", ...)

imodwt.hilbert(y)

modwpt.hilbert(x, wf, n.levels = 4, boundary = "periodic")
}
\arguments{
\item{x}{Real-valued time series or vector of observations.}

\item{wf}{Hilbert wavelet pair}

\item{n.levels}{Number of levels (depth) of the wavelet transform.}

\item{boundary}{Boundary treatment, currently only \code{periodic} and
\code{reflection}.}

\item{\ldots}{Additional parametes to be passed on.}

\item{y}{An object of S3 class \code{dwt.hilbert}.}
}
\value{
Hilbert wavelet transform object (list).
}
\description{
The discrete Hilbert wavelet transforms (DHWTs) for seasonal and
time-varying time series analysis.  Transforms include the usual orthogonal
(decimated), maximal-overlap (non-decimated) and maximal-overlap packet
transforms.
}
\references{
Selesnick, I. (200X). \emph{IEEE Signal Processing Magazine}

Selesnick, I. (200X). \emph{IEEE Transactions in Signal Processing}

Whither, B. and P.F. Craigmile (2004). Multivariate Spectral Analysis Using
Hilbert Wavelet Pairs, \emph{International Journal of Wavelets,
Multiresolution and Information Processing}, \bold{2}(4), 567--587.
}
\seealso{
\code{\link{hilbert.filter}}
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{jumpsine}
\alias{jumpsine}
\title{Sine with Jumps at 0.625 and 0.875}
\format{
A vector containing 512 observations.
}
\source{
S+WAVELETS.
}
\usage{
data(jumpsine)
}
\description{
\deqn{jumpsine(x) = 10\left( \sin(4{\pi}x) +
I_{[0.625 < x \leq 0.875]}\right)}{%
jumpsine(x) = 10*(sin(4*pi*x) + I_[0.625 < x <= 0.875])}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ar1}
\alias{ar1}
\title{Simulated AR(1) Series}
\format{
A vector containing 200 observations.
}
\usage{
data(ar1)
}
\description{
Simulated AR(1) series used in Gencay, Selcuk and Whitcher (2001).
}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/three_D.R
\name{dwt.3d}
\alias{dwt.3d}
\alias{idwt.3d}
\title{Three Dimensional Separable Discrete Wavelet Transform}
\usage{
dwt.3d(x, wf, J = 4, boundary = "periodic")

idwt.3d(y)
}
\arguments{
\item{x}{input array}

\item{wf}{name of the wavelet filter to use in the decomposition}

\item{J}{depth of the decomposition, must be a number less than or equal to
log(minZ,Y,Z,2)}

\item{boundary}{only \code{"periodic"} is currently implemented}

\item{y}{an object of class \code{dwt.3d}}
}
\description{
Three-dimensional separable discrete wavelet transform (DWT).
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cov.R
\name{wave.variance}
\alias{wave.variance}
\alias{wave.covariance}
\alias{wave.correlation}
\title{Wavelet Analysis of Univariate/Bivariate Time Series}
\usage{
wave.variance(x, type = "eta3", p = 0.025)

wave.covariance(x, y)

wave.correlation(x, y, N, p = 0.975)
}
\arguments{
\item{x}{first time series}

\item{type}{character string describing confidence interval calculation;
valid methods are \code{gaussian}, \code{eta1}, \code{eta2}, \code{eta3},
\code{nongaussian}}

\item{p}{(one minus the) two-sided p-value for the confidence interval}

\item{y}{second time series}

\item{N}{length of time series}
}
\value{
Matrix with as many rows as levels in the wavelet transform object.
The first column provides the point estimate for the wavelet variance,
covariance, or correlation followed by the lower and upper bounds from the
confidence interval.
}
\description{
Produces an estimate of the multiscale variance, covariance or correlation
along with approximate confidence intervals.
}
\details{
The time-independent wavelet variance is basically the average of the
squared wavelet coefficients across each scale.  As shown in Percival
(1995), the wavelet variance is a scale-by-scale decomposition of the
variance for a stationary process, and certain non-stationary processes.
}
\examples{

## Figure 7.3 from Gencay, Selcuk and Whitcher (2001)
data(ar1)
ar1.modwt <- modwt(ar1, "haar", 6)
ar1.modwt.bw <- brick.wall(ar1.modwt, "haar")
ar1.modwt.var2 <- wave.variance(ar1.modwt.bw, type="gaussian")
ar1.modwt.var <- wave.variance(ar1.modwt.bw, type="nongaussian")
par(mfrow=c(1,1), las=1, mar=c(5,4,4,2)+.1)
matplot(2^(0:5), ar1.modwt.var2[-7,], type="b", log="xy",
        xaxt="n", ylim=c(.025, 6), pch="*LU", lty=1, col=c(1,4,4),
        xlab="Wavelet Scale", ylab="")
matlines(2^(0:5), as.matrix(ar1.modwt.var)[-7,2:3], type="b",
         pch="LU", lty=1, col=3)
axis(side=1, at=2^(0:5))
legend(1, 6, c("Wavelet variance", "Gaussian CI", "Non-Gaussian CI"),
       lty=1, col=c(1,4,3), bty="n")

## Figure 7.8 from Gencay, Selcuk and Whitcher (2001)
data(exchange)
returns <- diff(log(as.matrix(exchange)))
returns <- ts(returns, start=1970, freq=12)
wf <- "d4"
J <- 6
demusd.modwt <- modwt(returns[,"DEM.USD"], wf, J)
demusd.modwt.bw <- brick.wall(demusd.modwt, wf)
jpyusd.modwt <- modwt(returns[,"JPY.USD"], wf, J)
jpyusd.modwt.bw <- brick.wall(jpyusd.modwt, wf)
returns.modwt.cov <- wave.covariance(demusd.modwt.bw, jpyusd.modwt.bw)
par(mfrow=c(1,1), las=0, mar=c(5,4,4,2)+.1)
matplot(2^(0:(J-1)), returns.modwt.cov[-(J+1),], type="b", log="x",
        pch="*LU", xaxt="n", lty=1, col=c(1,4,4), xlab="Wavelet Scale", 
        ylab="Wavelet Covariance")
axis(side=1, at=2^(0:7))
abline(h=0)

returns.modwt.cor <- wave.correlation(demusd.modwt.bw, jpyusd.modwt.bw,
                                      N = dim(returns)[1])
par(mfrow=c(1,1), las=0, mar=c(5,4,4,2)+.1)
matplot(2^(0:(J-1)), returns.modwt.cor[-(J+1),], type="b", log="x",
        pch="*LU", xaxt="n", lty=1, col=c(1,4,4), xlab="Wavelet Scale", 
        ylab="Wavelet Correlation")
axis(side=1, at=2^(0:7))
abline(h=0)

}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Percival, D. B. (1995) \emph{Biometrika}, \bold{82}, No. 3, 619-631.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.

Whitcher, B., P. Guttorp and D. B. Percival (2000) Wavelet Analysis of
Covariance with Application to Atmospheric Time Series, \emph{Journal of
Geophysical Research}, \bold{105}, No. D11, 14,941-14,962.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stack.plot.R
\name{stackPlot}
\alias{stackPlot}
\title{Stack Plot}
\usage{
stackPlot(
  x,
  plot.type = c("multiple", "single"),
  panel = lines,
  log = "",
  col = par("col"),
  bg = NA,
  pch = par("pch"),
  cex = par("cex"),
  lty = par("lty"),
  lwd = par("lwd"),
  ann = par("ann"),
  xlab = "Time",
  main = NULL,
  oma = c(6, 0, 5, 0),
  layout = NULL,
  same.scale = 1:dim(x)[2],
  ...
)
}
\arguments{
\item{x}{\code{ts} object}

\item{plot.type, panel, log, col, bg, pch, cex, lty, lwd, ann, xlab, main, oma, ...}{See
\code{plot.ts}.}

\item{layout}{Doublet defining the dimension of the panel.  If not
specified, the dimensions are chosen automatically.}

\item{same.scale}{Vector the same length as the number of series to be
plotted.  If not specified, all panels will have unique axes.}
}
\description{
Stack plot of an object.  This function attempts to mimic a function called
\code{stack.plot} in S+WAVELETS.
}
\details{
Produces a set of plots, one for each element (column) of \code{x}.
}
\author{
B. Whitcher
}
\keyword{hplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/up.sample.R
\name{up.sample}
\alias{up.sample}
\title{Upsampling of a vector}
\usage{
up.sample(x, f, y = NA)
}
\arguments{
\item{x}{vector of observations}

\item{f}{frequency of upsampling; e.g, 2, 4, etc.}

\item{y}{value to upsample with; e.g., NA, 0, etc.}
}
\value{
A vector twice its length.
}
\description{
Upsamples a given vector.
}
\references{
Any basic signal processing text.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cplxdual2D.R
\name{cplxdual2D}
\alias{cplxdual2D}
\alias{icplxdual2D}
\title{Dual-tree Complex 2D Discrete Wavelet Transform}
\usage{
cplxdual2D(x, J, Faf, af)

icplxdual2D(w, J, Fsf, sf)
}
\arguments{
\item{x}{2D array.}

\item{J}{number of stages.}

\item{Faf}{first stage analysis filters for tree i.}

\item{af}{analysis filters for the remaining stages on tree i.}

\item{w}{wavelet coefficients.}

\item{Fsf}{last stage synthesis filters for tree i.}

\item{sf}{synthesis filters for the preceeding stages.}
}
\value{
For the analysis of \code{x}, the output is \item{w}{wavelet
coefficients indexed by \code{[[j]][[i]][[d1]][[d2]]}, where
\eqn{j=1,\ldots,J} (scale), \eqn{i=1} (real part) or \eqn{i=2} (imag part),
\eqn{d1=1,2} and \eqn{d2=1,2,3} (orientations).} For the synthesis of
\code{w}, the output is \item{y}{output signal.}
}
\description{
Dual-tree complex 2D discrete wavelet transform (DWT).
}
\examples{

\dontrun{
## EXAMPLE: cplxdual2D
x = matrix(rnorm(32*32), 32, 32)
J = 5
Faf = FSfarras()$af
Fsf = FSfarras()$sf
af = dualfilt1()$af
sf = dualfilt1()$sf
w = cplxdual2D(x, J, Faf, af)
y = icplxdual2D(w, J, Fsf, sf)
err = x - y
max(abs(err))
}

}
\seealso{
\code{\link{FSfarras}}, \code{\link{farras}}, \code{\link{afb2D}},
\code{\link{sfb2D}}.
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

\name{Selesnick}
\alias{cshift}
\alias{cshift2D}
\alias{pm}
\title{Miscellaneous Functions for Dual-Tree Wavelet Software}
\description{
  Miscellaneous functions for dual-tree wavelet software.
}
\usage{
cshift(x, m)
cshift2D(x, m)
pm(a, b)
}
\arguments{
  \item{x}{\eqn{N}-point vector}
  \item{m}{amount of shift}
  \item{a,b}{input parameters}
}
\value{
  \item{y}{vector \eqn{x} will be shifed by \eqn{m} samples to the left
    or matrix \eqn{x} will be shifed by \eqn{m} samples down.}
  \item{u}{\eqn{(a + b)/sqrt(2)}}
  \item{v}{\eqn{(a - b)/sqrt(2)}}
}
%\details{}
\references{
  WAVELET SOFTWARE AT POLYTECHNIC UNIVERSITY, BROOKLYN, NY\cr
  \url{http://eeweb.poly.edu/iselesni/WaveletSoftware/}
}
%\seealso{}
%\examples{}
\author{Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{xbox}
\alias{xbox}
\title{Image with Box and X}
\format{
A 128 \eqn{\times}{x} 128 matrix.
}
\source{
S+WAVELETS.
}
\usage{
data(xbox)
}
\description{
\deqn{xbox(i,j) = I_{[i=n/4,\;3n/4,\;j;~ n/4 \leq j \leq 3n/4]} + }{%
xbox(i,j) = I_[i = n/4, 3n/4, j; n/4 \leq j \leq 3n/4] + I_[n/4 \leq i \leq
3n/4; j = n/4, 3n/4, i]}\deqn{ I_{[n/4 \leq i \leq 3n/4;~
j=n/4,\;3n/4,\;i]}}{% xbox(i,j) = I_[i = n/4, 3n/4, j; n/4 \leq j \leq 3n/4]
+ I_[n/4 \leq i \leq 3n/4; j = n/4, 3n/4, i]}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

\name{Hilbert}
\alias{dwt.hilbert}
\alias{dwt.hilbert.nondyadic}
\alias{idwt.hilbert}
\alias{modwt.hilbert}
\alias{imodwt.hilbert}
\alias{modwpt.hilbert}
\title{Discrete Hilbert Wavelet Transforms}
\description{
  The discrete Hilbert wavelet transforms (DHWTs) for seasonal and 
  time-varying time series analysis.  Transforms include the usual
  orthogonal (decimated), maximal-overlap (non-decimated) and
  maximal-overlap packet transforms.
}
\usage{
dwt.hilbert(x, wf, n.levels=4, boundary="periodic", ...)
dwt.hilbert.nondyadic(x, ...)
idwt.hilbert(y)
modwt.hilbert(x, wf, n.levels=4, boundary="periodic", ...)
imodwt.hilbert(y)
modwpt.hilbert(x, wf, n.levels=4, boundary="periodic")
}
\arguments{
  \item{x}{Real-valued time series or vector of observations.}
  \item{wf}{Hilbert wavelet pair}
  \item{n.levels}{Number of levels (depth) of the wavelet transform.}
  \item{boundary}{Boundary treatment, currently only \code{periodic} and
    \code{reflection}.}
  \item{y}{Hilbert wavelet transform object (list).}
  \item{\ldots}{Additional parametes to be passed on.}
}
%\value{}
%\details{}
\references{
  Selesnick, I. (200X). \emph{IEEE Signal Processing Magazine}

  Selesnick, I. (200X). \emph{IEEE Transactions in Signal Processing}

  Whither, B. and P.F. Craigmile (2004).  Multivariate Spectral Analysis 
  Using Hilbert Wavelet Pairs, \emph{International Journal of Wavelets, 
  Multiresolution and Information Processing}, to appear.
}
\seealso{
  \code{\link{hilbert.filter}}
}
%\examples{}
\author{B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dualtree.R
\name{FSfarras}
\alias{FSfarras}
\alias{farras}
\title{Farras nearly symmetric filters}
\usage{
FSfarras()
}
\value{
\item{af}{List (i=1,2) - analysis filters for tree i} \item{sf}{List
(i=1,2) - synthesis filters for tree i}
}
\description{
Farras nearly symmetric filters for orthogonal 2-channel perfect
reconstruction filter bank and Farras filters organized for the dual-tree
complex DWT.
}
\references{
A. F. Abdelnour and I. W. Selesnick. \dQuote{Nearly symmetric
orthogonal wavelet bases}, Proc. IEEE Int. Conf. Acoust., Speech, Signal
Processing (ICASSP), May 2001.
}
\seealso{
\code{\link{afb}}, \code{\link{dualtree}}, \code{\link{dualfilt1}}.
}
\author{
Matlab: S. Cai, K. Li and I. Selesnick; R port: B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{linchirp}
\alias{linchirp}
\title{Linear Chirp}
\format{
A vector containing 512 observations.
}
\source{
S+WAVELETS.
}
\usage{
data(linchirp)
}
\description{
\deqn{linchirp(x) = \sin(0.125 \pi n x^2)}{% 
linchirp(x) = sin(0.125*pi*n*x^2)}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sdf.R
\name{spp.var}
\alias{spp.var}
\alias{Hypergeometric}
\title{Variance of a Seasonal Persistent Process}
\usage{
spp.var(d, fG, sigma2 = 1)

Hypergeometric(a, b, c, z)
}
\arguments{
\item{d}{Fractional difference parameter.}

\item{fG}{Gegenbauer frequency.}

\item{sigma2}{Innovations variance.}

\item{a, b, c, z}{Parameters for the hypergeometric series.}
}
\value{
The variance of an SP process.
}
\description{
Computes the variance of a seasonal persistent (SP) process using a
hypergeometric series expansion.
}
\details{
See Lapsa (1997).  The subroutine to compute a hypergeometric series was
taken from \emph{Numerical Recipes in C}.
}
\references{
Lapsa, P.M. (1997) Determination of Gegenbauer-type random
process models.  \emph{Signal Processing} \bold{63}, 73-90.

Press, W.H., S.A. Teukolsky, W.T. Vetterling and B.P. Flannery (1992)
\emph{Numerical Recipes in C}, 2nd edition, Cambridge University Press.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwt.R
\name{mra}
\alias{mra}
\title{Multiresolution Analysis of Time Series}
\usage{
mra(x, wf = "la8", J = 4, method = "modwt", boundary = "periodic")
}
\arguments{
\item{x}{A vector or time series containing the data be to decomposed.  This
must be a dyadic length vector (power of 2) for \code{method="dwt"}.}

\item{wf}{Name of the wavelet filter to use in the decomposition.  By
default this is set to \code{"la8"}, the Daubechies orthonormal compactly
supported wavelet of length L=8 least asymmetric family.}

\item{J}{Specifies the depth of the decomposition.  This must be a number
less than or equal to log(length(x), 2).}

\item{method}{Either \code{"dwt"} or \code{"modwt"}.}

\item{boundary}{Character string specifying the boundary condition.  If
\code{boundary=="periodic"} the default, then the vector you decompose is
assumed to be periodic on its defined interval,\cr if
\code{boundary=="reflection"}, the vector beyond its boundaries is assumed
to be a symmetric reflection of itself.}
}
\value{
Basically, a list with the following components \item{D?}{Wavelet
detail vectors.} \item{S?}{Wavelet smooth vector.} \item{wavelet}{Name of
the wavelet filter used.} \item{boundary}{How the boundaries were handled.}
}
\description{
This function performs a level \eqn{J} additive decomposition of the input
vector or time series using the pyramid algorithm (Mallat 1989).
}
\details{
This code implements a one-dimensional multiresolution analysis introduced
by Mallat (1989).  Either the DWT or MODWT may be used to compute the
multiresolution analysis, which is an additive decomposition of the original
time series.
}
\examples{

## Easy check to see if it works...
x <- rnorm(32)
x.mra <- mra(x)
sum(x - apply(matrix(unlist(x.mra), nrow=32), 1, sum))^2

## Figure 4.19 in Gencay, Selcuk and Whitcher (2001)
data(ibm)     
ibm.returns <- diff(log(ibm))
ibm.volatility <- abs(ibm.returns)
## Haar
ibmv.haar <- mra(ibm.volatility, "haar", 4, "dwt")
names(ibmv.haar) <- c("d1", "d2", "d3", "d4", "s4")
## LA(8)
ibmv.la8 <- mra(ibm.volatility, "la8", 4, "dwt")
names(ibmv.la8) <- c("d1", "d2", "d3", "d4", "s4")
## plot multiresolution analysis of IBM data
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.volatility, axes=FALSE, ylab="", main="(a)")
for(i in 1:5)
  plot.ts(ibmv.haar[[i]], axes=FALSE, ylab=names(ibmv.haar)[i])
axis(side=1, at=seq(0,368,by=23), 
  labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))
par(mfcol=c(6,1), pty="m", mar=c(5-2,4,4-2,2))
plot.ts(ibm.volatility, axes=FALSE, ylab="", main="(b)")
for(i in 1:5)
  plot.ts(ibmv.la8[[i]], axes=FALSE, ylab=names(ibmv.la8)[i])
axis(side=1, at=seq(0,368,by=23), 
  labels=c(0,"",46,"",92,"",138,"",184,"",230,"",276,"",322,"",368))

}
\references{
Gencay, R., F. Selcuk and B. Whitcher (2001) \emph{An
Introduction to Wavelets and Other Filtering Methods in Finance and
Economics}, Academic Press.

Mallat, S. G. (1989) A theory for multiresolution signal decomposition: the
wavelet representation, \emph{IEEE Transactions on Pattern Analysis and
Machine Intelligence}, \bold{11}, No. 7, 674-693.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\seealso{
\code{\link{dwt}}, \code{\link{modwt}}.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/two_D.R
\name{denoise.dwt.2d}
\alias{denoise.dwt.2d}
\alias{denoise.modwt.2d}
\title{Denoise an Image via the 2D Discrete Wavelet Transform}
\usage{
denoise.dwt.2d(
  x,
  wf = "la8",
  J = 4,
  method = "universal",
  H = 0.5,
  noise.dir = 3,
  rule = "hard"
)
}
\arguments{
\item{x}{input matrix (image)}

\item{wf}{name of the wavelet filter to use in the decomposition}

\item{J}{depth of the decomposition, must be a number less than or equal to
log(minM,N,2)}

\item{method}{character string describing the threshold applied, only
\code{"universal"} and \code{"long-memory"} are currently implemented}

\item{H}{self-similarity or Hurst parameter to indicate spectral scaling,
white noise is 0.5}

\item{noise.dir}{number of directions to estimate background noise standard
deviation, the default is 3 which produces a unique estimate of the
background noise for each spatial direction}

\item{rule}{either a \code{"hard"} or \code{"soft"} thresholding rule may be
used}
}
\value{
Image of the same dimension as the original but with high-freqency
fluctuations removed.
}
\description{
Perform simple de-noising of an image using the two-dimensional discrete
wavelet transform.
}
\details{
See \code{\link{Thresholding}}.
}
\examples{

## Xbox image
data(xbox)
n <- nrow(xbox)
xbox.noise <- xbox + matrix(rnorm(n*n, sd=.15), n, n)
par(mfrow=c(2,2), cex=.8, pty="s")
image(xbox.noise, col=rainbow(128), main="Original Image")
image(denoise.dwt.2d(xbox.noise, wf="haar"), col=rainbow(128),
      zlim=range(xbox.noise), main="Denoised image")
image(xbox.noise - denoise.dwt.2d(xbox.noise, wf="haar"), col=rainbow(128),
      zlim=range(xbox.noise), main="Residual image")

## Daubechies image
data(dau)
n <- nrow(dau)
dau.noise <- dau + matrix(rnorm(n*n, sd=10), n, n)
par(mfrow=c(2,2), cex=.8, pty="s")
image(dau.noise, col=rainbow(128), main="Original Image")
dau.denoise <- denoise.modwt.2d(dau.noise, wf="d4", rule="soft")
image(dau.denoise, col=rainbow(128), zlim=range(dau.noise),
      main="Denoised image")
image(dau.noise - dau.denoise, col=rainbow(128), main="Residual image")

}
\references{
See \code{\link{Thresholding}} for references concerning
de-noising in one dimension.
}
\seealso{
\code{\link{Thresholding}}
}
\author{
B. Whitcher
}
\keyword{ts}

\name{Thresholding}
\alias{Thresholding}
\alias{da.thresh}
\alias{hybrid.thresh}
\alias{manual.thresh}
\alias{sure.thresh}
\alias{universal.thresh}
\alias{universal.thresh.modwt}
\alias{bishrink}
\alias{soft}
\title{Wavelet Shrinkage via Thresholding}
\description{
  Perform wavelet shrinkage using data-analytic, hybrid SURE, manual,
  SURE, or universal thresholding.
}
\usage{
da.thresh(wc, alpha = .05, max.level = 4, verbose = FALSE, return.thresh = FALSE)
hybrid.thresh(wc, max.level = 4, verbose = FALSE, seed = 0)
manual.thresh(wc, max.level = 4, value, hard = TRUE)
sure.thresh(wc, max.level = 4, hard = TRUE)
universal.thresh(wc, max.level = 4, hard = TRUE)
universal.thresh.modwt(wc, max.level = 4, hard = TRUE)
}
\arguments{
  \item{wc}{wavelet coefficients}
  \item{alpha}{level of the hypothesis tests}
  \item{max.level}{maximum level of coefficients to be affected by threshold}
  \item{verbose}{if \code{verbose=TRUE} then information is printed to
    the screen} 
  \item{value}{threshold value (only utilized in \code{manual.thresh})}
  \item{hard}{Boolean value, if \code{hard=F} then soft thresholding is used}
  \item{seed}{sets random seed (only utilized in \code{hybrid.thresh})}
  \item{return.thresh}{if \code{return.thresh=TRUE} then the vector of
    threshold values is returned, otherwise the surviving wavelet
    coefficients are returned}
}
\value{
  The default output is a list structure, the same length as was input,
  containing only those wavelet coefficients surviving the threshold.
}
\details{
  An extensive amount of literature has been written on wavelet
  shrinkage.  The functions here represent the most basic approaches to
  the problem of nonparametric function estimation.  See the references
  for further information.
}
\references{
  Gencay, R., F. Selcuk and B. Whitcher (2001)
  \emph{An Introduction to Wavelets and Other Filtering Methods in
    Finance and Economics},
  Academic Press.

  Ogden, R. T. (1996)
  \emph{Essential Wavelets for Statistical Applications and Data
    Analysis},
  Birkhauser.

  Percival, D. B. and A. T. Walden (2000)
  \emph{Wavelet Methods for Time Series Analysis},
  Cambridge University Press.

  Vidakovic, B. (1999)
  \emph{Statistical Modeling by Wavelets},
  John Wiley \& Sons.
}
%\seealso{}
%\examples{}
\author{B. Whitcher (some code taken from R. Todd Ogden)}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hosking.R
\name{hosking.sim}
\alias{hosking.sim}
\title{Generate Stationary Gaussian Process Using Hosking's Method}
\usage{
hosking.sim(n, acvs)
}
\arguments{
\item{n}{Length of series.}

\item{acvs}{Autocovariance sequence of series with which to generate, must
be of length at least \code{n}.}
}
\value{
Length \code{n} time series from true autocovariance sequence
\code{acvs}.
}
\description{
Uses exact time-domain method from Hosking (1984) to generate a simulated
time series from a specified autocovariance sequence.
}
\examples{

dB <- function(x) 10 * log10(x)
per <- function (z) {
  n <- length(z)
  (Mod(fft(z))^2/(2 * pi * n))[1:(n\%/\%2 + 1)]
}
spp.sdf <- function(freq, delta, omega)
  abs(2 * (cos(2*pi*freq) - cos(2*pi*omega)))^(-2*delta)
data(acvs.andel8)
n <- 1024
\dontrun{
z <- hosking.sim(n, acvs.andel8[,2])
per.z <- 2 * pi * per(z)
par(mfrow=c(2,1), las=1)
plot.ts(z, ylab="", main="Realization of a Seasonal Long-Memory Process")
plot(0:(n/2)/n, dB(per.z), type="l", xlab="Frequency", ylab="dB",
     main="Periodogram")
lines(0:(n/2)/n, dB(spp.sdf(0:(n/2)/n, .4, 1/12)), col=2)
}

}
\references{
Hosking, J. R. M. (1984) Modeling persistence in hydrological
time series using fractional differencing, \emph{Water Resources Research},
\bold{20}, No. 12, 1898-1908.

Percival, D. B. (1992) Simulating Gaussian random processes with specified
spectra, \emph{Computing Science and Statistics}, \bold{22}, 534-538.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{doppler}
\alias{doppler}
\title{Sinusoid with Changing Amplitude and Frequency}
\format{
A vector containing 512 observations.
}
\source{
S+WAVELETS.
}
\usage{
data(doppler)
}
\description{
\deqn{doppler(x) = \sqrt{x(1 - x)} }{% doppler(x) = sqrt{x(1-x)}
sin[(2.1*pi)/(x+0.05)]}\deqn{ \sin\left(\frac{2.1\pi}{x+0.05}\right)}{%
doppler(x) = sqrt{x(1-x)} sin[(2.1*pi)/(x+0.05)]}
}
\references{
Bruce, A., and H.-Y. Gao (1996) \emph{Applied Wavelet Analysis
with S-PLUS}, Springer: New York.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt.R
\name{basis}
\alias{basis}
\title{Produce Boolean Vector from Wavelet Basis Names}
\usage{
basis(x, basis.names)
}
\arguments{
\item{x}{Output from the discrete wavelet package transfrom (DWPT).}

\item{basis.names}{Vector of character strings that describe leaves on the
DWPT basis tree.  See the examples below for appropriate syntax.}
}
\value{
Vector of zeros and ones.
}
\description{
Produce a vector of zeros and ones from a vector of basis names.
}
\details{
None.
}
\examples{

data(acvs.andel8)
\dontrun{
x <- hosking.sim(1024, acvs.andel8[,2])
x.dwpt <- dwpt(x, "la8", 7)
## Select orthonormal basis from wavelet packet tree
x.basis <- basis(x.dwpt, c("w1.1","w2.1","w3.0","w4.3","w5.4","w6.10",
                           "w7.22","w7.23"))
for(i in 1:length(x.dwpt))
  x.dwpt[[i]] <- x.basis[i] * x.dwpt[[i]]
## Resonstruct original series using selected orthonormal basis
y <- idwpt(x.dwpt, x.basis)
par(mfrow=c(2,1), mar=c(5-1,4,4-1,2))
plot.ts(x, xlab="", ylab="", main="Original Series")
plot.ts(y, xlab="", ylab="", main="Reconstructed Series")
}

}
\seealso{
\code{\link{dwpt}}.
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwt.R
\name{brick.wall}
\alias{brick.wall}
\alias{dwpt.brick.wall}
\alias{brick.wall.2d}
\title{Replace Boundary Wavelet Coefficients with Missing Values}
\usage{
brick.wall(x, wf, method = "modwt")

dwpt.brick.wall(x, wf, n.levels, method = "modwpt")

brick.wall.2d(x, method = "modwt")
}
\arguments{
\item{x}{DWT/MODWT/DWPT/MODWPT object}

\item{wf}{Character string; name of wavelet filter}

\item{method}{Either \code{\link{dwt}} or \code{\link{modwt}} for
\code{brick.wall}, or either \code{\link{dwpt}} or \code{\link{modwpt}} for
\code{dwpt.brick.wall}}

\item{n.levels}{Specifies the depth of the decomposition. This must be a
number less than or equal to log(length(x),2).}
}
\value{
Same object as \code{x} only with some missing values.
}
\description{
Sets the first \eqn{n} wavelet coefficients to \code{NA}.
}
\details{
The fact that observed time series are finite causes boundary issues.  One
way to get around this is to simply remove any wavelet coefficient computed
involving the boundary.  This is done here by replacing boundary wavelet
coefficients with \code{NA}.
}
\references{
Lindsay, R. W., D. B. Percival and D. A. Rothrock (1996). The
discrete wavelet transform and the scale anlaysis of the surface properties
of sea ice, \emph{IEEE Transactions on Geoscience and Remote Sensing},
\bold{34}, No. 3, 771-787.

Percival, D. B. and A. T. Walden (2000) \emph{Wavelet Methods for Time
Series Analysis}, Cambridge University Press.
}
\author{
B. Whitcher
}
\keyword{ts}

\name{wpt.test}
\alias{cpgram.test}
\alias{css.test}
\alias{entropy.test}
\alias{portmanteau.test}
\title{Testing the Wavelet Packet Tree for White Noise}
\description{
  A wavelet packet tree, from the discrete wavelet packet transform
  (DWPT), is tested node-by-node for white noise.  This is the first
  step in selecting an orthonormal basis for the DWPT.
}
\usage{cpgram.test(y, p = 0.05, taper = 0.1)
css.test(y)
entropy.test(y)
portmanteau.test(y, p = 0.05, type = "Box-Pierce")
}
\arguments{
  \item{y}{wavelet packet tree (from the DWPT)}
  \item{p}{significance level}
  \item{taper}{weight of cosine bell taper (\code{cpgram.test} only)}
  \item{type}{\code{"Box-Pierce"} and \code{other} recognized
    (\code{portmanteau.test} only)}
}
\value{
  Boolean vector of the same length as the number of nodes in the
  wavelet packet tree.
}
\details{
  Top-down recursive testing of the wavelet packet tree is 
}
\references{
  Brockwell and Davis (1991)
  \emph{Time Series: Theory and Methods}, (2nd. edition),
  Springer-Verlag.

  Brown, Durbin and Evans (1975)
  Techniques for testing the constancy of regression relationships over
  time,
  \emph{Journal of the Royal Statistical Society B}, \bold{37}, 149-163.

  Percival, D. B., and A. T. Walden (1993)
  \emph{Spectral Analysis for Physical Applications: Multitaper and
    Conventional Univariate Techniques},
  Cambridge University Press.
}
\seealso{
  \code{\link{ortho.basis}}.
}
\examples{
data(mexm)
J <- 6
wf <- "la8"
mexm.dwpt <- dwpt(mexm[-(1:4)], wf, J)
## Not implemented yet
## plot.dwpt(x.dwpt, J)
mexm.dwpt.bw <- dwpt.brick.wall(mexm.dwpt, wf, 6, method="dwpt")
mexm.tree <- ortho.basis(portmanteau.test(mexm.dwpt.bw, p=0.025))
## Not implemented yet
## plot.basis(mexm.tree)
}
\author{B. Whitcher}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dwpt_sim.R
\name{bandpass.var.spp}
\alias{bandpass.var.spp}
\alias{bandpass.fdp}
\alias{bandpass.spp}
\alias{bandpass.spp2}
\title{Bandpass Variance for Long-Memory Processes}
\usage{
bandpass.fdp(a, b, d)

bandpass.spp(a, b, d, fG)

bandpass.spp2(a, b, d1, f1, d2, f2)

bandpass.var.spp(delta, fG, J, Basis, Length)
}
\arguments{
\item{fG, f1, f2}{Gegenbauer frequency.}

\item{J}{Depth of the wavelet transform.}

\item{Basis}{Logical vector representing the adaptive basis.}

\item{Length}{Number of elements in Basis.}

\item{a}{Left-hand boundary for the definite integral.}

\item{b}{Right-hand boundary for the definite integral.}

\item{d, delta, d1, d2}{Fractional difference parameter.}
}
\value{
Band-pass variance for the FD or SP process between \eqn{a} and
\eqn{b}.
}
\description{
Computes the band-pass variance for fractional difference (FD) or seasonal
persistent (SP) processes using numeric integration of their spectral
density function.
}
\details{
See references.
}
\references{
McCoy, E. J., and A. T. Walden (1996) Wavelet analysis and
synthesis of stationary long-memory processes, \emph{Journal for
Computational and Graphical Statistics}, \bold{5}, No. 1, 26-56.

Whitcher, B. (2001) Simulating Gaussian stationary processes with unbounded
spectra, \emph{Journal for Computational and Graphical Statistics},
\bold{10}, No. 1, 112-134.
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/three_D.R
\name{modwt.3d}
\alias{modwt.3d}
\alias{imodwt.3d}
\title{Three Dimensional Separable Maximal Ovelrap Discrete Wavelet Transform}
\usage{
modwt.3d(x, wf, J = 4, boundary = "periodic")

imodwt.3d(y)
}
\arguments{
\item{x}{input array}

\item{wf}{name of the wavelet filter to use in the decomposition}

\item{J}{depth of the decomposition}

\item{boundary}{only \code{"periodic"} is currently implemented}

\item{y}{an object of class \code{modwt.3d}}
}
\description{
Three-dimensional separable maximal overlap discrete wavelet transform
(MODWT).
}
\author{
B. Whitcher
}
\keyword{ts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/two_D.R
\name{modwt.2d}
\alias{modwt.2d}
\alias{imodwt.2d}
\title{Two-Dimensional Maximal Overlap Discrete Wavelet Transform}
\usage{
modwt.2d(x, wf, J = 4, boundary = "periodic")

imodwt.2d(y)
}
\arguments{
\item{x}{input matrix}

\item{wf}{name of the wavelet filter to use in the decomposition}

\item{J}{depth of the decomposition}

\item{boundary}{only \code{"periodic"} is currently implemented}

\item{y}{an object of class \code{dwt.2d}}
}
\value{
List structure containing the \eqn{3J+1} sub-matrices from the
decomposition.
}
\description{
Performs a separable two-dimensional maximal overlap discrete wavelet
transform (MODWT) on a matrix of arbitrary dimensions.
}
\details{
See references.
}
\examples{

## Xbox image
data(xbox)
xbox.modwt <- modwt.2d(xbox, "haar", 2)
## Level 1 decomposition
par(mfrow=c(2,2), pty="s")
image(xbox.modwt$LH1, col=rainbow(128), axes=FALSE, main="LH1")
image(xbox.modwt$HH1, col=rainbow(128), axes=FALSE, main="HH1")
frame()
image(xbox.modwt$HL1, col=rainbow(128), axes=FALSE, main="HL1")
## Level 2 decomposition
par(mfrow=c(2,2), pty="s")
image(xbox.modwt$LH2, col=rainbow(128), axes=FALSE, main="LH2")
image(xbox.modwt$HH2, col=rainbow(128), axes=FALSE, main="HH2")
image(xbox.modwt$LL2, col=rainbow(128), axes=FALSE, main="LL2")
image(xbox.modwt$HL2, col=rainbow(128), axes=FALSE, main="HL2")
sum((xbox - imodwt.2d(xbox.modwt))^2)

data(dau)
par(mfrow=c(1,1), pty="s")
image(dau, col=rainbow(128), axes=FALSE, main="Ingrid Daubechies")
sum(dau^2)
dau.modwt <- modwt.2d(dau, "d4", 2)
## Level 1 decomposition
par(mfrow=c(2,2), pty="s")
image(dau.modwt$LH1, col=rainbow(128), axes=FALSE, main="LH1")
image(dau.modwt$HH1, col=rainbow(128), axes=FALSE, main="HH1")
frame()
image(dau.modwt$HL1, col=rainbow(128), axes=FALSE, main="HL1")
## Level 2 decomposition
par(mfrow=c(2,2), pty="s")
image(dau.modwt$LH2, col=rainbow(128), axes=FALSE, main="LH2")
image(dau.modwt$HH2, col=rainbow(128), axes=FALSE, main="HH2")
image(dau.modwt$LL2, col=rainbow(128), axes=FALSE, main="LL2")
image(dau.modwt$HL2, col=rainbow(128), axes=FALSE, main="HL2")
sum((dau - imodwt.2d(dau.modwt))^2)

}
\references{
Liang, J. and T. W. Parks (1994) A two-dimensional translation
invariant wavelet representation and its applications, \emph{Proceedings
ICIP-94}, Vol. 1, 66-70.

Liang, J. and T. W. Parks (1994) Image coding using translation invariant
wavelet transforms with symmetric extensions, \emph{IEEE Transactions on
Image Processing}, \bold{7}, No. 5, 762-769.
}
\seealso{
\code{\link{dwt.2d}}, \code{\link{shift.2d}}.
}
\author{
B. Whitcher
}
\keyword{ts}
